﻿/*
Copyright (c) 2003-2012, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

CKEDITOR.editorConfig = function( config )
{
    // Define changes to default configuration here. For example:
    // config.language = 'fr';
    // config.uiColor = '#AADC6E';
    
    // All menus that can be used with CMS Designer. ( Basically, 'forms' and 'document' menus are deleted. )
    var CMSD_Full =
    [
        { name: 'document',     items : [ 'Source' ] },
        { name: 'clipboard',    items : [ 'Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo' ] },
        { name: 'editing',      items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
        { name: 'basicstyles',  items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
        { name: 'paragraph',    items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock' ] },
        '/',
        { name: 'links',        items : [ 'Link','Unlink','Anchor' ] },
        { name: 'insert',       items : [ 'Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe' ] },
        { name: 'styles',       items : [ 'Styles','Format','Font','FontSize' ] },
        { name: 'colors',       items : [ 'TextColor','BGColor' ] },
        { name: 'tools',        items : [ 'Maximize', 'ShowBlocks','-','About' ] }
    ];
    
    // Basic menus with CMS Designer. 
    var CMSD_Basic =
    [
        { name: 'document',     items : [ 'Source' ] },
        { name: 'clipboard',    items : [ 'Cut','Copy','Paste','PasteText','-','Undo','Redo','-','Find','Replace' ] },
        { name: 'basicstyles',  items : [ 'Bold','Italic','Underline','Strike','-','RemoveFormat' ] },
        { name: 'paragraph',    items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock' ] },
        { name: 'links',        items : [ 'Link','Unlink','Anchor' ] },
        '/',
        { name: 'styles',       items : [ 'Format','Font','FontSize' ] },
        { name: 'colors',       items : [ 'TextColor','BGColor' ] },
        { name: 'tools',        items : [ 'Maximize', 'ShowBlocks','-','About' ] }
    ];
    
    // Simple menus with CMS Designer. 
    var CMSD_Simple =
    [
        { name: 'clipboard',    items : [ 'Cut','Copy','Paste','PasteText','-','Undo','Redo' ] },
        { name: 'basicstyles',  items : [ 'Bold','Italic','Underline','Strike','-','RemoveFormat' ] },
        { name: 'paragraph',    items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock' ] },
        { name: 'links',        items : [ 'Link','Unlink' ] },
        { name: 'styles',       items : [ 'Format', 'FontSize' ] },
        { name: 'colors',       items : [ 'TextColor','BGColor' ] },
        { name: 'tools',        items : [ 'About' ] }
    ];
    
    // All menus in CKeditor. 
    var CKeditor_Full =
    [
        { name: 'document',     items : [ 'Source','-','Save','NewPage','DocProps','Preview','Print','-','Templates' ] },
        { name: 'clipboard',    items : [ 'Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo' ] },
        { name: 'editing',      items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
        { name: 'forms',        items : [ 'Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField' ] },
        '/',
        { name: 'basicstyles',  items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
        { name: 'paragraph',    items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiLtr','BidiRtl' ] },
        { name: 'links',        items : [ 'Link','Unlink','Anchor' ] },
        { name: 'insert',       items : [ 'Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe' ] },
        '/',
        { name: 'styles',       items : [ 'Styles','Format','Font','FontSize' ] },
        { name: 'colors',       items : [ 'TextColor','BGColor' ] },
        { name: 'tools',        items : [ 'Maximize', 'ShowBlocks','-','About' ] }
    ];
    
    // Setting the toolbar for CMS Designer.
    CKEDITOR.config.toolbar = CMSD_Basic; // You can change here to CMSD_Basic or CMSD_Simple.
};
