<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );
    require_once( dirname(__FILE__) . "/cmsdconfig.php.inc" );	// 2006.08.11 ɲ

    /* --------------------------------------------------------------------
     * Ϲܥ饹
     * 
     */ 
    class FileEntryItem extends BaseEntryItem
    {
		var $altEnabled = false;
		var $maxFileSize = 0;
		
		var $resizeWidth = 0;			// åץɻβꥵ
		var $resizeHeight = 0;		// åץɻβꥵ⤵
		//var $smallWidth = 0;	// ̾ư
		//var $smallHeight = 0;	// ̾ưι⤵
		
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function FileEntryItem( $xmlSchemaData, $entryName, $entryId )
    	{
    		// ١󥹥ȥ饯θƤӽФ
    		parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId );
    		
			// ALT°桼Ϥ뤫
			$altEnabled = $xmlSchemaData->get_attribute('alt');
			if ( $altEnabled == 'True')
			{
				$this->altEnabled = true;
			}
			
			// åץɻβꥵ⤵
			$this->resizeWidth = parseNumeric( $xmlSchemaData->get_attribute('width'), 0 );
			$this->resizeHeight = parseNumeric( $xmlSchemaData->get_attribute('height'), 0 );
			
			/*
			// ̾ư⤵
			$this->smallWidth = parseNumeric( $xmlSchemaData->get_attribute('smallwidth'), 0 );
			$this->smallHeight = parseNumeric( $xmlSchemaData->get_attribute('smallheight'), 0 );
			*/
			
			// ե륵ξ¡
			$maxFileSize = unit2byte( $xmlSchemaData->get_attribute('maxfilesize') );
            
            if ( !empty( $maxFileSize ) && is_numeric( $maxFileSize ) )
            {
                $this->maxFileSize = $maxFileSize;
            }
            
			
    	}
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			$newNode = parent::createNew( $xmlDocParentEntry );
   			
   			switch ( $this->dataType )
   			{
   				case 'img' :
					$newNode->set_attribute( 'filetype', 'image' );
					$newNode->set_attribute( 'alt', '' );
					$newNode->set_attribute( 'org', '' );
					$newNode->set_attribute( 'filesize', '0' );
					$newNode->set_attribute( 'state', 'new' );
					break;
				
				case 'file' : 
					$newNode->set_attribute( 'filetype', 'file' );
					$newNode->set_attribute( 'org', '' );
					$newNode->set_attribute( 'filesize', '0' );
					$newNode->set_attribute( 'state', 'new' );
					break;
				
			}

   			// fileidϤǤϷǤʤ١ƤӽФ¦ꤹ뤳ȡ
    		
    		return $newNode;
    	}
    	
    	
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
    		// ȥXML
            $xmlEntryDataList = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataList->nodeset[0];

			switch ( $this->dataType )
			{
			case 'img' :
				if ( isset( $_POST[ $this->dataName . '_DEL' ] ) )
				{
					// åܥåդƤ顢state'deleted'ˤ롣save˼ºݤ˺
					$xmlEntryData->set_attribute('state', 'deleted' );
				}
				else
				{
					// ALT°ϡñΤǹǽʤΤ˹롣
					$alt = getPOSTParam( $this->dataName . '_ALT' );//  $_POST[ $this->dataName . '_ALT' ];
					if ( isset( $_POST[ $this->dataName . '_ALT' ] ) )
					{
						$xmlEntryData->set_attribute('alt', fileconv( $alt ) );
					}
					
					$org = $_FILES[ $this->dataName ][ 'name' ];
					
					if ( strlen( $org ) <= 0 )
					{
						// ե뤬ꤵƤʤв⤷ʤ
						break;
					}
					
					$filesize = $_FILES[ $this->dataName ][ 'size' ];
					$temp = $_FILES[ $this->dataName ][ 'tmp_name' ];
					$imageSizeResult = getimagesize( $temp );
					$imgtype = $imageSizeResult[2];
					$width = $imageSizeResult[0];
					$height = $imageSizeResult[1];
					
					// ե륵ꤵƤ顢ǥå롣
					if ( $this->maxFileSize > 0 )
					{
						if ( $this->maxFileSize < $filesize )
						{
							$this->errorMessage = 'ե륵(' . byte2unit( $this->maxFileSize ) . ')Ķޤ';
							return false;
						}
					}
					
					// ⤷ե뤬ǤʤХ顼ɽƲ⤷ʤ
					if ( $imgtype != '' )	// ʳξ硢imgtypeˤ϶ʸ롣
					{
						$fileid = $xmlEntryData->get_attribute('fileid');
						$srcFileName = App::createAttachedFileName( $this->entryName, $this->entryId, $fileid, $org );
						
						// °򹹿
						$xmlEntryData->set_attribute('width', $width );
						$xmlEntryData->set_attribute('height', $height );
						$xmlEntryData->set_attribute('filesize', $filesize );
						$xmlEntryData->set_attribute('org', fileconv($org) );
						$xmlEntryData->set_attribute('src', $srcFileName );
						
						// ƥȥΡɤȤơURLꤹ롣
						$imgurl = App::createImageUrl( $this->entryName, $this->entryId, $fileid, $org ); //'cmsdesigner/viewimg.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid. '&/' . rawurlencode( $org );
						EntryUtil::deleteTextNode( $xmlEntryData );
						$xmlEntryData->set_content( fileconv( $imgurl ) );
					
						// 񤭹ξ硢state'updated'ˤ롣newξϤΤޤޤˤ롣
						if ( $xmlEntryData->get_attribute('state') != 'new' )
						{
							$xmlEntryData->set_attribute('state', 'updated' );
						}
						
						// 򥨥ȥե˰¸롣¸̾ fileid . '.' . org . '.' . 'tmp'¸롣
						///  ) 12345678.filename1.jpg.tmp
						/// ϡȥIDĤѥե̤˺ƴäsafemode¤mkdirưǰ
						$imageDirPath = App::createEntryDirPath( $this->entryName );// . $this->entryName . '.' . $this->entryId . '.images';
						/*
						if ( !file_exists( $imageDirPath ) )
						{
							$oldmask = umask(0);
							mkdir( $imageDirPath, 0777 );
							umask($oldmask);
						}
						*/
						
						// ե̤̾ѡ
						$imagefilepath = $imageDirPath . $srcFileName . '.tmp';
							
						if ( move_uploaded_file( $temp, $imagefilepath ) )
						{
							// ФˤäƤϥեͭapache0600ˤʤäƤޤ礬ꡢFTPGETǤʤΤǡǥѡߥåǤ0644ꤹ롣
							chmod( $imagefilepath, 0644 ); 
						}
						
						// ꥵ꤬äꥵ¸ʤʸꥵ夬ʤΤߡ
						if ( ( $this->resizeWidth != 0 and $this->resizeWidth < $width ) or ( $this->resizeHeight != 0 and $this->resizeHeight < $height ) )
						//if ( $this->resizeWidth != 0 or $this->resizeHeight != 0 )
						{
							$adimage = new ADImage();
							$adimage->loadFromFile( $imagefilepath );
							
							$newadimage = $adimage->createResizedImage( $this->resizeWidth, $this->resizeHeight );
							$adimage->destroy();
							
							$newadimage->saveToFile( $imagefilepath, $imgtype );
							
							// °ι
							$xmlEntryData->set_attribute('width', $newadimage->getWidth() );
							$xmlEntryData->set_attribute('height', $newadimage->getHeight() );
							$xmlEntryData->set_attribute('filesize', filesize( $imagefilepath ) );
							
							$newadimage->destroy();
							
						}
						
						/*
						// ꤬̾ä̾¸롣硢礹롣
						if ( $this->smallWidth != 0 or $this->smallHeight )
						{
							$adimage = new ADImage();
							$adimage->loadFromFile( $imagefilepath );
							
							$newadimage = $adimage->createResizedImage( $this->smallWidth, $this->smallHeight );
							$adimage->destroy();
							
							// ̾Υե̾ ex) entryname1.00001.small.jpg.tmp
							$smallImageFileName = App::createAttachedFileName( $this->entryName, $this->entryId, $fileid . '.small', $org );
							$smallImageFilePath = $imageDirPath . $srcFileName . '.tmp';
							$newadimage->saveToFile( $smallImageFilePath, $imgtype );
							chmod( $smallImageFilePath, 0644 );
							
							// °ι
							$xmlEntryData->set_attribute('smallimage', 'True' );
							$xmlEntryData->set_attribute('smallwidth', $newadimage->getWidth() );
							$xmlEntryData->set_attribute('smallheight', $newadimage->getHeight() );
							
							$newadimage->destroy();
						}
						*/
					
					}
					else
					{
						$this->errorMessage = 'ΥեϲեǤϤޤ';
						return false;
					}
				}
				
				break;
				
			case 'file' : 
				if ( isset( $_POST[ $this->dataName . '_DEL' ] ) )
				{
					// print "image file deleted!<br>\n";
					
					// åܥåդƤ顢state'deleted'ˤ롣save˼ºݤ˺
					$xmlEntryData->set_attribute('state', 'deleted' );
				}
				else
				{
					// print "image file update!<br>\n";
					$org = $_FILES[ $this->dataName ][ 'name' ];
					$filesize = $_FILES[ $this->dataName ][ 'size' ];
					$temp = $_FILES[ $this->dataName ][ 'tmp_name' ];
					
					// ե륵ꤵƤ顢ǥå롣
					if ( $this->maxFileSize > 0 )
					{
						if ( $this->maxFileSize < $filesize )
						{
							$this->errorMessage = 'ե륵(' . byte2unit( $this->maxFileSize ) . ')Ķޤ';
							return false;
						}
					}					
					
					// ⤷ե뤬åץɤ줿ΤǤʤХ顼ɽƲ⤷ʤ
					if ( is_uploaded_file($temp) )	
					{
						$fileid = $xmlEntryData->get_attribute('fileid');
						$srcFileName = App::createAttachedFileName( $this->entryName, $this->entryId, $fileid, $org );
						
						// °򹹿
						$xmlEntryData->set_attribute('filesize', $filesize );
						$xmlEntryData->set_attribute('org', fileconv($org) );
						$xmlEntryData->set_attribute('src', $srcFileName );
						
						// ƥȥΡɤȤơURLꤹ롣
						$fileurl = App::createFileUrl( $this->entryName, $this->entryId, $fileid, $org ); //'cmsdesigner/dlfile.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid. '&/' . rawurlencode( $org );
						EntryUtil::deleteTextNode( $xmlEntryData );
						$xmlEntryData->set_content( fileconv( $fileurl ) );
						
					
						// 񤭹ξ硢state'updated'ˤ롣newξϤΤޤޤˤ롣
						if ( $xmlEntryData->get_attribute('state') != 'new' )
						{
							$xmlEntryData->set_attribute('state', 'updated' );
						}
						
						// ե򥨥ȥե˰¸롣¸̾ fileid . '.' . org . '.' . 'tmp'¸롣
						///  ) 12345678.filename1.jpg.tmp
						/// ϡȥIDĤեѥե̤˺ƴäsafemode¤mkdirưǰ
						$imageDirPath = App::createEntryDirPath( $this->entryName );// . $this->entryName . '.' . $this->entryId . '.images';
						/*
						if ( !file_exists( $imageDirPath ) )
						{
							$oldmask = umask(0);
							mkdir( $imageDirPath, 0777 );
							umask($oldmask);
						}
						*/
                        
						if ( move_uploaded_file( $temp, $imageDirPath . $srcFileName . '.tmp' ) )
                        {
                            // ФˤäƤϥեͭapache0600ˤʤäƤޤ礬ꡢFTPGETǤʤΤǡǥѡߥåǤ0644ꤹ롣
                            chmod( $imageDirPath . $srcFileName . '.tmp', 0644 );
                        }
					}
				}
				
				break;
			
			}
    	    
    	    return true;
    	
    	}
    	
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItem( $xpathEntry, $currentEntry )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataArray->nodeset[0];
    		$value = $xmlEntryData->get_content();
    		
    		$strFormHTML = '';
    		
    		switch ( $this->dataType )
    		{
				case "img" :
					$org = $xmlEntryData->get_attribute('org');		// ե̾
					$alt = $xmlEntryData->get_attribute('alt');		// ALT°ʸ
					$state = $xmlEntryData->get_attribute('state');	// ǡ
					$fileid = $xmlEntryData->get_attribute('fileid');	// IMG-ID
					
					$imgurl = 'viewimg.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid. '&/' . rawurlencode( $org );
					
					if ( $state == 'deleted' )
					{
						// 줿 org + '()'ɽ롣
						$strFormHTML .= '<a href="' . $imgurl . '" target="_blank" >' . $org . ' (Ƥޤ)' . '</a><br>' . "\n";
					}
					else
					{
						if ( empty($org) )
						{
							// orgʤ顢̵ȤȤʤΤǡ(ʤ)פɽ롣
							$strFormHTML .= '(ʤ)';
						}
						else
						{
							// ̾ѥ
							$strFormHTML .= '<a href="' . $imgurl . '" target="_blank" >' . htmlconv($org) . '</a>';
						}
					}
					
					// alt°ѥƥȥܥåɽ
					if ( $this->altEnabled )
					{
						$strFormHTML .= '̾ <input type="text" size="40" name="' . $this->dataName . '_ALT' . '" value="' . htmlconv($alt) . '" />'; 
					}
					
					// åܥåɽ
					$strFormHTML .= '<input type="checkbox" name="' . $this->dataName . '_DEL" /><br>' . "\n";
					
					// ե륢åץɤɽ
					$strFormHTML .= 'åץɤե <input type="file" name="' . $this->dataName . '" size="50" /><br>' . "\n";
					
					break;

				case "file" : 
					$org = $xmlEntryData->get_attribute('org');		// ե̾
					$state = $xmlEntryData->get_attribute('state');	// ǡ
					$fileid = $xmlEntryData->get_attribute('fileid');	// ID
					
					$imgurl = 'dlfile.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid . '&/' . rawurlencode( $org );
					
					if ( $state == 'deleted' )
					{
						// 줿 org + '()'ɽ롣
						$strFormHTML .= '<a href="' . $imgurl . '" target="_blank" >' . $org . ' (Ƥޤ)' . '</a><br>' . "\n";
					}
					else
					{
						if ( empty($org) )
						{
							// orgʤ顢̵ȤȤʤΤǡ(ʤ)פɽ롣
							$strFormHTML .= '(եʤ)';
						}
						else
						{
							// ̾ѥ
							$strFormHTML .= '<a href="' . $imgurl . '" target="_blank" >' . htmlconv($org) . '</a>';
						}
					}
					
					// ѥåܥåɽ
					$strFormHTML .= '<input type="checkbox" name="' . $this->dataName . '_DEL" /><br>' . "\n";
					
					// ե륢åץɤɽ
					$strFormHTML .= 'åץɤե <input type="file" name="' . $this->dataName . '" size="50" /><br>' . "\n";
					
					break;

    		}
    		
    		return $strFormHTML;
    	}
		
		
		/* ----------------------------------------------------------------
		 * եܤ褹XML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataArray->nodeset[0];
    		$value = $xmlEntryData->get_content();
    		
    		$strFormHTML = '';
    		
			$xmlDocOutput = $xmlOutputEntryData->owner_document();
			
            // ե륵
			$maxFileSize = 0;	// 
            if ( $this->maxFileSize > 0 )
            {
                $maxFileSize = byte2unit( $this->maxFileSize );
            }
            
            
    		switch ( $this->dataType )
    		{
				case "img" :
					$org = $xmlEntryData->get_attribute('org');		// ե̾
					$alt = $xmlEntryData->get_attribute('alt');		// ALT°ʸ
					$state = $xmlEntryData->get_attribute('state');	// ǡ
					$fileid = $xmlEntryData->get_attribute('fileid');	// IMG-ID
					
					$imgurl = 'viewimg.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid. '&/' . rawurlencode( $org );
					
					$xmlOutputEntryData->set_attribute('org', $org );
					$xmlOutputEntryData->set_attribute('state', $state );
					$xmlOutputEntryData->set_attribute('fileid', $fileid );
					$xmlOutputEntryData->set_attribute('fileurl', $imgurl );
					if ( $this->altEnabled )
					{
						$xmlOutputEntryData->set_attribute('alt', $alt );
					}
                    
                    if ( $maxFileSize )
                    {
                        $xmlOutputEntryData->set_attribute('maxfilesize', $maxFileSize );
                    }
                    
					
					break;

				case "file" : 
					$org = $xmlEntryData->get_attribute('org');		// ե̾
					$state = $xmlEntryData->get_attribute('state');	// ǡ
					$fileid = $xmlEntryData->get_attribute('fileid');	// ID
					
					$imgurl = 'dlfile.php?entryname=' . $this->entryName . '&entryid=' . $this->entryId . '&fileid=' . $fileid . '&/' . rawurlencode( $org );
					
					$xmlOutputEntryData->set_attribute('org', $org );
					$xmlOutputEntryData->set_attribute('state', $state );
					$xmlOutputEntryData->set_attribute('fileid', $fileid );
					$xmlOutputEntryData->set_attribute('fileurl', $imgurl );
                    
                    if ( $maxFileSize )
                    {
                        $xmlOutputEntryData->set_attribute('maxfilesize', $maxFileSize );
                    }
					
					break;

    		}
    		
    		return $strFormHTML;
    	}
		
    	
    }

?>