<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    //require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );

    /* --------------------------------------------------------------------
     * Ϲܥ饹
     * 
     */ 
    class GeoLocationEntryItem extends BaseEntryItem
    {
    	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function GeoLocationEntryItem( $xmlSchemaData, $entryName, $entryId  )
    	{
    		// ١󥹥ȥ饯θƤӽФ
    		parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
    		
			/*
    		$this->max = (int)( $xmlSchemaData->get_attribute('max') ); 
    		$this->min = (int)( $xmlSchemaData->get_attribute('min') );
			*/
    		
    	}
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			$newNode = parent::createNew( $xmlDocParentEntry );
			//$newNode->set_content( '' );
    		
			$newNode->set_attribute( 'lat', '' );
			$newNode->set_attribute( 'lng', '' );
			$newNode->set_attribute( 'zoom', '' );
			
    		return $newNode;
    	}
    	
    	
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
    		// ȥXML
            $xmlEntryDataList = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataList->nodeset[0];
			
			
		    // "name"°бPOST¸ߤСȥȿǤ롣
			$lat = getPOSTParam( $this->dataName . '_LAT', '' );
			$lng = getPOSTParam( $this->dataName . '_LNG', '' );
			$zoom = getPOSTParam( $this->dataName . '_ZOOM' );
			
			// ɬܥå
			if ( ( $lat === '' or $lng === '' ) and ( $lat.$lng !== '' ) )	// latlngɤ餫ϤƤ
			{
				$this->errorMessage = sprintf("%s ٤ȷ٤ξϤɬפޤ", $this->dataCaption );
				return false;
			}
			
			if ( $lat.$lng === '' and $zoom !== '' )
			{
				$this->errorMessage = sprintf( "%s ̼ܤϤˤϰ٤ȷ٤Ϥɬפޤ", $this->dataCaption );
				return false;
			}
			
			// ͥå
			if ( $lat !== '' and !is_numeric( $lat ) )
			{
				$this->errorMessage = sprintf( "%s ٤˿ͰʳϤޤ", $this->dataCaption );
				return false;
			}
			
			if ( $lng !== '' and !is_numeric( $lng ) )
			{
				$this->errorMessage = sprintf( "%s ٤˿ͰʳϤޤ", $this->dataCaption );
				return false;
			}
			
			if ( $zoom !== '' and !is_numeric( $zoom ) )
			{
				$this->errorMessage = sprintf( "%s ̼ܤ˿ͰʳϤޤ", $this->dataCaption );
				return false;
			}
			
			$fLat = floatval( $lat );
			$fLng = floatval( $lng );
			$iZoom = intval( $zoom );
			
			// ϰϥå
			if ( $lat !== '' and ( $fLat < -90 or $fLat > 90 ) )
			{
				$this->errorMessage = sprintf( "%s ٤-90+90ϰϤĶޤ", $this->dataCaption );
				return false;
			}
			
			if ( $lng !== '' and ( $fLng < -180 or $fLng > 180 ) )
			{
				$this->errorMessage = sprintf( "%s ٤-180+180ϰϤĶޤ", $this->dataCaption );
				return false;
			}
			
			if ( $zoom !== '' and ( $iZoom < 0 or $iZoom > 19 ) )
			{
				$this->errorMessage = sprintf( "%s ̼ܤ019ϰϤĶޤ", $this->dataCaption );
				return false;
			}
			
			
			// ¸
			if ( $lat.$lng !== '' )	// Ϥä
			{
				// ޤƥȥΡɤʺʤȡset_contentǤϥƥȥΡɤˡ
				EntryUtil::deleteTextNode( $xmlEntryData );
				
				// ƥȥΡɤ˿ͤset롣
				$xmlEntryData->set_content( "($lat,$lng)" );
				
				$xmlEntryData->set_attribute( 'lat', $lat );
				$xmlEntryData->set_attribute( 'lng', $lng );
				$xmlEntryData->set_attribute( 'zoom', $zoom );
			}
    	    
    	    return true;
    	
    	}
    	
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItem( $xpathEntry, $currentEntry )
    	{
			// ߻ȤƤʤ᥽åɡ
    	}
		

		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
			$xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			$xmlEntryData = $xmlEntryDataArray->nodeset[0];
			
			$lat = $xmlEntryData->get_attribute( 'lat' );
			$lng = $xmlEntryData->get_attribute( 'lng' );
			$zoom = $xmlEntryData->get_attribute( 'zoom' );
			
			// ꥯȤͤСͤɽʥ顼ͤݾڤ褦ˤ
			$lat = getPOSTParam( $this->dataName . '_LAT', $lat );
			$lng = getPOSTParam( $this->dataName . '_LNG', $lng );
			$zoom = getPOSTParam( $this->dataName . '_ZOOM', $zoom );
			
			// ǡ
			$xmlOutputEntryData->set_attribute('lat', $lat );
			$xmlOutputEntryData->set_attribute('lng', $lng );
			$xmlOutputEntryData->set_attribute('zoom', $zoom );
    	}
    	
    }

?>