<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/version.php.inc" );
	require_once( dirname(__FILE__) . "/app.php.inc" );
	require_once( dirname(__FILE__) . "/manager.util.php.inc" );
	require_once( dirname(__FILE__) . "/manager.factory.php.inc" );
	require_once( dirname(__FILE__) . "/xmlutil.php.inc" );
	require_once( dirname(__FILE__) . "/manager.header.php.inc" );
	require_once( dirname(__FILE__) . "/cache.php.inc" );


	// ȥꥯ饹
	class CMSEntry
	{
	
		function IsEntryPublished( &$xmlEntryRoot )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", date('Y') );
			$sMonth = sprintf( "%02d", date('m') );
			$sDay = sprintf( "%02d", date('d') );
			$sHour = sprintf( "%02d", date('H') );
			$sMinute = sprintf( "%02d", date('i') );

			//$strToday = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
			$strToday = $sYear . $sMonth . $sDay . $sHour . $sMinute;
			
			// ָפġ帽彪λ ΤΤФＰ
			// ե饰䳫λ¸ߤʤäΥСȤθߴΰ٤ˡ餬̵ȥθＰˤ롣
			// XPathˤʸ羮ӤʤȽâʸξΤӲǽäΤǡ:-ʤɤ򳰤Ӥ뤳Ȥˤ
			
			$startDate = $xmlEntryRoot->get_attribute('startdate');
			$endDate = $xmlEntryRoot->get_attribute('enddate');
			$visible = $xmlEntryRoot->get_attribute('visible');
			
			// ޤvisibleʤСŤȥΰٳϤ佪λȤȤˤʤΤ̵˸
			// ˡ⤷visibleFalseʤ顢̵丽ʸˤǤ̵λ帽ʸλˤǤ⡢̵
			if ( empty( $visible ) or  ! ( $visible === 'False' or $startDate > $strToday or $endDate <= $strToday ) )	// бXPathƱˤ
			{
				return true;
			}
			else
			{
				return false;
			}
			
		}
		
		function GetEntryPublishState( &$xmlEntryRoot )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", date('Y') );
			$sMonth = sprintf( "%02d", date('m') );
			$sDay = sprintf( "%02d", date('d') );
			$sHour = sprintf( "%02d", date('H') );
			$sMinute = sprintf( "%02d", date('i') );

			//$strToday = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
			$strToday = $sYear . $sMonth . $sDay . $sHour . $sMinute;
			
			// ָפġ帽彪λ ΤΤФＰ
			// ե饰䳫λ¸ߤʤäΥСȤθߴΰ٤ˡ餬̵ȥθＰˤ롣
			// XPathˤʸ羮ӤʤȽâʸξΤӲǽäΤǡ:-ʤɤ򳰤Ӥ뤳Ȥˤ
			
			$startDate = $xmlEntryRoot->get_attribute('startdate');
			$endDate = $xmlEntryRoot->get_attribute('enddate');
			$visible = $xmlEntryRoot->get_attribute('visible');
			
			if ( empty( $visible ) )
			{
				$publishState = 'public';		// 
			}
			else if ( $visible === 'False' )
			{
				$publishState = 'private';		// 
			}
			else if ( $startDate > $strToday )
			{
				$publishState = 'not yet';		// ̤
			}
			else if ( $endDate <= $strToday )
			{
				$publishState = 'over';			// λ
			}
			else if ( $startDate === '000000000000' and $endDate === '999999999999' )
			{
				$publishState = 'public';		// 
			}
			else
			{
				$publishState = 'during';		// 
			}
			
			return $publishState;
		}
		
	
	}
	
	
	class CommonActionUtil
	{
		function XsltEntryEditor( $xmlDocOutput )
		{
			// ̶̾
			$xmlOutputRoot = $xmlDocOutput->document_element();
			
			// 桼ID
			$authedUser = LoginManager::GetAuthedUser();
			$authedUserId = $authedUser->getUserId();
			$xmlOutputRoot->set_attribute( 'autheduserid', $authedUserId );
			
			// XSLѴ
			$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			return $strFormHTML;
		}
	}

	
	class VersionInfoAction
	{
		function procRequest()
		{
			print ( $this->renderHTMLXML() );
		}
		
		function renderHTMLXML()
		{
			// HTML	
			// DOM
			// 롼ȥΡ'entryeditor'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'versioninfo' );
			$xmlOutputRoot->set_attribute( 'appname', CMSD_APP_NAME );
			$xmlOutputRoot->set_attribute( 'appversion', CMSD_APP_VERSION );
			
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			
			return $strFormHTML;
			
		}
		
	}
	
	
	class EntryNamesForEditor
	{
		function procRequest()
		{
			// site.configɤ߹߲ǽå
			if ( ! is_readable( App::getSiteConfigFilePath() ) )
			{
				cmsd_abort_proc( App::getSiteConfigFilePath() . " ¸ߤʤɤ߹ԲĤˤʤäƤޤ" );
			}
			
			// Site.Configꤵ줿ȥ롣
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			
			// XMLɤ߹ߤ
			if ( empty( $xmlDocSite ) )
			{
				cmsd_abort_proc( App::getSiteConfigFilePath() . " ɤ߹ߤ˼Ԥޤե뤬XMLǤϤʤǽޤ" );
			}
			
			$xpath = $xmlDocSite->xpath_new_context();
			
			$xmlEntryConfigList = $xpath->xpath_eval( "/site/entries/entry" );
			
			print( $this->renderHTMLXML( cmsd_get_nodeset( $xmlEntryConfigList ) ) );
			
		}
		
		function renderHTMLXML( $xmlEntryConfigList )
		{
			// HTML	
			// DOM
			// 롼ȥΡ'entryeditor'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'entrynames' );
			
			foreach( $xmlEntryConfigList as $xmlEntryConfig )
			{
				// Ƽ泌ȥեμ
				$entryname = $xmlEntryConfig->get_attribute( 'name' );
				$entrytype = $xmlEntryConfig->get_attribute( 'type' );
				$entrycaption = file2code( $xmlEntryConfig->get_attribute( 'caption' ) );
				$entrydescription = file2code( $xmlEntryConfig->get_attribute( 'description' ) );
				
				// EntryConfig饹
				$entryConfig = new CMSEntryConfig( $xmlEntryConfig );
				$user = LoginManager::GetAuthedUser();
				
				// 桼ȥեɽ¤äƤСɽоݤ˲ä롣[2008.04 桼]
				if ( $entryConfig->canShowInContentList( $user ) )
				{
					// Entryν
					$xmlOutputEntry = $xmlDocOutput->create_element('entryname');
	
					if ( strlen( $entrytype) > 0 )
					{
						$xmlOutputEntry->set_attribute('entrytype', $entrytype );
					}
					else
					{
						$xmlOutputEntry->set_attribute('entrytype', 'entryfolder' );	// ά"entryfolder"Ȥ롣
					}
					
					if ( strlen( $entrycaption ) > 0 )
					{
						$xmlOutputEntry->set_attribute('entrycaption', fileconv( $entrycaption ) );
					}
					if ( strlen( $entrydescription ) > 0 )
					{
						$xmlOutputEntry->set_attribute('entrydescription', fileconv( $entrydescription ) );
					}
					$xmlOutputEntry->set_attribute('entryname', $entryname );
					$xmlOutputRoot->append_child( $xmlOutputEntry );
				}
			}
			
			// HTMLλ
			
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			
			/*
			$xslt = domxml_xslt_stylesheet_file( dirname(__FILE__) . "/entryeditor.xsl" );
			$result = $xslt->process( $xmlDocOutput );
			$strFormHTML = $result->dump_mem( false, 'EUC-JP' );
			*/
			
			// ʸԶ򥳡ɡ2006.07.06 ɲ
			$strFormHTML = replaceMetaTag( $strFormHTML, 'utf-8', 'euc-jp' );
			
			return $strFormHTML;
			
		}
	}
	
	
	class EntriesForEditor
	{
		var $entryName = "";	// ȥ̾
		var $pageNo = 1;	// ڡֹ
		var $maxPageRows = 15;	// ڡɽ
		
		var $entryConfig = null;
		
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 */		
		function EntriesForEditor( $entryName )
		{
			$this->entryName = $entryName;
			
			// Խ̤äƤβȿ
			$this->maxPageRows = getGETParam( 'maxpagerows', 15 );
			$this->pageNo = getGETParam( 'pageno', 1 );
			
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $entryName );
			
			$this->entryConfig = $entryConfig;
		}
		
		/* ----------------------------------------------------------------
		 * ꥯȤνƤӽФ᥽åɡ
		 */		
		function procRequest()
		{
			// ƤӽФʤactionԤʤ
			if ( ! isset( $_GET['p'] ) )
			{
				// ȽꡧɤǤʤΤߡƼԤ
				if ( ! ReloadToken::isReload() )
				{
					switch ( getPOSTParam( 'action' ) )
					{
						case 'delete' :
							$itemlist = getPOSTParam(  'items' );
							EntriesForEditor::deleteItems( $this->entryName, $itemlist );
							break;
						
						case 'page' :
							$newPageNo = getPOSTParam( 'pageno' );
							$this->pageNo = $newPageNo;
							break;
						
						case 'rows' :

							$newMaxPageRows = getPOSTParam( 'maxpagerows' );
							$newPageNo = (int) ceil( ((($this->pageNo - 1) * $this->maxPageRows) + 1) / $newMaxPageRows );
							$this->pageNo = $newPageNo;
							$this->maxPageRows = $newMaxPageRows;
							break;
					}
				}
			}
			
			/*
			// Site.Configꤵ줿ȥ롣
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			$xpath = $xmlDocSite->xpath_new_context();
			
			$xmlEntryConfig = $xpath->xpath_eval( "/site/entries/entry[@name='" . $this->entryName . "']" );
			// 2005.7.7 ɵ
			if ( count($xmlEntryConfig->nodeset) <= 0 )
			{
				cmsd_abort_proc( "site.config.xmlե'{$this->entryName}'Υȥޤ" );
			}
			//$entryCatpion = htmlconv( $xmlEntryConfigList->nodeset[0]->get_attribute('caption') );
			$entryCatpion = $xmlEntryConfig->nodeset[0]->get_attribute('caption');	// ȥ
			$schemaName = $xmlEntryConfig->nodeset[0]->get_attribute('schema');		// ̾
			// 2005.7.7 ɲ
			if ( $schemaName == '' )
			{
				cmsd_abort_proc( "site.config.xmlե'{$this->entryName}'Υȥschema°ꤵƤޤ" );
			}
			*/
			
			// indexե뤬̵硢Ƕindexե롣
			if ( ! file_exists( App::createEntryFilePath( $this->entryName, 'index' ) ) )
			{
				// ȥե񤭹߲ǽå롣
				$dirpath = App::createEntryDirPath( $this->entryName );
				if ( ! is_writable( $dirpath ) )
				{
					// 񤭹ԲĤΥ顼åϤƽλ롣
					cmsd_abort_proc( "ȥե'$dirpath'񤭹ޤ󡣥եΥѡߥå707777˰ʾˤʤäƤ뤫ǧƤ" );
				}
				
				// DOM
				$xmlDocEntryIndex = domxml_new_doc( '1.0' );
			
				// 롼ȥΡ'entry'
				$xmlDocEntryIndex->add_root( 'entrylist' );
				
				$xmlDocEntryIndex->dump_file( App::createEntryFilePath( $this->entryName, 'index' ), false, true );
				
			}

			// ȥindexXMLɤ߹ࡣ
			$xmlDocEntryIndex = domxml_open_file( App::createEntryFilePath( $this->entryName, 'index' ) );
			$xpath = $xmlDocEntryIndex->xpath_new_context();
			
			/*
			// ڡء
			$startEntryPos = ( $this->pageNo - 1 ) * $this->maxPageRows + 1;
			$endEntryPos = $this->pageNo * $this->maxPageRows;
			$pageCond = "";
			*/
			
			// 桼¤ˤꡢɽϰϤڤؤ[2008.04 桼]
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
			$authedUser = LoginManager::GetAuthedUser();
			$authedUserId = $authedUser->getUserId();
			
			$mineOk = $entryConfig->canAction( $authedUser, 'list', 'mine' );		// ʬΥȥɽǽ
			$othersOk = $entryConfig->canAction( $authedUser, 'list', 'others' );	// ¾ͤΥȥɽǽ
			
			if ( $mineOk && $othersOk )
			{
				// ƤΥȥɽ
				$xmlEntryList = $xpath->xpath_eval( "/entrylist/entry" );
			}
			elseif ( $mineOk && !$othersOk )
			{
				// ʬΥȥΤɽ
				$xmlEntryList = $xpath->xpath_eval( "/entrylist/entry[@author='$authedUserId']" );
			}
			elseif( !$mineOk && $othersOk )
			{
				// ¾ͤΥȥΤɽ
				$xmlEntryList = $xpath->xpath_eval( "/entrylist/entry[@author!='$authedUserId' or not(@author)]" );
			}
			
			// ȥIDꤵƤ硢륨ȥIDޤڡֹõ
			$targetEntryId = getGETParam( 'entryid' );
			if ( strlen( $targetEntryId ) > 0 )
			{
				$targetEntryPosition = 0;
				foreach ( cmsd_get_nodeset( $xmlEntryList ) as $entryIndex=>$xmlEntry )
				{
					$entryId = $xmlEntry->get_attribute( 'id' );
					if ( $entryId === $targetEntryId )
					{
						$targetEntryPosition = $entryIndex + 1;
						break;
					}
				}
				
				if ( $targetEntryPosition > 0 )
				{
					$this->pageNo = (int) ceil( $targetEntryPosition / $this->maxPageRows );
				}
			}
			
			// ɥȡ򿷤ȯԤ롣
			ReloadToken::newToken();
			
			// ߤƤɽԤ
			print( $this->renderHTMLXML( cmsd_get_nodeset( $xmlEntryList ) ) );	
			
		}
		
				
		/* ----------------------------------------------------------------
		 * [饹᥽å]
		 * ꤷȥID롣
		 * $entryName : ȥ̾
		 * $itemlist : ȥID
		 */
		function DeleteItems( $entryName, $itemlist )
		{
			if ( ! empty( $itemlist ) )
			{
				$xmlDocEntryIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
				$xpathEntryIndex = $xmlDocEntryIndex->xpath_new_context();
				
				// ¥åʼºݤ˺Ԥ˰öå[2008.04 桼]
				$siteConfig = new CMSSiteConfig();
				$entryConfig = $siteConfig->getEntryConfig( $entryName );
				$authedUser = LoginManager::GetAuthedUser();
				$authedUserId = $authedUser->getUserId();
				
				$deleteMineOk = $entryConfig->canAction( $authedUser, 'delete', 'mine' );
				$deleteOthersOk = $entryConfig->canAction( $authedUser, 'delete', 'others' );
				
				foreach ( $itemlist as $deleteitem )
				{
					// Index鳺ȥξ
					$xmlEntryRefArr = $xpathEntryIndex->xpath_eval( "/entrylist/entry[@href='" . App::createEntryFileName( $entryName, $deleteitem ) . "']" );
					
					if ( count( cmsd_get_nodeset( $xmlEntryRefArr ) ) > 0 ) 
					{
						// Index˻ꥨȥ꤬¸ߤʤ顢¥åԤ
						$xmlEntryRef = $xmlEntryRefArr->nodeset[0];
						$author = $xmlEntryRef->get_attribute('author');
						
						if ( ( ( $authedUserId === $author ) && ! $deleteMineOk ) ||
							 ( ( $authedUserId !== $author ) && ! $deleteOthersOk ) )
						{
							cmsd_abort_proc( "No permisson to delete the entry : $entryName - $deleteitem." );
						}
						
					}
					
				}
				
				// ºݤκ
				foreach ( $itemlist as $deleteitem )
				{
					// оݥȥ꤬¸ߤΤ߽¹Ԥ롣
					if ( file_exists( App::createEntryFilePath( $entryName, $deleteitem ) ) )
					{
					
						// Index롣
						$xmlEntryRefArr = $xpathEntryIndex->xpath_eval( "/entrylist/entry[@href='" . App::createEntryFileName( $entryName, $deleteitem ) . "']" );
						
						if ( count( cmsd_get_nodeset( $xmlEntryRefArr ) ) > 0 ) 
						{
							// Index˻ꥨȥ꤬¸ߤʤ顢Ԥ
							$xmlEntryRefArr->nodeset[0]->unlink_node();
						}
								
						// ȥե롣
						unlink( App::createEntryFilePath( $entryName, $deleteitem ) );
						
						// ȥ˴Ϣե뷲롣
						$deletefiles = glob( App::createEntryDirPath( $entryName ) . $entryName . '.' . $deleteitem . '.*' );
						if ( $deletefiles )
						{
							foreach ( $deletefiles as $filepath )
							{
								unlink( $filepath );
							}
						}
					}
				}
				
				ADDom::SaveXmlToFile( $xmlDocEntryIndex, App::createEntryFilePath( $entryName, 'index' ), 'UTF-8' );
				//$xmlDocEntryIndex->dump_file( App::createEntryFilePath( $entryName, 'index' ), false, true );
				
				// åեκ 2009.01.30 ɲ j.shinde
				ADPageCache::deleteAllCaches();

			}
		}
		
		/* ----------------------------------------------------------------
		 * ̤衣XMLǲ̾XSLTȤä̤Ϥ롣
		 */
		function renderHTMLXML( $xmlEntryList )
		{
		
			// ޥե뤬¸ߤ뤫ޤɤ߹߲ǽå롣
			$schemaFilePath = App::createSchemaFilePath( $this->entryConfig->schemaName );
			if ( ! is_readable( $schemaFilePath ) )
			{
				cmsd_abort_proc( "ޥե '$schemaFilePath' ¸ߤʤɤ߹ԲĤˤʤäƤޤ" );
			}

			// ޤ֥ȥ긫ФפȤư̾롣
			$xmlDocSchema = domxml_open_file( $schemaFilePath );
			
			// XMLɤ߹ߤ
			if ( empty( $xmlDocSchema ) )
			{
				cmsd_abort_proc( "ޥե '$schemaFilePath' ɤ߹ߤ˼Ԥޤե뤬XMLǤϤʤǽޤ" );
			}
			
			// θФѹ̾
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$titleDataNameList = $xpathSchema->xpath_eval( "/schema/@title" );
			$titleDataName = '';	// 
			if ( is_object($titleDataNameList) && !is_null($titleDataNameList->nodeset) )
			{
				$titleDataName = $titleDataNameList->nodeset[0]->get_content();
			}
			// - Фѹ̾ꤵƤʤ硢Ƭܤ򸫽ФѹܤȤ롣
			if ( strlen( $titleDataName ) <= 0 )
			{
				$xmlSchemaItemArr = $xpathSchema->xpath_eval( "/schema/data[@type!='separator'][1]" );	// 2006.2.8 ѹ ѥ졼ɲб
				$titleDataName = $xmlSchemaItemArr->nodeset[0]->get_attribute('name');
			}
			
			// ڡѤξ
			$maxPageRows = $this->maxPageRows;
			$pageNo = $this->pageNo;
			$startEntryPos = ( $pageNo - 1 ) * $maxPageRows;
			$endEntryPos = $pageNo * $maxPageRows - 1;
			$allEntryCount = count( $xmlEntryList ); 
			$endPageNo = (int) ceil( $allEntryCount / $maxPageRows ); //(int)( (int)$allEntryCount / (int)$maxPageRows ) + (( ($allEntryCount % $maxPageRows > 0 )) ? 1 : 0 );
			
			// 桼¤ˤꡢܥ󡢺?ܥåɽˤ[2008.04 桼]
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
			$authedUser = LoginManager::GetAuthedUser();
			$authedUserId = $authedUser->getUserId();
			
			$addOk = $entryConfig->canAction( $authedUser, 'add', 'mine' );					// ʬΥȥ򿷵ɲòǽ
			$deleteMineOk = $entryConfig->canAction( $authedUser, 'delete', 'mine' );		// ¾ͤΥȥǽ
			$deleteOthersOk = $entryConfig->canAction( $authedUser, 'delete', 'others' );	// ¾ͤΥȥǽ
			$editMineOk = $entryConfig->canAction( $authedUser, 'edit', 'mine' );			// ¾ͤΥȥԽǽ
			$editOthersOk = $entryConfig->canAction( $authedUser, 'edit', 'others' );		// ¾ͤΥȥԽǽ
			
			// HTML	
			// DOM
			// 롼ȥΡ'entryeditor'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'entries' );
			$xmlOutputRoot->set_attribute('entrycaption', fileconv( $this->entryConfig->caption ) );
			$xmlOutputRoot->set_attribute('entryname', $this->entryName );
			$xmlOutputRoot->set_attribute('publishcontrol', $this->entryConfig->publishControl );
			
			// ȥɽURLꤵƤ顢Ϥ롣
			if ( ! empty($this->entryConfig->listPageUrl) )
			{
				$xmlOutputRoot->set_attribute('listpageurl', $this->entryConfig->listPageUrl );
			}
			
			// ɲø¤äƤ뤫ɤ[2008.04 桼]
			if ( $addOk )
			{
				$xmlOutputRoot->set_attribute( 'addok', 'yes' );	// ̵ξ°̵
			}
			
			// indexե뤫ƥե̾եDOM򳫤ɽ롣
			foreach( $xmlEntryList as $entryIndex=>$xmlEntryRef )
			{
				// ߤΥڡʤнϤ
				if ( $entryIndex >= $startEntryPos and $entryIndex <= $endEntryPos )
				{
				
					// ȥΥ롼Ǥͤ
					$filename = $xmlEntryRef->get_attribute( 'href' );
					$xmlDocEntry = domxml_open_file( App::createEntryDirPath( $this->entryName ) . $filename );
					$xmlEntry = $xmlDocEntry->document_element();
					$xpathEntry = $xmlDocEntry->xpath_new_context();
				
					$id = $xmlEntry->get_attribute('id');
					$date = $xmlEntry->get_attribute('date');
					//$visible = $xmlEntry->get_attribute('visible') ? '' : '';
					$author = $xmlEntry->get_attribute( 'author' );
					
					
					// Ф롣Ф̾ʣꤵƤ⤢Τǡ","splitƥ롼פ󤹡
					$title = "";
					$titleDataNameArr = explode( ",", $titleDataName );
					foreach ( $titleDataNameArr as $dataName )
					{
						// ιܤ򥨥ȥ꤫롣
						$xmlEntryChildList = $xpathEntry->xpath_eval("/entry/" . $dataName );
						if ( cmsd_get_nodeset( $xmlEntryChildList ) )
						{
							if ( strlen( $title ) > 0 ){
								$title .= " | ";
							}
							
							$xmlSchemaItemArr = $xpathSchema->xpath_eval( "/schema/data[@name='{$dataName}']" );
							$dataType = $xmlSchemaItemArr->nodeset[0]->get_attribute('type');
							
							switch ( $dataType )
							{
								// եξ硢ե̾ɽ
								case 'img':
								case 'file':
								
									$title .= file2code( $xmlEntryChildList->nodeset[0]->get_attribute('org') );
									break;
								
								// ˥塼ξ硢襭ץɽ
								case 'menu':
									$menuId = $xmlEntryChildList->nodeset[0]->get_content();
									$xmlSchemaMenuItemArr = $xpathSchema->xpath_eval( "/schema/data[@name='{$dataName}']/menuitem[@id='{$menuId}']" );
									
									if ( !empty($xmlSchemaMenuItemArr->nodeset) )
									{
										$title .= file2code( $xmlSchemaMenuItemArr->nodeset[0]->get_content() );
									}
									else
									{
										$title .= "()";
									}
									
									break;
								
								// ʳƤ򤽤Τޤ
								default:
									$title .=  file2code( $xmlEntryChildList->nodeset[0]->get_content() );
									break;
							}
							
						}
					}
					if ( mb_strlen( $title ) > 50 )
					{
						$title = mb_substr( $title, 0, 50 ) . ".."; // Ƭ50ʸʬФ
					}
					
					/*
					// ȥ긫Ф̾ޤ˻ꤵƤ뤫
					if ( $titleDataName )
					{
						// ꤵƤСιܤ򥨥ȥ꤫롣
						$xmlEntryChildList = $xpathEntry->xpath_eval("/entry/" . $titleDataName );
					}
					else
					{
						// ȥ긫Ф̾ޤ˻ꤵƤʤС
						// ȥκǽλǤtext()ơפȤ롣
						$xmlEntryChildList = $xpathEntry->xpath_eval("/entry/*");
					}
					
					// ǤͤФƬ鲿ʸʬФ
					if ( $xmlEntryChildList->nodeset )
					{
						$xmlEntryChild = $xmlEntryChildList->nodeset[0];
						$title = file2code( $xmlEntryChild->get_content() );
						if ( mb_strlen( $title ) > 50 )
						{
							$title = mb_substr( $title, 0, 50 ) . "..";	// Ƭ50ʸʬФ
						}
					}
					*/
					
					// 롣
					$publishState = CMSEntry::GetEntryPublishState( $xmlEntry );
					if ( $this->entryConfig->publishControl === 'none' )
					{
						$publishState = 'showall';
					}
				
					// DOM˥ȥ꣱ʬξ񤭽Ф
					$xmlOutputEntry = $xmlDocOutput->create_element('entry');
					$xmlOutputEntry->set_attribute('id', $id );
					$xmlOutputEntry->set_attribute('date', $date );
					$xmlOutputEntry->set_content( fileconv( $title ) );
					$xmlOutputEntry->set_attribute('publishstate', $publishState );
					
					// ¤뤫ɤ[2008.04 桼]
					//	- ȥļȥOk  ¾ȥ¾ȥOkʤСǽ
					if ( ( ( $authedUserId === $author ) && $deleteMineOk ) || ( ( $authedUserId !== $author ) && $deleteOthersOk ) )
					{
						$xmlOutputEntry->set_attribute('deleteok', 'yes' );	// ̵ξ°νϤʤ
					}
					
					// Խ¤뤫ɤ
					//	- ȥļȥOk  ¾ȥ¾ȥOkʤСǽ
					if ( ( ( $authedUserId === $author ) && $editMineOk ) || ( ( $authedUserId !== $author ) && $editOthersOk ) )
					{
						$xmlOutputEntry->set_attribute('editok', 'yes' );	// ̵ξ°νϤʤ
					}
					
					$xmlOutputRoot->append_child( $xmlOutputEntry );
					
				}
			}
			
			if ( true )
			{
				// naviǤ
				$xmlNavi = $xmlDocOutput->create_element('navi');
				$xmlNavi->set_attribute('position', $pageNo );
				$xmlNavi->set_attribute('allcount', $allEntryCount );
				$xmlNavi->set_attribute('maxpage', $endPageNo );
				$xmlNavi->set_attribute('maxpagerows', $maxPageRows );
				
				// ڡ¸ߤСprevǤɲ
				if ( $this->pageNo > 1	)
				{
					$xmlPrev = $xmlDocOutput->create_element('prev');
					$xmlPrev->set_attribute('id', $pageNo - 1 );
					$xmlNavi->append_child( $xmlPrev );
				}
				
				// ¸ߤڡʬpageǤɲ
				for ( $index = 1; $index <= $endPageNo; $index++ )
				{
					$xmlPage = $xmlDocOutput->create_element('page');
					$xmlPage->set_attribute('id', $index );
					$xmlNavi->append_child( $xmlPage );
				}
				
				// ڡ¸ߤСnextǤɲ
				if ( $allEntryCount > $maxPageRows * $pageNo )
				{
					$xmlNext = $xmlDocOutput->create_element('next');
					$xmlNext->set_attribute('id', $pageNo + 1 );
					$xmlNavi->append_child( $xmlNext );
				}
				
				$xmlOutputRoot->append_child( $xmlNavi );			
			}
			
			// ReloadTokenν
			ReloadToken::embedToXmlDoc( $xmlDocOutput );
			
			// HTMLλ
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			/*
			$xslt = domxml_xslt_stylesheet_file( dirname(__FILE__) . "/entryeditor.xsl" );
			$result = $xslt->process( $xmlDocOutput );
			$strFormHTML = $result->dump_mem( false, 'EUC-JP' );
			*/
			
			// ʸԶ򥳡ɡ2006.07.06 ɲ
			$strFormHTML = replaceMetaTag( $strFormHTML, 'utf-8', 'euc-jp' );
			
			return $strFormHTML;			
			
		}

		
	}
	
	
	/* --------------------------------------------------------------------
	 * ȥԽġ롣
	 * ȥԽ롣
	 */
	class EntryEditor
	{
		var $currentEntry = "/entry"; 	// ȥθߤԽذ
		var $currentSchema = "/schema";	// ޤθߤԽذ
		//var $isNew = True;	  // ȥ꤫
		var $entryName = "";	// ȥ̾
		var $entryId = "";		// ȥID
		var $schemaName = "";	// ̾
		
		var $sortOrder = 'desc';	// ¤ӽ
		var $sortKey = '@date';	// ȥ
		var $groupKeys = NULL;	// 롼ץ
		
		var $strAllXml = "";	   // ԽоݤXMLʸ
		var $isDirty = false; 	// ԽƤ¸Ƥʤ
		var $errorMessage = '';	// 顼å
		var $errorId = '';			// 顼ID
		var $normalMessage = ''; // ̾å
		
		var $selectedListItems = array();	 // ꥹȹԽ̤ˤơ򤵤줿ID
		
		var $entries_MaxPageRows = 15;	// ȥ̤1ڡɽ
		var $entries_PageNo = 1; 	// ȥ꡼̤󡧥ڡֹ
		
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $entryName : ȥ̾
		 * $id : ȥIDξ϶"new"ꤹ롣
		 */
		function EntryEditor( $entryName, $id )
		{
			$this->entryName = $entryName;
			
			if ( $id === 'new' )
			{
				// ǧںѤߥ桼μ
				$user = LoginManager::GetAuthedUser();
				
				// IDȯԡ'_'+桼IDפȤǡ桼֤ΰե̾ξͤɤ
				$id = '_' . $user->getUserId();
			}
			
			$this->entryId = $id;
			$this->load( $entryName, $id );
			
			$this->entries_MaxPageRows = getGETParam( 'maxpagerows', 15 );
			$this->entries_PageNo = getGETParam( 'pageno' , 1 );
		}
		
		function isNewEntry( $id = null )
		{
			if ( is_null( $id ) )
			{
				$id = $this->entryId;
			}
			
			// ȥIDƬ1ʸ'_'ξ硢ȥȽǤ롣
			return ( substr( $id, 0, 1 ) === '_' );
		}
		
		/* ----------------------------------------------------------------
		 * Խΰ٤ξե뤫ɤ߹ࡣ
		 * $entryName : ȥ̾
		 * $id : ȥIDξ϶"new"ꤹ롣
		 */
		function load( $entryName, $id )
		{
			// Site.Configꤵ줿ȥ롣
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			$xpath = $xmlDocSite->xpath_new_context();
			
			$xmlEntryConfig = $xpath->xpath_eval( "//entry[@name='" . $entryName . "']" );
			// 2005.7.7 ɲ
			if ( count( cmsd_get_nodeset( $xmlEntryConfig )) <= 0 )
			{
				cmsd_abort_proc( "site.config.xmlե'$entryName'Υȥޤ" );
			}
			$this->schemaName = $xmlEntryConfig->nodeset[0]->get_attribute( "schema" );
			// 2005.7.7 ɲ
			if ( $this->schemaName === '' )
			{
				cmsd_abort_proc( "site.config.xmlե'$entryName'Υȥschema°ꤵƤޤ" );
			}
			
			// ޾롣
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();

			// ȥʤХȥ¸ȥʤХե뤫ɤ롣
			if ( $this->isNewEntry( $id ) ) // $id== "new" )
			{
				// Υȥ
				$this->createNewEntry();
			}
			else
			{
	 			// ȥXMLʸȤƼѿݻ롣
			   	// ȥؤԽϤʸФƹԤsave᥽åɤˤƥȥե˽񤭽Ф
		   	 	$xmlDocEntry = domxml_open_file( App::createEntryFilePath( $entryName, $id ) );
				
				// ߤγؤΥȥǡܤ򥹥ޤƱ롣
				$this->conformDataToSchema( $xmlDocEntry, $xmlDocSchema );
				
		   		// ѿʸȤƳǼ롣
				$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
			}
			
			// ޤ饽ȥƥФ˳ǼƤ
			
			/// schemaǤsortkey°sortorder°롣
			$xmlSchema = $xmlDocSchema->document_element();
			$sortKey = $xmlSchema->get_attribute( 'sortkey' );
			$sortOrder = $xmlSchema->get_attribute( 'sortorder' );
			
			if ( !empty($sortKey))
			{
				$this->sortKey = $sortKey;
				$this->sortOrder = $sortOrder;
			}
			else
			{
				// sortkey°ꤵƤʤСͤˡǥȾ롣
			
				$xmlSchemaSortKeyArr = $xpathSchema->xpath_eval( "/schema//data[@sort!='']" );
				if ( !empty( $xmlSchemaSortKeyArr->nodeset ) )
				{
					$this->sortOrder = $xmlSchemaSortKeyArr->nodeset[0]->get_attribute('sort');
					$this->sortKey = $xmlSchemaSortKeyArr->nodeset[0]->get_attribute('name');
				}
			
			}
			
			/// sortOrderξάͤ'desc'
			if ( empty( $this->sortOrder ) )
			{
				$this->sortOrder = 'desc';
			}
			
			// ޤ饰롼׾ƥФ˳ǼƤ
   			$xmlSchemaGroupKeyArr = $xpathSchema->xpath_eval( "/schema//data[@group='True' or @group='true']" );
			$this->groupKeys = array();
			if ( !empty( $xmlSchemaGroupKeyArr->nodeset ) )
			{
				foreach( cmsd_get_nodeset( $xmlSchemaGroupKeyArr ) as $xmlSchemaGroupKey )
				{
						$this->groupKeys[] = $xmlSchemaGroupKey->get_attribute('name');
				}
			}
			
			/* 2006.08.11 ȥȡȥ¸˺Ƥ١ǤɬפϤʤȽǡޤνΤޤޤȥޥ桼꤬ä
			// ĤäƤΥtmpե롣
			$deletefiles = glob( App::createEntryDirPath( $this->entryName) . '*.tmp' );
			if ( $deletefiles )
			{
				foreach ( $deletefiles as $tmpfilePath )
				{
					unlink($tmpfilePath);
				}
			}
			*/

		}
		
		function createNewEntry()
		{
			// DOM
			$xmlDocNewEntry = domxml_new_doc( '1.0' );
			
			// 롼ȥΡ'entry'
			$xmlEntryRoot = $xmlDocNewEntry->add_root( 'entry' );
			
 		  	// ߤΥDOM
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$xmlSchemaDataList = $xpathSchema->xpath_eval( "/schema/data" );
			
			// եID
			$fileid = 0; // 0̤Ǥ뤳Ȥɽ͡
			
			foreach( $xmlSchemaDataList->nodeset as $xmlSchemaData )
			{
				// ˥Ρɤ򿷵롣
				$item = EntryItemFactory::createEntryItem( $xmlSchemaData, $this->entryName, $this->entryId	);
				$newNode = $item->createNew( $xmlDocNewEntry );
				
				// newNodenullξ硢ΡɤɲäפʤΤǥåפ롣
				if ( is_null( $newNode ) )	
				{	
					continue;
				}
				
				// imgfile°Τߡfileid֤롣
				$type = $xmlSchemaData->get_attribute('type');
				if ( $type === 'img' or $type === 'file' )
				{
					$fileid = (int)$fileid + 1;
					$newNode->set_attribute( 'fileid', sprintf( "%08d", $fileid ) );	
				}
				
				// ΡɤҤȤɲä롣
				$xmlEntryRoot->append_child( $newNode );				
				
			}
			
			// ȥ깹˸
			/// ȥ깹ѤΥ޹ܤ롣
			$xmlSchemaDataEntryDate = $this->createSchemaDataForEntryDate( $xmlDocSchema );
			
			/// ȥ깹򹹿롣
			$item = EntryItemFactory::createEntryItem( $xmlSchemaDataEntryDate, $this->entryName, $this->entryId  );
			$item->createEntryDate( $xmlEntryRoot );
			
			// 桼̾[2008.04 桼]
			$user = LoginManager::GetAuthedUser();
			$xmlEntryRoot->set_attribute( 'author', $user->getUserId() );

			$this->strAllXml = $xmlDocNewEntry->dump_mem( true, 'UTF-8' );
			
		}
		
		/* ----------------------------------------------------------------
		 * ߤγؤΥȥǡܤ򡢥ޤƱ롣
		 */
		function conformDataToSchema( &$xmlDocEntry, &$xmlDocSchema )
		{
			//print "conformDataToSchema<br/>\n";
			// ȥXMLDOM롣
			//$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xpathEntry = $xmlDocEntry->xpath_new_context();
			
			// ߤγؤΥȥ롣
			$xmlParentDataArr = $xpathEntry->xpath_eval( $this->currentEntry );
			$xmlParentData = $xmlParentDataArr->nodeset[0];
			
			// ߤγؤΥޤγ"data"Ǥ롣
			//$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$xmlSchemaDataArr = $xpathSchema->xpath_eval( $this->currentSchema . "/data" );  // 2006.02.08 ⡧@type!='separator'ǹʤäΨɤseparator̰ʤΤǤΤޤޤˤ
			
			// ߤγؤΥǡ򡢥ޤƱ롣ʹܤ¸ߤʤ硢ܤɲä
			
			$fileid = 0; // եIDѿ0̤ɽ͡
			
			// listitemǤ˶Ȥꤹ롣
			if ( count( cmsd_get_nodeset( $xmlSchemaDataArr )) > 0 )
			{
				foreach( cmsd_get_nodeset($xmlSchemaDataArr) as $xmlSchemaData )
				{
					// EntryItem֥Ȥ롣
					$item = EntryItemFactory::createEntryItem( $xmlSchemaData, $this->entryName, $this->entryId );
					
					// ѥ졼ξϲ⤷ʤ2006.02.08 ѥ졼б
					if ( $item->getType() != 'separator' )
					{
						// ιܤȥ¸ߤ뤫
						/// ȥXML
						$xmlEntryDataArr = $xpathEntry->xpath_eval( $this->currentEntry . '/' . $item->getName() );
						//print "conformDataToSchema : Checked EntryData, " . $item->getName() . ", " . get_class($xmlEntryDataArr->nodeset[0]) . "<br/>\n";
						
						if ( count( cmsd_get_nodeset($xmlEntryDataArr) ) == 0 )
						{
							//print "conformDataToSchema : Added EntryData</ br>";
							// ¸ߤʤ硢Ρɤ򿷵롣
							$newNode = $item->createNew( $xmlDocEntry );
						
							// imgfile°Τߡfileid֤롣
							$type = $xmlSchemaData->get_attribute('type');
							if ( $type === 'img' or $type === 'file' )
							{
								if ( (int)$fileid <= 0 )
								{
									// fileid֤롣Ʊ쥨ȥκID+1롣
									$fileid = EntryUtil::getMaxFileId( $xpathEntry ) + 1;
								}
								else
								{
									$fileid = (int)$fileid + 1;
								}					
								$newNode->set_attribute( 'fileid', sprintf( "%08d", $fileid ) );	
							}
					
							// ꥹȹܤ˻ҥΡɤȤɲä롣					
							$xmlParentData->append_child( $newNode );
						
						}
					}
				
				}
			}
		}
		
		
		function procRequest()
		{			
			// 顼å롣
			$this->errorMessage = '';
			$this->errorId = '';
			
			// ꥹȹֹ롣
			$this->selectedListItems = array();
			
			// ̾å롣
			$this->normalMessage = '';
			
			// ǧںѤߥ桼μ
			$user = LoginManager::GetAuthedUser();
			
			// forceLock꤬ä硢ȥå롣
			if ( getPOSTParam( 'action' ) === 'forceLock' )
			{
				EditingEntryLock::ForceLock( $this->entryName, $this->entryId, $user->getUserId() );
			}
			
			// ȥåʿȥʳξΤߡ
			if ( $this->entryId != 'new' )
			{
				
				// å롣
				$lock = EditingEntryLock::CatchLock( $this->entryName, $this->entryId, $user->getUserId() );
				if ( ! $lock->isOwner( $user->getUserId() ) )
				{
					// åǤʤäϡ顼ɽ򤹤롣
					$ownerUserId = $lock->ownerUserId;
					$lastUpdate = date( 'Y-m-d H:i:s', $lock->lastUpdate );
					$this->errorMessage = "¾Υ桼($ownerUserId)ԽǤǽ $lastUpdate ǤԽåޤ";
					$this->errorId = "alreadyLocked";
					
				}
				
			}
			
			// Խ¤뤫[2008.04 桼]
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
			
			$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xmlEntryRoot = $xmlDocEntry->document_element();
			$author = $xmlEntryRoot->get_attribute( 'author' );
								
			// Ԥʤ̵Ǹͭꡣ
			if ( ! $user->isAdministrator() )
			{
				if ( $this->isNewEntry() )
				{
					// ⡼ɻ
					if ( ! $entryConfig->canAction( $user, 'add', 'mine' ) )
					{
						// ɲø̵Х顼
						$this->errorMessage = "ȥɲø¤ޤ";
						$this->errorId = "noPermissionForAdding";
					}
				}
				else
				{

				
					// Խ⡼ɻ
					if ( ( ( $author === $user->getUserId() ) && ! $entryConfig->canAction( $user, 'edit', 'mine'	) ) ||
						 ( ( $author !== $user->getUserId() ) && ! $entryConfig->canAction( $user, 'edit', 'others' ) ) )
					{
						// ȥļȥԽ¤̵¾ȥ¾ȥԽ¤̵ϥ顼
						$this->errorMessage = 'ΥȥԽ¤ޤ';
						$this->errorId = 'noPermissionForEditting';
					}
				}
			}
			
			
			// ƤӽФ(ġ顼ȯƤʤ)
			if ( ! isset( $_GET['p'] ) && $this->errorId === '' )
			{
				// ƤӽФǤʤʤ顢ȽԤ
				if ( ! ReloadToken::isReload() )
				{
					// ɤƤʤʤ顢ƼԤ
					
					switch ( $_POST['action'] )
					{
						case 'move' :
							$this->update();
							if ( $this->errorMessage === '' ) // 顼Ǥʤаư
							{
								$this->moveLevel( $_POST['nextlevel'] );
							}
							break;

						case 'update' :
							$this->update();
							$this->isDirty = true;
							break;
														
						case 'save' :
							$this->update();
							$this->isDirty = true;
							if ( $this->errorMessage === '' ) // 顼Ǥʤ¸
							{
								$this->save();
								$this->isDirty = false;
							}
							break;
						
						case 'newitem' :
							$this->newItem();
							$this->isDirty = true;
							break;
						
						case 'delitems' :
							$itemlist = $_POST['items'];
							$this->deleteItems( $itemlist );
							$this->isDirty = true;
							break;
						
						case 'moveitems' :
							$itemlist = $_POST['items'];
							$moveto = $_POST['moveto'];
							$this->moveItems( $itemlist, $moveto );
							$this->isDirty = true;
							$this->selectedListItems = $itemlist;
							break;
 					}
					
					//print "Current : " . ReloadToken::getCurrentToken() . "<br>\n";
					//print "Request : " . ReloadToken::getRequestToken() . "<br>\n";
					
				}
				else
				{
					//print "Reloaded!!<br>\n";
					//print "Current : " . ReloadToken::getCurrentToken() . "<br>\n";
					//print "Request : " . ReloadToken::getRequestToken() . "<br>\n";
					
				}
			}
			
			// ɥȡ򿷤ȯԤ롣
			ReloadToken::newToken();		
			
			// ߤƤɽԤ 		  
			//print( $this->renderFormHTML() );
			print( $this->renderFormXML() );
	
						
		}
		
		
		function moveLevel( $dataName )
		{
			// ߤΥDOM
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$xmlSchemaDataList = $xpathSchema->xpath_eval( $this->currentSchema );
			$xmlSchemaData = $xmlSchemaDataList->nodeset[0];
		
		
			// $dataName ".."ä飱ľγؤذư
			// "^"ä־γؤذư
			// ʳʤꤵ줿̤γؤذư
			
			if ( $dataName === ".." )
			{
				// ߤxpath顢1("/"Ƕڤ줿ʬʬ롣
				$pos = strrpos( $this->currentEntry, '/' );
				$this->currentEntry = 
					substr( $this->currentEntry, 0, $pos ); //$pos, strlen( $this->currentEntry ) - $pos );
				
				$pos = strrpos( $this->currentSchema, '/' );
				$this->currentSchema = 
					substr( $this->currentSchema, 0, $pos); // $pos, strlen( $this->currentSchema ) - $pos );
				
			}
			else if ( substr( $dataName, 0, 1 ) === "^" ) // Ƭʸ"^"ä
			{
				// "^nn" ΥѥǤ뤳Ȥ
				
				// ʬγؤذư롣
				$iLevel = substr( $dataName, 1 );
				if ( ! is_numeric( $iLevel ) )
				{
					$iLevel = 1;
				}
				
				$schemaXPath = $this->currentSchema;
				$entryXPath = $this->currentEntry;
				for ( $iCount = 0; $iCount < $iLevel; $iCount ++ )
				{
					$schemaXPath = $this->getUpperLevelXPathStr( $schemaXPath );
					$entryXPath = $this->getUpperLevelXPathStr( $entryXPath );
					
					// ⤷"/entry"ã顢Ǥbreak;
					if ( $entryXPath === '/entry' )
					{
						break;
					}
				}
				
				$this->currentSchema = $schemaXPath;
				$this->currentEntry = $entryXPath;
				
			}
			else  // γؤذư
			{
				//print "moveLevel, ";
				//print $xmlSchemaData->get_attribute( 'name' ) . ", ";
				if ( $xmlSchemaData->get_attribute( 'type' ) === 'list' )
				{
					// ؤꥹȤξ硢ȥxpathidˤʹߤղä롣
					$this->currentEntry .= "/listitem[@id='$dataName']";

					// ޤxpathˡnameˤʹߤղä롣
					$this->currentSchema .= "/listitem";
					
				}
				else
				{
					// ؤꥹȰʳξ硢ȥxpath˥̾ˤʹߤղä롣
					$this->currentEntry .= "/$dataName";
	
					// ޤxpathˡnameˤʹߤղä롣
					$this->currentSchema .= "/data[@name='$dataName']";
					
				}
				
				// ưγؤ򥹥ޤƱ롣
				$xmlDocEntry = domxml_open_mem( $this->strAllXml );
				$this->conformDataToSchema( $xmlDocEntry, $xmlDocSchema );
				// DOMĥ꡼ʸ󲽤ƥФ᤹
				$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
			}
			
		}
		
		/* ----------------------------------------------------------------
		 * ꥹȤ˿ܤɲä롣
		 * ߤγؤη"list"ʤ顢ǤɲäIDֵѤ롣
		 */
		function newItem()
		{
			// ܤΥޤ롣
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$xmlSchemaDataArr = $xpathSchema->xpath_eval( $this->currentSchema . "/listitem/data" );
			
			// ȥXMLDOM롣
			$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xpathEntry = $xmlDocEntry->xpath_new_context();
				
			// ܤIDꤹ롣¸IDκ͡ܣȤ롣
			$xmlEntryListItemArr = $xpathEntry->xpath_eval( $this->currentEntry . "/listitem" );
			$newID = 1; // ͤ1
			foreach( cmsd_get_nodeset( $xmlEntryListItemArr ) as $xmlEntryListItem )
			{
				$itemid = $xmlEntryListItem->get_attribute('id');
				if ( (int)$newID <= (int)$itemid )
				{
					// ߤͰʾIDȯ顢ꤵ+1롣
					$newID = (int) $itemid + 1;
				}
			}
			
			//print "newId : " . $newID . "<br>\n";
			
			// IDlistitemǤ롣
			$xmlEntryNewListItem = $xmlDocEntry->create_element( 'listitem' );
			$xmlEntryNewListItem->set_attribute( 'id', $newID );
			
			$fileid = 0; // 0̤ɽ͡
			
			// listitemǤ˶Ȥꤹ롣
			foreach( cmsd_get_nodeset( $xmlSchemaDataArr ) as $xmlSchemaData )
			{
				// ˥Ρɤ򿷵롣
				$item = EntryItemFactory::createEntryItem( $xmlSchemaData, $this->entryName, $this->entryId	);
				$newNode = $item->createNew( $xmlDocEntry );
				
				// ͤnullʤ鲿⤷ʤ	2006.02.08 ɲ ѥ졼ɲб
				if ( ! is_null( $newNode ) )
				{
				
					// imgfile°Τߡfileid֤롣
					$type = $xmlSchemaData->get_attribute('type');
					if ( $type === 'img' or $type === 'file' )
					{
						if ( (int)$fileid <= 0 )
						{
							// fileid֤롣Ʊ쥨ȥκID+1롣
							$fileid = EntryUtil::getMaxFileId( $xpathEntry ) + 1;
						}
						else
						{
							$fileid = (int)$fileid + 1;
						}					
						$newNode->set_attribute( 'fileid', sprintf( "%08d", $fileid ) );	
					}
					
					// ꥹȹܤ˻ҥΡɤȤɲä롣					
					$xmlEntryNewListItem->append_child( $newNode );
				}
				
			}
			
			// listitemDOMĥ꡼롣
			$xmlEntryCurrentArr = $xpathEntry->xpath_eval( $this->currentEntry );
			$xmlEntryCurrentArr->nodeset[0]->append_child( $xmlEntryNewListItem );
			
			// DOMĥ꡼ʸ󲽤ƥФ᤹
			$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
			
			// Ȱ֤򡢺ɲälistitemذư롣
			$this->moveLevel( (string)$newID );
			
		}
		
		/* ----------------------------------------------------------------
		 * 򤵤줿ꥹȹܤꥹȤ롣
		 * ߤγؤη"list"ʤ顢򤵤줿ǤꥹȤ롣
		 */
		function deleteItems( $itemlist )
		{
			if ( !empty( $itemlist ) )
			{
				// ȥDOM
				$xmlDocEntry = domxml_open_mem( $this->strAllXml );
				$xpathEntry = $xmlDocEntry->xpath_new_context();
				
				foreach( $itemlist as $itemid )
				{
					$xmlEntryListItemArr = $xpathEntry->xpath_eval( $this->currentEntry . "/listitem[@id='" . $itemid . "']" );	
					if ( !empty( $xmlEntryListItemArr ) )
					{
						$xmlEntryListItemArr->nodeset[0]->unlink_node();
					}
				}
				
				// DOMʸ󲽤ƥѿ᤹
				$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
				
			}
		}
		

		/* ----------------------------------------------------------------
		 * 򤵤줿ꥹȹܤꥹǰư롣ʣξ硢ޤȤưư롣ưǤϤҤȲˤʤ롣
		 * ذưꥹȤƬֹ-1ءذưꥹȤֹ+1ذư롣
		 * $itemlist : ֹ
		 * $moveto : 'top'ʤƬء'bottom'ʤء'up'ʤ飱ľء'down'ʤ飱Ĳذư
		 */
		function moveItems( $itemlist, $moveto )
		{
			//print $moveto . '<br />';
		
			if ( !empty( $itemlist ) )
			{
				// ȥDOM
				$xmlDocEntry = domxml_open_mem( $this->strAllXml );
				$xpathEntry = $xmlDocEntry->xpath_new_context();
				
				// ꥹȹܤDOMڤΥ̥ꥹȤ¸롣
				$xmlMoveItemArr = array();
				
				// ꥹΤ
				$xmlEntryListItemArr = $xpathEntry->xpath_eval( $this->currentEntry . "/listitem" );
				
				foreach ( cmsd_get_nodeset( $xmlEntryListItemArr ) as $itemIndex=>$xmlItem )
				{
					$itemID = $xmlItem->get_attribute('id');
					if ( in_array( $itemID, $itemlist ) )
					{
						
						// 'up'ʤƬܤΣ'down'ʤܤΣĸƤ
						if ( $moveto === 'up' and ! isset( $xmlInsertPoint ) )
						{
							if ( $itemIndex === 0 )
							{
								//print 'Ƭǡ<br/>';
								$xmlInsertPoint = 'topnode';	// ǥΡɤ֤롣
							}
							else
							{
								$xmlInsertPoint =& $xmlEntryListItemArr->nodeset[$itemIndex-1]; //$xmlItem->previous_sibling();
							}
						}
						else if ( $moveto === 'down' )
						{
							// ǸϺǸ-1ʤnull򡢤ʳʤ+2ΰ֤ݥȤȤ롣(insert_beforeȤᡢ2ĸƤɬפ
							if ( $itemIndex < count($xmlEntryListItemArr->nodeset) - 2 )
							{
								$xmlInsertPoint =& $xmlEntryListItemArr->nodeset[$itemIndex+2];
							}
							else
							{
								$xmlInsertPoint = 'bottomnode';    // ǥΡɤ֤롣
							}
							/*
							$xmlInsertPoint =& $xmlItem->next_sibling();
							if ( ! is_null( $xmlInsertPoint ) )
							{
								// Ǹ=nullˤʤʤ顢⤦ļƤinsert_beforeȤΤǡ2ĸƤɬפˡ
								$xmlInsertPoint =& $xmlInsertPoint->next_sibling();  
							}
							*/
						}
						
						// DOM̥ꥹȤ¸
						$xmlItem->unlink_node();
						$xmlMoveItemArr[] = $xmlItem;
						
					}
				}
				
				
				if ( $moveto === 'top' or $xmlInsertPoint === 'topnode' )
				{
					// ƬΡɤݥȤꡣƬΡɤȤϡưꥹȤ򺹤ĤƬΡɤʤΤǡʤФʤʤ
					$xmlInsertPoint = null;
					foreach ( cmsd_get_nodeset( $xmlEntryListItemArr ) as $itemIndex=>$xmlItem )
					{
						// ưоݹܤǤϡ֤ʤץΡɤȯ顢ݥȡ
						$itemID = $xmlItem->get_attribute('id');
						if ( ! in_array( $itemID, $itemlist ) )
						{
							$xmlInsertPoint =& $xmlEntryListItemArr->nodeset[$itemIndex];
							break;
						}
					}
					
					// ʤä硢ܰưȤȤʤΤǡ֤'bottomnode'ѹ롣
					if ( is_null( $xmlInsertPoint ) )
					{
						$xmlInsertPoint = 'bottomnode';
					}
				}
				
				if ( $moveto === 'bottom' or $xmlInsertPoint === 'bottomnode' )    // ݥȤ'bottomnode'ʤΤϡ'down'ܤꥹȤä硣
				{
					// Ǹappend롣
					$xmlEntryCurrentArr = $xpathEntry->xpath_eval( $this->currentEntry );
					foreach( $xmlMoveItemArr as $xmlMoveItem )
					{
						$xmlEntryCurrentArr->nodeset[0]->append_child( $xmlMoveItem );
					}
				}
				else
				{
					//print 'insertPoint : ' . $xmlInsertPoint->get_attribute('id') . '<br />';
				
					// ݥȤ롣
					$xmlEntryCurrentArr = $xpathEntry->xpath_eval( $this->currentEntry );
					foreach( $xmlMoveItemArr as $xmlMoveItem )
					{
						$xmlEntryCurrentArr->nodeset[0]->insert_before( $xmlMoveItem, $xmlInsertPoint );
					}
				}
				
				// DOMʸ󲽤ƥѿ᤹
				$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
				
				//print '<pre>' . $this->strAllXml . '</pre><br />';
				
			}
		}		 
		
		
		/* ----------------------------------------------------------------
		 * ϥǡԽΥǡȿǡʥեˤϤޤȿǤʤˡ
		 */		
		function update()
		{
		
			// ߤγؤΥޤбꥯȤͤ򡢸ߤΥȥȿǤ롣
			
			// ȥXMLDOM롣
			$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xpathEntry = $xmlDocEntry->xpath_new_context();
			
			// ߤγؤΥޤγ"data"Ǥ롣
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			$xmlSchemaDataList = $xpathSchema->xpath_eval( $this->currentSchema . "/data" );
			
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
			
			// ߤγؤȥå׳ؤʤСȥ깹ιܤ򹹿
			if ( $this->currentEntry === '/entry' )
			{
				// ȥ깹ѤΥ޹ܤ롣
				$xmlSchemaDataEntryDate = $this->createSchemaDataForEntryDate( $xmlDocSchema );
				
				// ȥ깹򹹿롣
				$item = EntryItemFactory::createEntryItem( $xmlSchemaDataEntryDate, $this->entryName, $this->entryId	);
				$resultOK = $item->update( $xpathEntry, $this->currentEntry );
				if ( ! $resultOK )
				{
					$this->errorMessage = $item->getErrorMessage();
					return;
				}
				
				// ¾Υإå򹹿롣
				$item = new HeaderEntryItem( $this->entryName, $this->entryId, $entryConfig->publishControl );
				$resultOK = $item->update( $xpathEntry, $this->currentEntry );
				if ( ! $resultOK )
				{
					$this->errorMessage = $item->getErrorMessage();
					return;
				}
			}
			
			// ޤdataǤбϤСȥȿǤ롣
			foreach( cmsd_get_nodeset( $xmlSchemaDataList ) as $xmlSchemaData )
			{
				//print( "className = " . get_class( $xmlSchemaData ) . "<br>\n" );
				// ǡ̾򥹥ޤ롣
				$dataname = $xmlSchemaData->get_attribute( 'name' );
				$datatype = $xmlSchemaData->get_attribute( 'type' );
				
				//print( $dataname . " = " . htmlconv( $datavalue ) . "<br>\n" );
				
				$xmlEntryDataList = $xpathEntry->xpath_eval( $this->currentEntry . "/$dataname" );
				if ( !empty( $xmlEntryDataList ) )	// ȥǡˡ޹ܤбǡ뤫
				{
					if ( $datatype != 'list' )	// ϡlistܰʳlistܤʤ̵
					{
						$item = EntryItemFactory::createEntryItem( $xmlSchemaData, $this->entryName, $this->entryId	);
						$resultOK = $item->update( $xpathEntry, $this->currentEntry );
						if ( ! $resultOK )
						{
							$this->errorMessage = $item->getErrorMessage();
						}
					}
				}
			}
			
			$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
		}
		
		/* ----------------------------------------------------------------
		 * ԽΥǡե¸
		 */		
		function save()
		{
			// -- å -----------------------------------------------------

			// ȥե񤭹߲ǽå롣
			$checkpath = App::createEntryDirPath( $this->entryName );
			if ( ! is_writable( $checkpath ) )
			{
				// 񤭹ԲĤΥ顼åϤƽλ롣
				cmsd_abort_proc( "ȥե'$checkpath'񤭹ޤ󡣥եΥѡߥå707777˰ʾˤʤäƤ뤫ǧƤ" );
			}
			
			// ȥindexե뤬¸ߤʤС񤭹߲ǽå롣
			$checkpath = App::createEntryFilePath( $this->entryName, 'index' );
			if ( file_exists( $checkpath ) )
			{
				if ( ! is_writable( $checkpath ) )
				{
					cmsd_abort_proc( "ȥindexե'$checkpath'񤭹ޤ󡣥եΥѡߥå606666˰ʾˤʤäƤ뤫ǧƤ" );
				}
			}

			// ȥե뤬¸ߤʤС񤭹߲ǽå롣
			$checkpath = App::createEntryFilePath( $this->entryName, $this->entryId );
			if ( file_exists( $checkpath ) )
			{
				if ( ! is_writable( $checkpath ) )
				{
					cmsd_abort_proc( "ȥindexե'$checkpath'񤭹ޤ󡣥եΥѡߥå606666˰ʾˤʤäƤ뤫ǧƤ" );
				}
			}
						
			// --  -----------------------------------------------------
			
			// ߤΥXMLǡDOMɤ߹ࡣ
			$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xpathEntry = $xmlDocEntry->xpath_new_context();
			
			// indexǡDOMɤ߹ࡣ
			$xmlDocEntryIndex = domxml_open_file( App::createEntryFilePath( $this->entryName, 'index' ) );
			$xpathEntryIndex = $xmlDocEntryIndex->xpath_new_context();
			$xmlNodeEntryIndexRoot = $xmlDocEntryIndex->document_element();
			
			// ȥ꤫
			$bNewEntry = $this->isNewEntry(); //( $this->entryId == "new" );
			
			// ȥξ硢IDդ롣
			if ( $bNewEntry )
			{
				$fp = fopen( App::createEntrySequenceFilePath( $this->entryName ), "ab+" );
				set_file_buffer($fp, 0);
				flock( $fp, LOCK_EX );
				
				// IDȯԤ󥹴ե˽񤭹ࡣ
				$iSequence = 0;
				if ( file_exists( App::createEntrySequenceFilePath( $this->entryName ) ) )
				{
					//$fp = fopen( App::createEntrySequenceFilePath( $this->entryName ), "r" );
					rewind($fp);
					$iSequence = fgets($fp); //fread($fp, filesize( App::createEntrySequenceFilePath( $this->entryName ) ));
					//fclose($fp);
				}
				
				if ( is_numeric( $iSequence ) )
				{
					$iSequence = (int) $iSequence + 1;
					
				}
				else
				{
					$iSequence = 1;
				}
				
				if ( file_exists( App::createEntryFilePath( $this->entryName, sprintf( "%05d", $iSequence ) ) ) )
				{
					$this->errorMessage = "ȥIDͿ˼Ԥޤȥ¸ޤǤ$iSequence";
					flock( $fp, LOCK_UN );
					fclose( $fp );
					return;
				}
				
				ftruncate($fp, 0);	// ե륵򥼥ˤ롣
				rewind($fp);
				//$fp = fopen( App::createEntrySequenceFilePath( $this->entryName ), "w" );
				fwrite( $fp, $iSequence );
				
				flock( $fp, LOCK_UN );
				fclose($fp);
				
				$this->entryId = sprintf( "%05d", $iSequence );
				
			}
			else
			{
				// ¸ȥξ硢indexե뤫¸Υȥ롣
				$xmlNodeNewEntryRefArr = $xpathEntryIndex->xpath_eval( "/entrylist/entry[@href='" . $this->entryName . '.' . $this->entryId . '.xml' . "']" );
				if ( cmsd_get_nodeset( $xmlNodeNewEntryRefArr ) )	// Խ¾Υ桼˺Ƥǽ١
				{
					$xmlNodeNewEntryRef = $xmlNodeNewEntryRefArr->nodeset[0];
					$xmlNodeNewEntryRef->unlink_node();
				}
				
			}
			
			// ȥΥإå񤭹ࡣ
			$xmlNodeEntry = $xmlDocEntry->document_element();
			$xmlNodeEntry->set_attribute( 'id', $this->entryId );
			$xmlNodeEntry->set_attribute( 'schemaname', $this->schemaName );
			/* 2004.12.23 ȥ깹դ򥳥ƥĥޥ͡㤫鹹褦ˤ١ȥȡ
			$xmlNodeEntry->set_attribute( 'date', date( "Y-m-d H:i:s" ) );
			$xmlNodeEntry->set_attribute( 'year', date( "Y" ) );
			$xmlNodeEntry->set_attribute( 'month', date( "m" ) );
			$xmlNodeEntry->set_attribute( 'day', date( "d" ) );
			$xmlNodeEntry->set_attribute( 'hour', date( "H" ) );
			$xmlNodeEntry->set_attribute( 'minute', date( "i" ) );
			$xmlNodeEntry->set_attribute( 'second', date( "s" ) );
			*/
			
			//$xmlNodeEntry->set_attribute( 'visible', 'True' );
			$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8');

			//$date = "2003-10-01 16:28:30"; 
			//sscanf( $date, "%d-%d-%d %d:%d:%d", &$yy, &$mm, &$dd, &$hh, &$ii, &$ss ); 
			//$mkdate = mktime( $hh, $ii, $ss, $mm, $dd 1, $yy); 
			//echo date("Y-m-d H:i:s", $mkdate);								
			
			// indexե˥ȥɲä¸롣
			$xmlNodeNewEntryRef = $xmlDocEntryIndex->create_element( 'entry' );
			$xmlNodeNewEntryRef->set_attribute( 'href', $this->entryName . '.' . $this->entryId . '.xml' );
			$xmlNodeNewEntryRef->set_attribute( 'id', $this->entryId );
			
			// indexե˥ȥθ¸롣
			$xmlNodeNewEntryRef->set_attribute( 'visible', $xmlNodeEntry->get_attribute('visible') );
			$xmlNodeNewEntryRef->set_attribute( 'startdate', $xmlNodeEntry->get_attribute('startdate') );
			$xmlNodeNewEntryRef->set_attribute( 'enddate', $xmlNodeEntry->get_attribute('enddate') );
			
			// indexեˤ¾Υإå¸롣[2008.04 桼]
			$xmlNodeNewEntryRef->set_attribute( 'date', $xmlNodeEntry->get_attribute('date') );
			$xmlNodeNewEntryRef->set_attribute( 'year', $xmlNodeEntry->get_attribute('year') );
			$xmlNodeNewEntryRef->set_attribute( 'month', $xmlNodeEntry->get_attribute('month') );
			$xmlNodeNewEntryRef->set_attribute( 'day', $xmlNodeEntry->get_attribute('day') );
			$xmlNodeNewEntryRef->set_attribute( 'hour', $xmlNodeEntry->get_attribute('minute') );
			$xmlNodeNewEntryRef->set_attribute( 'second', $xmlNodeEntry->get_attribute('second') );
			$xmlNodeNewEntryRef->set_attribute( 'weekday', $xmlNodeEntry->get_attribute('weekday') );
			
			$xmlNodeNewEntryRef->set_attribute( 'author', $xmlNodeEntry->get_attribute('author') );
			
			// indexȥˡ롼ץȥɲä롣
			/// 롼ץ
			foreach( $this->groupKeys as $groupKey )
			{
				$xmlNodeGroupKeyDataArr = $xpathEntry->xpath_eval( '/entry/' . $groupKey ); // СǤϡȥå׳ؤΤб
				if ( !empty( $xmlNodeGroupKeyDataArr->nodeset ) )
				{
					$xmlNodeGroupKey = $xmlDocEntryIndex->create_element( 'groupkey' );
					$xmlNodeGroupKey->set_attribute( 'key', $groupKey );
					$xmlNodeGroupKey->set_content( $xmlNodeGroupKeyDataArr->nodeset[0]->get_content() );
					$xmlNodeNewEntryRef->append_child( $xmlNodeGroupKey );
				}
			}
			
			/// ȥ
			$xmlNodeSortKeyDataArr = $xpathEntry->xpath_eval( '/entry/' . $this->sortKey ); // СǤϡȥå׳ؤΤб
			if ( !empty( $xmlNodeSortKeyDataArr->nodeset ) )
			{
				$sortValue = $xmlNodeSortKeyDataArr->nodeset[0]->get_content();
				$xmlNodeSortKey = $xmlDocEntryIndex->create_element( 'sortkey' );
				$xmlNodeSortKey->set_attribute( 'key', $this->sortKey );
				$xmlNodeSortKey->set_content( $sortValue );
				$xmlNodeNewEntryRef->append_child( $xmlNodeSortKey );
			}
			
			
			// ȥˤŬڤʰ֤򸫤Ĥindex˥ȥ롣
			$insertPos = -1; // 
			$entryValue = ""; //  2011.04.14 ɲ
			$xmlNodeEntryRefArr = $xpathEntryIndex->xpath_eval('/entrylist/entry');
			foreach( cmsd_get_nodeset( $xmlNodeEntryRefArr ) as $index => $xmlNodeEntryRef )
			{
				$xmlNodeSortKeyArr = $xmlNodeEntryRef->get_elements_by_tagname( 'sortkey' );
				if ( ! empty( $xmlNodeSortKeyArr ) )
				{
					$entryValue = $xmlNodeSortKeyArr[0]->get_content();
				}
				if ( $this->sortOrder === 'asc' )
				{
					if ( $entryValue >= $sortValue )
					{
						$insertPos = $index;
						//print 'insertPost = ' . $insertPos . ', entryValue = ' . $entryValue;
						break;
					}
				}
				else
				{
					if ( $entryValue < $sortValue )
					{
						$insertPos = $index;
						break;
					}
					
				}
			}
			
			if ( $insertPos <= -1 )
			{
				// ֤Ĥʤä
				$xmlNodeEntryIndexRoot->append_child( $xmlNodeNewEntryRef );
				
				/*
				if ( $this->sortOrder == 'asc' )
				{
					// ascʤ顢Ǹɲá
					$xmlNodeEntryIndexRoot->append_child( $xmlNodeNewEntryRef );
				}
				else
				{
					// descʤ顢Ƭɲá
					if ( !empty($xmlNodeEntryRefArr->nodeset) )
					{
						$xmlNodeEntryIndexRoot->insert_before( $xmlNodeNewEntryRef, $xmlNodeEntryRefArr->nodeset[0] );
					}
					else
					{
						$xmlNodeEntryIndexRoot->append_child( $xmlNodeNewEntryRef );
					}
				}
				*/
			}
			else
			{
				// ֤Ĥä
				$xmlNodeEntryIndexRoot->insert_before( $xmlNodeNewEntryRef, $xmlNodeEntryRefArr->nodeset[$insertPos] );
				
			}
			
			//$xmlNodeEntryIndexRoot->append_child( $xmlNodeNewEntryRef );
			
			ADDom::SaveXmlToFile( $xmlDocEntryIndex, App::createEntryFilePath( $this->entryName, 'index' ), 'UTF-8' );
			//$xmlDocEntryIndex->dump_file( App::createEntryFilePath( $this->entryName, 'index' ), false, true );
			
						
			
			// åץɥեνDOMĥ꡼Ρ줿źեեˤĤƳԤ
			// ƱˡפȤʤäʻȤƤʤ˥ե롣
			/// DOMĥ꡼ꡢimg/fileΥΡɤƼ롣
			$xpathEntry = $xmlDocEntry->xpath_new_context();
			$xmlEntryImageArr = $xpathEntry->xpath_eval( "//*[@fileid!='']" );
			$attachedfiles = array();	// źեեΥꥹȤ
			/* $smallimagefiles = array();	// ̾եΥꥹȤӺ */
			if ( is_object($xmlEntryImageArr) ) {
				foreach( cmsd_get_nodeset( $xmlEntryImageArr ) as $xmlEntryImage )
				{
					$state = $xmlEntryImage->get_attribute('state');
					$fileName = $xmlEntryImage->get_attribute('src');
					
					if ( $state != 'saved' )
					{
						// ե̾ξϲ⤷ʤ
						if ( $fileName != '' )
						{
							// ¸ե뤬¸ߤʤ顢롣
							$filePath = App::createEntryDirPath( $this->entryName ) . $fileName;
							if ( file_exists( $filePath ) )
							{
								unlink( $filePath );
							}
							
							switch( $state )
							{
								case 'new' :
								case 'updated' :
								
									// tmpե͡ह롣
									if ( file_exists( $filePath . '.tmp' ) )
									{
										rename( $filePath . ".tmp", $filePath );
									}
									
									break;
								
								case 'deleted' :
									// °򥯥ꥢ롣
									$xmlEntryImage->set_attribute( 'org', '' );
									$xmlEntryImage->set_attribute( 'filesize', '0' );
									$xmlEntryImage->set_attribute( 'src', '' );
									
									if ( $xmlEntryImage->get_attribute('filetype') === 'image' )
									{
										$xmlEntryImage->set_attribute( 'width', '0' );
										$xmlEntryImage->set_attribute( 'height', '0' );
									}
									
									// ѥ򥯥ꥢ롣2005.03.28ɲ
									EntryUtil::deleteTextNode( $xmlEntryImage );
									$xmlEntryImage->set_content('');

									break;
							
							}
							
							// entryidnewξ硢ե̤֤̾ʤΤǡ̾ѹ롣
							if ( $bNewEntry )
							{
								$fileid = $xmlEntryImage->get_attribute('fileid');
								$org = $xmlEntryImage->get_attribute('org');
								$oldFileName = $fileName;
								$fileName = $this->getSrcFileName( $fileid, $org );
								$xmlEntryImage->set_attribute('src', $fileName );
								
								if ( $xmlEntryImage->get_attribute('filetype') === 'image' )
								{
									$fileurl = App::createImageUrl( $this->entryName, $this->entryId, $fileid, $org );	
								}
								else
								{
									$fileurl = App::createFileUrl( $this->entryName, $this->entryId, $fileid, $org );	
								}
								
								// եURLƤȤƥåȡ
								EntryUtil::deleteTextNode( $xmlEntryImage );
								$xmlEntryImage->set_content( fileconv($fileurl) );
								
								// ƥݥե̾˥͡
								if ( file_exists( App::createEntryDirPath( $this->entryName ) . $oldFileName ) )
								{
									rename( App::createEntryDirPath( $this->entryName ) . $oldFileName, App::createEntryDirPath( $this->entryName ) . $fileName );
								}
							}
						}
						
						// statesavedѹ롣
						$xmlEntryImage->set_attribute('state', 'saved');
					}
					
					// źեե̾ꥹȤɲá
					$attachedfiles[] = $fileName;
					
					/*
					// ̾ե̾ꥹȤɲá
					if ( strlen( $xmlEntryImage->get_attribute('smallimage') ) > 0 )
					{
						$fileid = $xmlEntryImage->get_attribute('fileid');
						$org = $xmlEntryImage->get_attribute('org');
						$smallIMGFilename = $this->getSrcFileName( $fileid . '.small', $org );
						$smallimagefiles[] = $smallIMGFilename;
					}
					*/
				}
			}
			
			
			/// פȤʤäե롣(Υȥ *.tmpե⤳Ǿä
			$filesInEntry = glob( App::createEntryDirPath( $this->entryName) . $this->entryName . '.' . $this->entryId . '.*' );
			if ( $filesInEntry )
			{
				foreach ( $filesInEntry as $filePath )
				{
					// ȥβեꥹȤ˴ޤޤƤʤСפȤߤʤƺ롣
					if ( ! in_array( basename( $filePath ), $attachedfiles ) ) // and ! in_array( basename( $filePath ), $smallimagefiles ) )
					{
						if ( getfileext( basename( $filePath ) ) != 'xml' )
						{
							//print basename( $filePath ) . " is deleted(img).<br>\n"; 
							unlink( $filePath );
						}
					}
				}
			}
			
			/// Υȥβåեƺ롣衢ѹ줿Ρ줿ΤOKǲΰ٤
			$cacheImageFilesInEntry = glob( App::getCacheDir() . "imagecache.{$this->entryName}.{$this->entryId}.*" );
			if ( $cacheImageFilesInEntry )
			{
				foreach ( $cacheImageFilesInEntry as $filePath )
				{
					unlink( $filePath );
				}
			}
			
			
			/// ߤtmpեƺ롣ʲˡԽϤ¸˥֥饦ĤΥߤʤɡ
			$tempfilesInEntry = glob( App::createEntryDirPath( $this->entryName) . '*.tmp' );
			if ( $tempfilesInEntry )
			{
				foreach ( $tempfilesInEntry as $tempfilePath )
				{
					// 1ʾΥեäʸߤΥեäƤޤȡ¾Υ桼˱ƶƤޤ١
					$timeLastUpdate = filemtime( $tempfilePath );
					if ( $timeLastUpdate < strtotime( '-1 day' ) )
					{
						unlink( $tempfilePath );
					}
				}
			}
			
			// XMLǡ᤹
			$this->strAllXml = $xmlDocEntry->dump_mem( true, 'UTF-8' );
			
			// DOM񤭹ࡣ
			$xmlDocEntry->dump_file( App::createEntryFilePath( $this->entryName, $this->entryId ), false, true );
			
			
			// åեκ 2009.01.30 ɲ j.shinde
			ADPageCache::deleteAllCaches();
			
			// åɽ롣
			$this->normalMessage = 'ȥ¸ޤ';
			
		}
		
		
		function delete()
		{
			
		}
		
		function getSrcFileName( $fileid, $orgFileName )
		{
			return $this->entryName . '.' . $this->entryId . '.' . $fileid . '.' . getfileext( $orgFileName );
		}
		
		function getUpperLevelXPathStr( $strXPath )
		{
			// ߤxpath顢1("/"Ƕڤ줿ʬʬ롣
			$pos = strrpos( $strXPath, '/' );
			$strXPath = substr( $strXPath, 0, $pos );
			
			return $strXPath;

		}
		

		/* ----------------------------------------------------------------
		 * FORM-XML롣
		 */
		function renderFormXML()
		{
			// Site.Configꤵ줿ȥ롣
			/*
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			$xpathSite = $xmlDocSite->xpath_new_context();
			$xmlEntryConfigList = $xpathSite->xpath_eval( "/site/entries/entry[@name='" . $this->entryName . "']" );
			$entryCaption = $xmlEntryConfigList->nodeset[0]->get_attribute('caption');
			*/
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
			$entryCaption = $entryConfig->caption;
			
			// ޤXpath롣
			$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $this->schemaName ) );
			//print "XML string : '<pre>" . htmlentities( htmlconv( $xmlDocSchema->dump_mem() ), ENT_COMPAT, 'EUC-JP' ) . "</pre>'";
			$xpathSchema = $xmlDocSchema->xpath_new_context();
			
			// ֤߰Υޤɤ߹ࡣ
			$xmlSchemaRoot = $xpathSchema->xpath_eval( $this->currentSchema ); // "/schema/data[@name='shopphotolist']" );
			$xmlSchemaRoot = $xmlSchemaRoot->nodeset[0];
		
			// ȥXPath롣			 
			//print "XML string : '<pre>" . htmlentities( htmlconv( $this->strAllXml ), ENT_COMPAT, 'EUC-JP' ) . "</pre>'"; 		
			$xmlDocEntry = domxml_open_mem( $this->strAllXml );
			$xpathEntry = $xmlDocEntry->xpath_new_context();

			// HTML	
			// DOM
			// 롼ȥΡ'entryeditor'
			$xmlDocOutput = domxml_new_doc( '1.0' );
			$xmlOutputRoot = $xmlDocOutput->add_root( 'entryeditor' );	
			
			// Entryν
			$xmlOutputEntry = $xmlDocOutput->create_element('entry');
			$xmlOutputEntry->set_attribute('id', $this->entryId );
			$xmlOutputEntry->set_attribute('isnew', ( $this->isNewEntry() ? 'True' : 'False' ) );
			$xmlOutputEntry->set_attribute('isdirty', ( $this->isDirty ? 'True' : 'False' ) );
			$xmlOutputEntry->set_attribute('entrycaption', fileconv( $entryCaption ) );
			$xmlOutputEntry->set_attribute('entryname', $this->entryName );
			/// ֤߰Υޡȥ˴ŤԽեܤ롣
			if ( $xmlSchemaRoot->get_attribute( "type" ) === 'list' )
			{
				// type=="list"ξ硢ꥹѤXML롣
				$this->renderFormXMLList( $xpathSchema, $xpathEntry, $xmlOutputEntry );
			}
			else
			{
				// type=="list"ʳξ硢֥åѤXML롣ȥå׳ؤξtypenullˤʤΤǤ롣
				$this->renderFormXMLBlock( $xmlSchemaRoot->child_nodes(), $xpathEntry, $xmlOutputEntry );
			}			
			$xmlOutputRoot->append_child( $xmlOutputEntry );
			
			// ReloadTokenν
			ReloadToken::embedToXmlDoc( $xmlDocOutput );
			/*
			$xmlOutputReloadToken = $xmlDocOutput->create_element('reloadtoken');
			$xmlOutputReloadToken->set_attribute('key', ReloadToken::getTokenKey() );
			$xmlOutputReloadToken->set_attribute('value', ReloadToken::getCurrentToken() );
			$xmlOutputRoot->append_child( $xmlOutputReloadToken );
			*/
			
			// ȥ־ν
			$xmlOutputLocation = $xmlDocOutput->create_element('location');
			$xmlOutputLocation->set_attribute('istop', ( ( $this->currentEntry === '/entry' ) ? 'True' : 'False' ));
			$xmlOutputLocation->set_attribute('currenttype', ( $xmlSchemaRoot->get_attribute( "type" ) === 'list' ? 'list' : 'block' ));
			$this->createOutputSchemaLocation( $xpathSchema, $xpathEntry, $xmlOutputLocation );
			$xmlOutputRoot->append_child( $xmlOutputLocation );
			
			// 顼IDν
			if ( $this->errorId != '' )
			{
				$xmlOutputRoot->set_attribute('errorid', $this->errorId );
			}
			
			// 顼åν
			if ( $this->errorMessage != '' )
			{
				$xmlOutputErrorMessage = $xmlDocOutput->create_element('errormessage');
				$xmlOutputErrorMessage->set_content( fileconv( $this->errorMessage ) );
				$xmlOutputRoot->append_child( $xmlOutputErrorMessage );
			}
			
			// ̾åν
			if ( $this->normalMessage != '' )
			{
				$xmlOutputNormalMessage = $xmlDocOutput->create_element('normalmessage');
				$xmlOutputNormalMessage->set_content( fileconv( $this->normalMessage ) );
				$xmlOutputRoot->append_child( $xmlOutputNormalMessage );
			}
			
			// ȥɽURLꤵƤ顢Ϥ롣
			if ( ! empty($entryConfig->entryPageUrl) )
			{
				$xmlOutputRoot->set_attribute('entrypageurl', $entryConfig->entryPageUrl );
			}
			
			// ν
			$authedUser = LoginManager::GetAuthedUser();
			$xmlOutputAuthedUser = $xmlDocOutput->create_element( 'autheduser' );
			$xmlOutputAuthedUser->set_attribute( 'userid', $authedUser->getUserid() );
			$xmlOutputAuthedUser->set_attribute( 'role', $authedUser->getRole() );
			$xmlOutputRoot->append_child( $xmlOutputAuthedUser );
			
			// 桼νϡAdminξΤߡ
			if ( $authedUser->isAdministrator() )
			{
				$userArr = SiteUser::LoadAllUsers();
				$xmlOutputUserList = $xmlDocOutput->create_element( 'userlist' );
				foreach( $userArr as $user )
				{
					$xmlOutputUser = $xmlDocOutput->create_element( 'user' );
					$xmlOutputUser->set_attribute( 'userid', $user->getUserId() );
					$xmlOutputUserList->append_child( $xmlOutputUser );
				}
				$xmlOutputRoot->append_child(  $xmlOutputUserList );
			}
			
			// ڡν
			$xmlOutputOwnerPage = $xmlDocOutput->create_element( 'ownerpage' );
			$xmlOutputOwnerPage->set_attribute( 'name', 'entries' ); // ȤäƤʤ
			$xmlOutputOwnerPage->set_attribute( 'maxpagerows', $this->entries_MaxPageRows );
			$xmlOutputOwnerPage->set_attribute( 'pageno', $this->entries_PageNo );
			$xmlOutputRoot->append_child( $xmlOutputOwnerPage );
			
			// HTMLλ
			// XSLѴ
			//$strFormHTML = ADXslt::process( $xmlDocOutput, dirname(__FILE__) . "/entryeditor.xsl" );
			$strFormHTML = CommonActionUtil::XsltEntryEditor( $xmlDocOutput );
			/*
			$xslt = domxml_xslt_stylesheet_file( dirname(__FILE__) . "/entryeditor.xsl" );
			$result = $xslt->process( $xmlDocOutput );
			$strFormHTML = $result->dump_mem( false, 'EUC-JP' );			
			*/
			
			//$strFormHTML = "XML string : <pre>" . htmlconv( $xmlDocOutput->dump_mem( true, 'EUC-JP' ) ) . "<pre>'";
			
			// ʸԶ򥳡ɡ2006.07.06 ɲ
			$strFormHTML = replaceMetaTag( $strFormHTML, 'utf-8', 'euc-jp' );
			
			return $strFormHTML;
		}
		
		/* ----------------------------------------------------------------
		 * FORM-HTMLˡ
		 * $nodeList : ֤߰Υޤ"data"ǤΥꥹȡ
		 * $xpathEntry : ˤ롢ԽΥȥǡ
		 * $xmlOutputEntry : ԽɽѤΥǡ롼ǡ
		 */
		function renderFormXMLBlock( $nodeList, $xpathEntry, &$xmlOutputEntry )
		{
			// ȥå׳ؤξ硢ȥʸߤϹդΤߡˤɽ롣
			if ( $this->currentEntry === '/entry' )
			{
				// ɽXMLΥɥȤ
				$xmlDocOutput = $xmlOutputEntry->owner_document();
				
				// ȥ깹̾ܥ饹Υ󥰤ȤäƽϤ롣----------------
				
				/// - ȥ깹ɽѤιܤtype='entrydate'Ƥ
				$xmlSchemaDataEntryDate = $this->createSchemaDataForEntryDate( $xmlDocOutput );
				$xmlDocOutput = $xmlOutputEntry->owner_document();
				$xmlOutputEntryData = $xmlDocOutput->create_element('entrydata');
				$xmlOutputEntryData->set_attribute('name', $xmlSchemaDataEntryDate->get_attribute( "name" ) );
				$xmlOutputEntryData->set_attribute('caption', $xmlSchemaDataEntryDate->get_attribute( "caption" ) );
				$xmlOutputEntryData->set_attribute('type', $xmlSchemaDataEntryDate->get_attribute('type') );
				
				/// - ܥ֥ȤOutputإ
				$item = EntryItemFactory::createEntryItem( $xmlOutputEntryData, $this->entryName, $this->entryId  );
				$item->renderFormItemXML( $xpathEntry, $this->currentEntry, $xmlOutputEntryData );
				$xmlOutputEntry->append_child( $xmlOutputEntryData );
				
				// Configɤ߹
				$siteConfig = new CMSSiteConfig();
				$entryConfig = $siteConfig->getEntryConfig( $this->entryName );
				
				// ȥ깹ʳΥإåʸʤɡˤ󥰤롣---------------
				$item = new HeaderEntryItem( $this->entryName, $this->entryId, $entryConfig->publishControl );
				$xmlOutputEntryData = $xmlDocOutput->create_element('entrydata');
				$xmlOutputEntryData->set_attribute('name', 'header' ); // ߡͤϼºݤˤϻѤʤ
				$xmlOutputEntryData->set_attribute('caption', fileconv( '' ) );
				$xmlOutputEntryData->set_attribute('type', 'header' );
				
				$item->renderFormItemXML( $xpathEntry, $this->currentEntry, $xmlOutputEntryData );
				$xmlOutputEntry->append_child( $xmlOutputEntryData );
				

			}
			
			foreach( $nodeList as $node )
			{
				if ( $node->node_type() == XML_ELEMENT_NODE )
				{
					// ޤͤƽ
					$xmlDocOutput = $xmlOutputEntry->owner_document();
					$xmlOutputEntryData = $xmlDocOutput->create_element('entrydata');
					$xmlOutputEntryData->set_attribute('name', $node->get_attribute( "name" ) );
					$xmlOutputEntryData->set_attribute('caption', $node->get_attribute( "caption" ) );
					$xmlOutputEntryData->set_attribute('description', $node->get_attribute( 'description' ) );	// 2006.2.8 ѥ졼ɲб
					$xmlOutputEntryData->set_attribute('type', $node->get_attribute('type') );

					$item = EntryItemFactory::createEntryItem( $node, $this->entryName, $this->entryId	);
					$item->renderFormItemXML( $xpathEntry, $this->currentEntry, $xmlOutputEntryData );
					
					$xmlOutputEntry->append_child( $xmlOutputEntryData );
				}
			}
			
		}
		
		function renderFormXMLList( $xpathSchema, $xpathEntry, &$xmlOutputEntry )
		{
			// ޤθ֤߰λǡʤĤޤ귫֤ǤΥˤ롣
			$xmlSchemaListItemArr = $xpathSchema->xpath_eval( $this->currentSchema . "/listitem" );
			$xmlSchemaListItem = $xmlSchemaListItemArr->nodeset[0];	// listitemǤ1Ĥͭꤨʤ
			
			// ФѤι̾
			$titleItemNames = explode( ",", $xmlSchemaListItem->get_attribute('title') );
			
			if ( ! is_array( $titleItemNames ) )
			{
				// ޶ڤʣꤵƤʤñ֤ͤ١1Ǥˤ롣
				$titleItemNames = array( $titleItemNames );
			}
			
			$titleItemNamesArr = array();
			$titleItemTypesArr = array();
			
			if ( is_array( $titleItemNames )  )
			{
				// ̤ξ硢trimƶǤʤиФ̾˳Ǽ
				foreach( $titleItemNames as $titleItemName )
				{
					$titleItemName = trim( $titleItemName );
					if ( $titleItemName !== '' )
					{
						$xmlTitleItemArr = $xpathSchema->xpath_eval( $this->currentSchema . "/listitem/data[@name='{$titleItemName}']" );
						if ( count( cmsd_get_nodeset( $xmlTitleItemArr ) ) > 0 )	// ιܤ¸ߤ顣
						{
							$xmlTitleItem = $xmlTitleItemArr->nodeset[0];
							$titleItemNamesArr[] = $xmlTitleItem->get_attribute('name');
							$titleItemTypesArr[] = $xmlTitleItem->get_attribute('type');
						}
					}
				}
			}
			
			// ФܤǤʤСƬܤ򸫽ФȤ롣
			if ( count( $titleItemNamesArr ) <= 0 )
			{
				$xmlSchemaListItemFirstChildArr = $xpathSchema->xpath_eval( $this->currentSchema . "/listitem/data[@type!='separator'][1]" );	// 2006.11.14 ѹ ѥ졼ɲбб٤
				$xmlSchemaListItemFirstChild = $xmlSchemaListItemFirstChildArr->nodeset[0];	// ꥹȹκǽλҥ޹
				$titleItemNamesArr[0] = $xmlSchemaListItemFirstChild->get_attribute('name');
				$titleItemTypesArr[0] = $xmlSchemaListItemFirstChild->get_attribute('type');
			}
			
			
			// ֤ǥޤʸ롣
			$datacaption = convencoding_xml2html( $xmlSchemaListItem->get_attribute( 'caption' ) );
			
			// ȥθ֤߰λǡʤĤޤ귫֤ǤΥꥹȡˤ롣
			//$itemNodeName = $xmlSchemaNode->child_nodes()->nodeset[0]->get_attribute( 'name' );
			$xmlEntryNodeList = $xpathEntry->xpath_eval( $this->currentEntry . "/*" ); // $itemNodeName" );
			
			$xmlDocOutput = $xmlOutputEntry->owner_document();
			
			// ȥꥹȹܤλҥΡˡΡɤξ򣱹ԤĽϤ롣
			foreach( cmsd_get_nodeset( $xmlEntryNodeList ) as $nodeChild )
			{
				if ( $nodeChild->node_type() == XML_ELEMENT_NODE )
				{
					$listitemId = $nodeChild->get_attribute( 'id' );
					
					// ꥹȸФʣξ""Ϣ뤹ˡ
					$caption = '';	// 
					
					foreach( $titleItemNamesArr as $index=>$titleItemName )
					{
						if ( strlen( $caption ) > 0 ) { $caption .= ''; }
					
						$xmlTitleItemArr = $xpathEntry->xpath_eval( $this->currentEntry . "/listitem[@id='{$listitemId}']/{$titleItemName}" );
						if ( count( cmsd_get_nodeset( $xmlTitleItemArr ) ) <= 0 )
						{
							// ιܤ¸ߤʤä顢֤ͤ
							$caption .= "(̤)";
							continue;	// θФء
						}
						
						$xmlTitleItem = $xmlTitleItemArr->nodeset[0];
						
						switch (  $titleItemTypesArr[$index] )
						{
							// եξ硢ե̾ɽ
							case 'img':
							case 'file':
								// imgܤfileܤξ硢ƤեURLˤʤäƤĹΤǡꥸʥե̾򸫽ФȤ롣
								$caption .= file2code( $xmlTitleItem->get_attribute( 'org' ) );
								break;
							
							// ˥塼ξ硢襭ץɽ
							case 'menu':
								$menuId = $xmlTitleItem->get_content();
								$xmlSchemaMenuItemArr = $xpathSchema->xpath_eval( $this->currentSchema . "/listitem/data[@name='{$titleItemName}']/menuitem[@id='{$menuId}']" );
								
								if ( !empty($xmlSchemaMenuItemArr->nodeset) )
								{
									$caption .= file2code( $xmlSchemaMenuItemArr->nodeset[0]->get_content() );
								}
								else
								{
									$caption .= "()";
								}
								
								break;
							
							// ʳƤ򤽤Τޤ
							default:
								// ʳξϡƤ򸫽ФȤ롣
								$caption .= file2code( $xmlTitleItem->get_content() );
								break;
						}
						
					}
					
					$caption = mb_substr( $caption, 0, 50 );	// Ƭ50ʸǥåȤ롣
					
					// ǤIDϤ롣	
					$xmlOutputEntryData = $xmlDocOutput->create_element('entrydata');
					$xmlOutputEntryData->set_attribute('caption', fileconv($caption) );
					$xmlOutputEntryData->set_attribute('listid', $nodeChild->get_attribute( "id" ) );
					
					// ܤ֤ݻ롣
					if ( is_array( $this->selectedListItems ) and in_array( $nodeChild->get_attribute('id'), $this->selectedListItems ) )
					{
						$xmlOutputEntryData->set_attribute('selected', 'selected' );
					}
					
					$xmlOutputEntry->append_child( $xmlOutputEntryData );
				}
			}

		}
		
		/* ----------------------------------------------------------------
		 * ߤΥȥ곬ؤΥѥ󤯤ʥӥHTML롣
		 * 
		 */
		function createOutputSchemaLocation( $xpathSchema, $xpathEntry, &$xmlOutputLocation )
		{
			
			$schemaPath = $this->currentSchema;
			$entryPath = $this->currentEntry;
			
			// ؿμ
			$iMaxLevel = count( explode( '/', $schemaPath ) ) - 2;
			
			$iLevel = $iMaxLevel;  // ǲؤ饹ȡʥURLѤ
			
			$xmlDocOutput = $xmlOutputLocation->owner_document();
			$xmlOutputLocation->set_attribute('maxlevel', $iMaxLevel );
			
			while ( $schemaPath != "/schema" )
			{
				// ȥ꤫ꥹIDʥꥹȤʤ϶
				//print $entryPath;
				$xmlEntryArr = $xpathEntry->xpath_eval( $entryPath );
				$xmlEntry = $xmlEntryArr->nodeset[0];
				$listID = $xmlEntry->get_attribute('id');
				
				// ޤ饭ץ롣
				$xmlSchemaArr = $xpathSchema->xpath_eval( $schemaPath );
				$xmlSchema = $xmlSchemaArr->nodeset[0];
				$schemaCaption = $xmlSchema->get_attribute('caption');
				
				if ( !empty( $listID ) )
				{
					$schemaCaption .= '(' . $listID . ')';
				}
				
				$xmlOutputLocationItem = $xmlDocOutput->create_element('locationitem');
				$xmlOutputLocationItem->set_attribute('distance', $iMaxLevel - $iLevel );
				$xmlOutputLocationItem->set_attribute('level', $iLevel );
				$xmlOutputLocationItem->set_attribute('caption', $schemaCaption );
				$xmlOutputLocation->append_child( $xmlOutputLocationItem );
				
				// XPathγؤľ˾夬롣
				$schemaPath = $this->getUpperLevelXPathStr( $schemaPath );
				$entryPath = $this->getUpperLevelXPathStr( $entryPath );
				
				$iLevel --;
			}
			
		}
		
		/* ----------------------------------------------------------------
		 * ȥ깹դԽ٤Υ֥Ȥ롣
		 * 
		 */		
		function createSchemaDataForEntryDate( &$xmlDocSchema )
		{
			$xmlSchemaDataEntryDate = $xmlDocSchema->create_element( 'data' );
			$xmlSchemaDataEntryDate->set_attribute('name', 'cmsd_date');
			$xmlSchemaDataEntryDate->set_attribute('type', 'entrydate');
			$xmlSchemaDataEntryDate->set_attribute('caption', fileconv( 'ȥ깹' ));
			
			return $xmlSchemaDataEntryDate;
				
		}
			
	}
	
	


?>