<?php

	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/app.php.inc" );
	require_once( dirname(__FILE__) . "/xmlutil.php.inc" );
	require_once( dirname(__FILE__) . "/user.php.inc" );	// 2005.07.28 ɲáǡαΰ١
	//require_once( dirname(__FILE__) . "/viewtag.php.inc" );	// 2005.08.25 ɲá
	require_once( dirname(__FILE__) . "/cmsdconfig.php.inc" );	// 2005.09.22 ɲá

	// å󳫻
	//session_start();

	function dispview( $name, $kind )
	{
		// ȥIDꤹ롣
		$id = $kind;	// IDѤѿ$kind"index""recentry"ξϤΤޤ޻Ȥ
		if ( $kind == "entry" )
		{
			// "entry"ξϥꥯȤID롣
			$id = $_REQUEST["e"];		// 桼"e"
		}
		
		// HTML
		$v = new View( $name );
		$v->renderHTML( $id );
	}
	
	
	// ޾֤ʥꥹȹܤܤƱ֤
	// ex ) schemaInfoArr[ "data1" ][ "type" ]
	function getSchemaInfoByArray( $schemaName )
	{
		// array
		$array = array();
	
		// DOMμ
		$xmlDocSchema = domxml_open_file( App::createSchemaFilePath( $schemaName ) );
		$xpathSchema = $xmlDocSchema->xpath_new_context();
		
		$xmlSchemaDataArr = $xpathSchema->xpath_eval( "/schema//data" );
		
		foreach ( cmsd_get_nodeset( $xmlSchemaDataArr ) as $xmlSchemaData )
		{
			$name = $xmlSchemaData->get_attribute( 'name' );
			$attributes = $xmlSchemaData->attributes();
			
			$schemaInfo = array();
			foreach ( $attributes as $attribute )
			{
				$schemaInfo[ $attribute->name() ] = $attribute->value();
			}
			
			$array[ $name ] = $schemaInfo;
		}
		
		return $array;
		
	}
	
	
	class cmsview_common
	{
		function IsShowingClosedEntry()
		{
			return ( isset( $_GET['showclosedentry'] ) && $_GET['showclosedentry'] == 'yes' );
		}
	
		/* ---------------------------------------------------------------
		 * ꤷentryΥ̾Site.Config롣
		 * $entryName : ȥ̾
		 */
		function getSchemaName( $entryName )
		{
			// Site.Configꤵ줿ȥ롣
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			$xpath = $xmlDocSite->xpath_new_context();
			
			$xmlEntryConfig = $xpath->xpath_eval( "//entry[@name='" . $entryName . "']" );
			
			// 2005.7.7 ɲ
			if ( count( cmsd_get_nodeset( $xmlEntryConfig ) ) <= 0 )
			{
				//trigger_error( "site.config.xmlե'$entryName'Υȥޤ", E_USER_ERROR );
				cmsd_abort_proc( "site.config.xmlե'$entryName'Υȥޤ");
			}
			
			$schemaName = $xmlEntryConfig->nodeset[0]->get_attribute( "schema" );
			
			// 2005.7.7 ɲ
			if ( $schemaName == '' )
			{
				cmsd_abort_proc( "site.config.xmlե'$entryName'Υȥschema°ꤵƤޤ" );
			}
			
			return $schemaName;
		}
		
		
		function createXPathCondition( $groupKeyValue, $publishControl )
		{
			// ե饰Ӹ֤ξ
			$condForPublish = cmsview_common::createXPathConditionForPublish( $publishControl );
			
			// 롼פˤʹ
			if ( empty($groupKeyValue))
			{
				// 롼ץꤵƤʤСƼ롣
				/// 郎¸ߤС[]ǰϤࡣ
				if ( strlen($condForPublish) > 0 )
				{
					$cond = '[' . $condForPublish . ']';
				}
				else
				{
					$cond = '';
				}
			}
			else
			{
				// 롼ץꤵƤ顢롼פǹʤࡣ
				$condForGroup = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
				if ( strlen($condForGroup) > 0 )
				{
					if ( strlen($condForPublish) > 0 )
					{
						$cond = '[' . $condForPublish . ' and ' . $condForGroup . ']';
					}
					else
					{
						$cond = '[' . $condForGroup . ']';
					}
				}
				else
				{
					if ( strlen($condForPublish) > 0 )
					{
						$cond = '[' . $condForPublish . ']';
					}
					else
					{
						$cond = '';
					}
				}
			}
			
			//print htmlentities( $cond );
			return $cond;
		}
		
		function createXPathConditionForPublish( $publishControl )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", date('Y') );
			$sMonth = sprintf( "%02d", date('m') );
			$sDay = sprintf( "%02d", date('d') );
			$sHour = sprintf( "%02d", date('H') );
			$sMinute = sprintf( "%02d", date('i') );

			//$strToday = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
			$strToday = $sYear . $sMonth . $sDay . $sHour . $sMinute;
			
			// ָפġ帽彪λ ΤΤФＰ
			// ե饰䳫λ¸ߤʤäΥСȤθߴΰ٤ˡ餬̵ȥθＰˤ롣
			// XPathˤʸ羮ӤʤȽâʸξΤӲǽäΤǡ:-ʤɤ򳰤Ӥ뤳Ȥˤ
			
			//$cond = "( not(@visible) or @visible='True' )";
			//$cond = "(not( @visible='False' or ( @visible='True' and (( @startdate >= '$strToday' ) or ( @enddate <= '$strToday' )) )))";
			
			// ˡˤäƾＰѹ
			
			switch ( $publishControl )
			{
				// ɽ
				case 'none' :
					$cond = '';
					break;
				
				// Τ
				case 'on-off' :
					$cond = "not(@visible='False')";
					break;
				
				// ޡȤ
				case 'full' :
					$cond = "(not( @visible='False' or ( @startdate > '$strToday' ) or ( @enddate <= '$strToday' )))";
					break;
			}
			
			// ȥζɽ
			// showclosedentryѥ᡼"yes"ǳġƥĴ̤˥ѤξϡƸȤ롣
			if ( cmsview_common::IsShowingClosedEntry() and LoginManager::IsAuthed() )
			{
				$cond = "";
			}
			
			return $cond;
		}
		
		function escapeStringInXPath( $str )
		{
			if ( strstr( $str, "'" ) !== false )
			{
				$output = '';
				$arr = explode( "'", $str );
				foreach( $arr as $item )
				{
					if ( strlen( $output ) > 0 )
					{
						$output .= ",\"'\",";
					}
					$output .= "'" . fileconv( $item ) . "'";	// ʸ󤬥ޥХȤξ硢UTF-8ѴƤɬפ롣
				}
				$output = 'concat( ' . $output . ')';
			}
			else
			{
				$output = "'" . fileconv( $str ) . "'";	// ʸ󤬥ޥХȤξ硢UTF-8ѴƤɬפ롣
			}
			
			return $output;
		}
		
		/* ---------------------------------------------------------------
		 * 롼׾XPathξＰȤɽʸ֤
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 */
		function createXPathConditionForGroup( $groupKey )
		{
			$strCond = '';
			if ( is_array( $groupKey ) )
			{
				foreach ( $groupKey as $key => $value )
				{
					// value򥨥פ롣
					$escapedValue = cmsview_common::escapeStringInXPath( $value );
				
					// ñξʵ͡ˤθߴݻ̾"cmsd_singlekey"ꤵƤ顢̾άȤñ쥭ǹʤࡣ
					if ( $key == 'cmsd_singlekey' )
					{
						//$strCond = "groupkey='" . $value . "'";
						$strCond = "groupkey=" . $escapedValue;
						break;
					}
				
					// valueǤʤΤ߼¹ԡvalueäݤξ硢郎ꤵʤäȸƾɲäʤ
					if ( strlen($value) > 0 ) // boolȤӤȡ㤨"0"äƤʤɤfalseˤʤäƤޤΤNG
					{
						if ( ! empty( $strCond ) )
						{
							$strCond .= " and ";
						}
						//$strCond .= "(groupkey/@key='" . $key . "' and groupkey='" . $value . "')";
						//$strCond .= "(groupkey[@key='" . $key . "']='" . $value . "')";
						$strCond .= "(groupkey[@key='" . $key . "']=" . $escapedValue . ")";
					}
				}
			}
			else
			{
				//$strCond = "groupkey='" . $groupKey . "'";
				$strCond = "groupkey=" . cmsview_common::escapeStringInXPath( $groupKey );
			}
			
			return $strCond;
		}
		
		
		/* ---------------------------------------------------------------
		 * DOMѤhref°롣
		 * $entryId : ȥID
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 */
		function createUrlParamsForEntry( $entryId, $groupKey )
		{
			$href = "?eid=" . $entryId;

			if ( is_array( $groupKey ) )
			{
				foreach ( $groupKey as $key => $value )
				{
					$href .= '&' . urlencode($key) . '=' . urlencode($value);
				}
			}
			else
			{
				// ⤷ʤ
				// 롼ץ顼Ϥ줿ȤȤϡڡߤľܻꤵƤȤȤʤΤǡ
				// URLϤɬפϤʤ
			}
			
			return $href;
		}
		
		
		/* ---------------------------------------------------------------
		 * DOMѤrwhref°롣
		 * $entryId : ȥID
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 */
		function createRWUrlParamsForEntry( $entryId, $groupKey )
		{
			$rwhref = "eid/" . $entryId . ".html";

			return $rwhref;
		}
		
		
		/* ---------------------------------------------------------------
		 * DOM˥롼׾ɲä롣
		 * $pageno : ڡֹ
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 */
		function createUrlParamsForPage( $pageno, $groupKey, $sortKey = null )
		{
			$href = "?pageno=" . $pageno;

			if ( is_array( $groupKey ) )
			{
				foreach ( $groupKey as $key => $value )
				{
					$href .= '&' . urlencode($key) . '=' . urlencode($value);
				}
			}
			else
			{
				// ⤷ʤ
				// 롼ץ顼Ϥ줿ȤȤϡڡߤľܻꤵƤȤȤʤΤǡ
				// URLϤɬפϤʤ
			}
			
			if ( ! empty( $sortKey ) )
			{
				foreach ( $sortKey as $key => $value )
				{
					$href .= '&' . urlencode($key) . '=' . urlencode($value);
				}
			}
			
			return $href;
		}
		
		/* ---------------------------------------------------------------
		 * DOM˥롼׾ɲä롣
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 * &$xmlOutputRoot : ɲä֤DOMǡ
		 */
		function addGroupInfo( $groupKey, &$xmlOutputRoot )
		{
			// DOMɥȥ֥Ȥ
			$xmlDoc = $xmlOutputRoot->owner_document();
			
			// 롼׾ɲ
			if ( is_array( $groupKey ) )
			{
				foreach ( $groupKey as $key => $value )
				{
					$xmlGroup = $xmlDoc->create_element('group');
					$xmlGroup->set_attribute('key', $key);
					$xmlGroup->set_attribute('value', fileconv( $value ) );
					$xmlOutputRoot->append_child($xmlGroup);
				}
			}
			else
			{
				$xmlGroup = $xmlDoc->create_element('group');
				$xmlGroup->set_attribute( 'value', fileconv( $groupKey ) );
				$xmlOutputRoot->append_child($xmlGroup);
			}
			
		}
		
		/* ---------------------------------------------------------------
		 * DOM˥ѥ᡼ɲä롣
		 * $paramKey : ѥ᡼̾ʣѥ᡼ꤹ硢Ϣǻꤹ롣
		 * &$xmlOutputRoot : ɲä֤DOMǡ
		 */
		function addParamInfo( $paramKey, &$xmlOutputRoot )
		{
			// DOMɥȥ֥Ȥ
			$xmlDoc = $xmlOutputRoot->owner_document();
			
			// ѥ᡼ɲ
			foreach ( $paramKey as $key => $value )
			{
				$xmlParam = $xmlDoc->create_element('param');
				$xmlParam->set_attribute('key', $key);
				$xmlParam->set_attribute('value', fileconv( $value ) );
				$xmlOutputRoot->append_child($xmlParam);
			}
			
		}
		
		
		/* ---------------------------------------------------------------
		 * DOM˥롼׾ɲä롣
		 * $groupKey : 롼׾ʣ롼׾ꤹ硢Ϣǻꤹ롣
		 * &$xmlOutputRoot : ɲä֤DOMǡ
		 */
		function setGroupKeyValue( &$groupKeyValue )
		{
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			if ( is_array( $groupKeyValue ) )
			{
				foreach ( $groupKeyValue as $key=>$value )
				{
					// nullʤСꥯȤͤꤹ롣
					//if ( is_null($value) )
					if ( strlen( $value ) <= 0 ) //  2005.8.21 ѹ : is_nullȡޥɥά''ϤΤNGäempty0ꤵ줿ˤޤΤǡstrlen()<=0Ѥ
					{
						// ꥯȤ˻꤬Сꤹ롣
						if ( isset( $_REQUEST[$key] ) )
						{
							$groupKeyValue[$key] = $_REQUEST[$key];
						}
						else
						{
							// ꥯȤλ꤬ʤСܼΤ롣
							unset( $groupKeyValue[$key] );
							
						}
					}
				}
			}
			
		}
		
		function IsEntryPublished( &$xmlEntryRoot, $publishControl )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", date('Y') );
			$sMonth = sprintf( "%02d", date('m') );
			$sDay = sprintf( "%02d", date('d') );
			$sHour = sprintf( "%02d", date('H') );
			$sMinute = sprintf( "%02d", date('i') );

			//$strToday = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
			$strToday = $sYear . $sMonth . $sDay . $sHour . $sMinute;
			
			// ָפġ帽彪λ ΤΤФＰ
			// ե饰䳫λ¸ߤʤäΥСȤθߴΰ٤ˡ餬̵ȥθＰˤ롣
			// XPathˤʸ羮ӤʤȽâʸξΤӲǽäΤǡ:-ʤɤ򳰤Ӥ뤳Ȥˤ
			
			$startDate = $xmlEntryRoot->get_attribute('startdate');
			$endDate = $xmlEntryRoot->get_attribute('enddate');
			$visible = $xmlEntryRoot->get_attribute('visible');
			
			// ˡˤäƾＰѹ
			
			$isPublished = false;
			switch ( $publishControl )
			{
				// ɽ
				case 'none' :
					$isPublished = true;
					break;
				
				// Τ
				case 'on-off' :
					$isPublished = ( empty( $visible) or $visible != 'False' );
					break;
				
				// ޡȤ
				case 'full' :
					// ޤvisibleʤСŤȥΰٳϤ佪λȤȤˤʤΤ̵˸
					// ˡ⤷visibleFalseʤ顢̵丽ʸˤǤ̵λ帽ʸλˤǤ⡢̵
					$isPublished = ( empty( $visible ) or  ! ( $visible == 'False' or $startDate > $strToday or $endDate <= $strToday ) );	// бXPathƱˤ
					break;
			}
			
			return $isPublished;
		}
		
	}
	
	
	/* ---------------------------------------------------------------
	 * ȥ꣱ѥӥ塼饹
	 * ޡȥꡢǥӤĤHTML󥰤롣
	 */
	class entry_view
	{
		var $entryName = '';
		//var $designName = null;
		var $entryId = '';
		var $groupKeyValue = array();
		var $navigation = false;
		//var $xml = false;
		var $tagRemoving = false;
		
		var $paramKeyValue = array();	// 2005.9.25 Ƴ. xsltϤǡ˴ޤѥ᡼Ǽ
		var $interlock = false; // 2006.2.15 Ƴ. 줬 true λ eid  pageno Ϳǡeid ưŪϢư롣
		var $pageMaxRows = 10;	// 2006.2.16 ɲáϢưб
		var $inlineXslt = null;  // 2007.7.3 Ƴ. ʸľxsltͿǤ롣

		/* ---------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $entryName : ȥ̾
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function entry_view( $entryName, $entryId = null )
		{
			$this->entryName = $entryName;
			$this->entryId = $entryId;
		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼ɲá
		 * $entryName : ȥ̾
		 * $keyValue : ά̵URLˡ
		 */
		function addParamKey( $keyName, $keyValue = null )
		{
			if ( is_null( $this->paramKeyValue ) )
			{
				$this->paramKeyValue = array();
			}
			
			if ( is_null( $keyValue ) || $keyValue === '' )
			{
				$keyValue = getGETParam( $keyName, '' );
			}
			
			$this->paramKeyValue[ $keyName ] = $keyValue;
		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼õ
		 */
		function clearParamKey()
		{
			$this->paramKeyValue = array();
		}
		
		/* ---------------------------------------------------------------
		 * ʹ߾ɲá
		 * $keyName : ̾
		 * $keyValue : ͡ʾάREQUEST
		 */
		function addGroupKey( $keyName, $keyValue = null )
		{
			if ( is_null( $this->groupKeyValue ) )
			{
				$this->groupKeyValue = array();
			}

			$this->groupKeyValue[ $keyName ] = $keyValue;
			
			$this->navigationOn();
		}
		
		/* ---------------------------------------------------------------
		 * ʹ߾õ
		 */
		function clearGroupKey()
		{
			$this->navigationOff();
			$this->groupKeyValue = array();
		}
		
		/* ---------------------------------------------------------------
		 * ʥӥĤ롣
		 */
		function navigationOn()
		{
			$this->navigation = true;
		}
		
		/* ---------------------------------------------------------------
		 * ʥӥĤʤ
		 */
		function navigationOff()
		{
			$this->navigation = false;
		}
		
		/* ---------------------------------------------------------------
		 * ܺϢưԤ
		 */
		function interlockOn()
		{
			$this->interlock = true;
		}
		
		/* ---------------------------------------------------------------
		 * ܺϢưԤʤ
		 */
		function interlockOff()
		{
			$this->interlock = false;
		}
		
		/* ---------------------------------------------------------------
		 * ڡɽϢưѡˡ
		 */
		function setPageMaxRows( $value )
		{
			$this->pageMaxRows = $value;
		}
		
		/* ---------------------------------------------------------------
		 * ڡɽϢưѡˡ
		 */
		function getPageMaxRows()
		{
			return $this->pageMaxRows;
		}
		
		/* ---------------------------------------------------------------
		 * Ԥ
		 */
		function tagRemovingOn()
		{
			$this->tagRemoving = true;
		}

		/* ---------------------------------------------------------------
		 * Ԥʤʵ͡ˡ
		 */
		function tagRemovingOff()
		{
			$this->tagRemoving = false;
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT
		 * $xsltString : XSLʸꡣxmlxsl:stylesheetǤϼưŪ䴰롣
		 */
		function setInlineXslt( $xsltString )
		{
			$this->inlineXslt = $xsltString;
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT䴰ηǼ
		 */
		function getInlineXsltFull()
		{
			$xslt = '<?xml version="1.0" encoding="UTF-8" ?>' . "\n" .
					'<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">' . "\n" . 
					'<xsl:output method="xml" encoding="EUC-JP" omit-xml-declaration="yes" indent="no" />' . "\n";
					
			$xslt .= $this->inlineXslt;
			
			$xslt .= '</xsl:stylesheet>';
			
			return $xslt;

		}

		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣
		 * $designName : ǥ̾άXSLѴXMLϤ롣
		 */
		function outputxml( $designName = null )
		{
			print $this->output( $designName, true );
		}
		
		/* ---------------------------------------------------------------
		 * XHTMLȤƥȥϤ롣
		 * $designName : ǥ̾άԲġ
		 */
		function outputhtml( $designName )
		{
			print $this->output( $designName, false );
		}
		
		/* ---------------------------------------------------------------
		 * ȥΰľܽϤ롣
		 * $itemId : ̾άԲġ
		 */		
		function outputdata( $itemId )
		{
			print $this->output( $itemId, false, true );
		}
		
		
		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣
		 * $designName : ǥ̾άXSLѴXMLϤ롣
		 */
		function getxml( $designName = null )
		{
			return $this->output( $designName, true );
		}
		
		/* ---------------------------------------------------------------
		 * XHTMLȤƥȥϤ롣
		 * $designName : ǥ̾άԲġ
		 */
		function gethtml( $designName )
		{
			return $this->output( $designName, false );
		}
		
		/* ---------------------------------------------------------------
		 * ȥΰľܽϤ롣
		 * $itemId : ̾άԲġ
		 */		
		function getdata( $itemId )
		{
			return $this->output( $itemId, false, true );
		}
		
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $isXML : XSLTŬѤXMLΤޤ޽Ϥ뤫ɤ( true : XMLΤޤ޽Ϥ롣 )
		 */
		//function entry( $entryName, $designName = null, $entryId = '', $groupKeyValue = '', $showNavi = false, $isXML = false )		
		function output( $designName = null, $isXML = false, $onlyData = false )
		{
			// ѿ
			$entryName = $this->entryName;
			//$designName = $this->designName;
			$entryId = $this->entryId;
			$groupKeyValue = $this->groupKeyValue;
			$paramKeyValue = $this->paramKeyValue;
			//$isXML = $this->xml;
			$showNavi = $this->navigation;
			$tagRemoving = $this->tagRemoving;
			
			$interlock = $this->interlock;	// 2006.2.16 ɲáϢưб
			$pageNo = 0;	// 2006.2.16 ɲáϢưб
			$pageMaxRows = $this->pageMaxRows;	// 2006.2.16 ɲáϢưб
			
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $entryName );
			
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			cmsview_common::setGroupKeyValue( $groupKeyValue );
			
			// ڡֹμܺϢưѡ2006.02.16 ɲá
			if ( isset( $_REQUEST['pageno'] ) )
			{
				$pageNo = $_REQUEST['pageno'];
				
				// ڡֹ椬Ͱʳʤ顢ʤȤ롣
				if ( ! is_numeric( $pageNo ) )
				{
					$pageNo = 0;	// 0:ʤ
				}
			}
			
			
			// ȥIDά줿硢REQUEST롣
			if ( empty( $entryId ) and isset( $_REQUEST[ 'eid' ] ) )
			{
				$entryId = $_REQUEST[ 'eid' ];
			}
			
			// REQUESTǤʤ
			if ( empty( $entryId ) ) 
			{
				// ϢưONǡġڡֹ椬ꤵƤ顢"interlock"Ȥ롣
				if ( $interlock and $pageNo != 0 )
				{
					$entryId = 'interlock';
				}
				else
				{
					// ϢưͭǤʤ硢"top"ꤵ줿ΤȤߤʤ
					$entryId = 'top';
				}
			}
			
			//cmsd_abort_proc( "pageno='$pageNo', entryId='$entryId', interlock=" . ( $interlock == true ? 'True' : 'False' ) );
			
			// ȥID"top"ꤵ줿硢indexեƬȥŬѤ롣
			if ( $entryId == 'top' or $entryId == 'interlock' or $entryId == 'random' )
			{
				// indexDOM
		   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
				$xpathIndex = $xmlDocIndex->xpath_new_context();
				
				/*
				// ϢưΥȥϰϡʥڡ˹ʹ߾
				if ( $entryId == 'interlock' )
				{
					// ڡֹ椫饨ȥϰϤ
					$startPos = $pageMaxRows * ( $pageNo - 1) + 1;
					$endPos = $pageMaxRows * ( $pageNo );
					
					$rangecond = "[position()>=" . $startPos . " and position()<=" . $endPos . "]";
				}
				*/
				
				// 롼פˤʹ߾
				$cond = cmsview_common::createXPathCondition( $groupKeyValue, $entryConfig->publishControl );
				
				// ϢưΥȥ־pageNo  pageMaxRows ꡢڡƬȥ򸫤Ĥ롣
				if ( $entryId == 'interlock' )
				{
					$interlockEntryPos = $pageMaxRows * ( $pageNo - 1 ) + 1;
					$cond .= "[$interlockEntryPos]";
				}
				
				// ʹ
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond );
				
				//cmsd_abort_proc(	"/entrylist/entry" . $cond . '[' . $interlockEntryPos . ']' );
				
				// ̤¸ߤСΥȥID롣
				if ( !empty($xmlAllEntryRefArr->nodeset) )
				{
					if ( $entryId == 'interlock' or $entryId == 'top' )
					{
						// interlock ޤ top ξ硢̤ƬȥID롣
						$entryId = $xmlAllEntryRefArr->nodeset[0]->get_attribute('id');
					}
					elseif ( $entryId == 'random' )
					{
						// random ξ硢˰ӽФ
						$randomIndex = mt_rand( 0, count( $xmlAllEntryRefArr->nodeset ) - 1 );
						$entryId = $xmlAllEntryRefArr->nodeset[ $randomIndex ]->get_attribute('id');
					}
				}
				
				$xmlDocIndex->free();
			}
			
		
			// ̾μ
			$schemaName = cmsview_common::getSchemaName( $entryName );
			
			// ޾Ǽ
			$schemaInfoArr = getSchemaInfoByArray( $schemaName );

			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! $onlyData and ( ! $isXML || $designName ) )	// XMLꤸʤ̵ǥådesignNameꤵƤ̵ǥåonlyDataξϥåʤ
			{
				// âdesignNameꤵƤʤƤ⡢inlineXsltꤵƤʤ
				if ( strlen( $designName ) > 0 )
				{
			
					if ( ! file_exists( App::createXslFilePath( $schemaName, $designName ) ))
					{
						return "ե'" . App::createXslFilePath( $schemaName, $designName ) . "'ĤޤߥޥɤΥǥ̾λְ꤬äƤޤ";
					}
					
				}
				elseif ( strlen( $this->inlineXslt ) <= 0 )
				{
					return "ߥޥɤdesign°cmsd:designǤޤ";
				}
			
			

			}
			

			// Υȥե뤬¸ߤʤ硢äݤΥȥǡ롣
			if ( ! file_exists( App::createEntryFilePath( $entryName, $entryId ) ) )
			{
				// äݤΥȥǡnoentryǤ롣
				
				// DOM
				$xmlDocEntry = domxml_new_doc( '1.0' );
				
				// 롼ȥΡ'noentry'
				$xmlEntryRoot = $xmlDocEntry->add_root( 'noentry' );
			}
			else 
			{
				// ȥ꤬¸ߤʤ顢ȥɤ߹ǽѤ˲ù롣
							
				// ȥDOM
		   	 	$xmlDocEntry = domxml_open_file( App::createEntryFilePath( $entryName, $entryId ) );
	
				// DOMĥ꡼Ƥtext/textareaܤ򡢽ѤĴ롣
				trans_dom_for_output( $xmlDocEntry, $schemaInfoArr, $tagRemoving );
	
				// ȥDOMΥ롼Ǥ
				$xmlEntryRoot = $xmlDocEntry->document_element();
				
				// ġƥĴ̤˥󤷤Ƥʤ֤ξ硢noentryȤ롣
				if ( ! ( cmsview_common::IsEntryPublished( $xmlEntryRoot, $entryConfig->publishControl ) or ( LoginManager::IsAuthed() and cmsview_common::IsShowingClosedEntry() ) ) )
				//if ( ! cmsview_common::IsEntryPublished( $xmlEntryRoot ) and ! LoginManager::IsAuthed() and ! cmsview_common::IsShowingClosedEntry() )
				{
					// äݤΥȥǡnoentryǤ롣
					
					// DOM
					$xmlDocEntry = domxml_new_doc( '1.0' );
					
					// 롼ȥΡ'noentry'
					$xmlEntryRoot = $xmlDocEntry->add_root( 'noentry' );
					
				}
				else
				{
					//print "IsAuthed = " . ( LoginManager::IsAuthed() ? "True" : "False" ) . ", IsEntryPublished = " . ( cmsview_common::IsEntryPublished( $xmlEntryRoot ) ? "True" : "False" ) . ", IsShowingClosedEntry = " . ( cmsview_common::IsShowingClosedEntry()	? "True" : "False" ) . "<br />";
					
					// entryhref°ɲä롣
					$xmlEntryRoot->set_attribute('href', cmsview_common::createUrlParamsForEntry( $entryId, $groupKeyValue ) );
					
					// ڻƳ2005.05.12 for 1.0.0fentryrwhref°ɲä롣
					//$xmlEntryRoot->set_attribute('rwhref', cmsview_common::createRWUrlParamsForEntry( $entryId, $groupKeyValue ) );			
					
					// entrydaysago°ɲä롣
					set_daysago_attribute( $xmlEntryRoot );
				
					// ʥӥϥե饰TrueʤСʥӥϤ롣
					if ( $showNavi )
					{
						// indexDOM
				   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
						$xpathIndex = $xmlDocIndex->xpath_new_context();
						
						// 롼פˤʹ
						$cond = cmsview_common::createXPathCondition( $groupKeyValue, $entryConfig->publishControl );
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond );
						
						/*
						// 롼פˤʹ
						if ( empty($groupKeyValue))
						{
							// 롼ץꤵƤʤСƼ롣
							$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
						}
						else
						{
							// 롼ץꤵƤ顢롼פǹʤࡣ
							$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
							if ( strlen( $cond ) > 0 )
							{
								$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[$cond]" );
							}
							else
							{
								$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
							}
						}
						*/
					
						// 롼
						$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
					
						// Ȱ
						$entryPos = -1;	// 
						foreach ( cmsd_get_nodeset( $xmlAllEntryRefArr ) as $currEntryPos => $xmlEntryRef )
						{
							$currEntryId = $xmlEntryRef->get_attribute('id');
							//print $currEntryId . "=$entryId, ";
							if ( $currEntryId == $entryId )
							{
								$entryPos = $currEntryPos;
								break;
							}
						}
						
				
						if ( $entryPos >= 0 )
						{
							// naviǤ
							$xmlNavi = $xmlDocEntry->create_element('navi');
							$xmlNavi->set_attribute('position', $entryPos );
							$xmlNavi->set_attribute('allcount', $allEntryCount );
							
							// ȥ꤬¸ߤСprevǤɲ
							if ( $entryPos > 0	)
							{
								$xmlPrev = $xmlDocEntry->create_element('prev');
								$id = $xmlAllEntryRefArr->nodeset[$entryPos-1]->get_attribute('id');
								$xmlPrev->set_attribute('id', $id );
								$xmlPrev->set_attribute('href', cmsview_common::createUrlParamsForEntry( $id, $groupKeyValue ) );
								// ڻƳ2005.05.12 for 1.0.0frwhref°ɲä롣
								//$xmlPrev->set_attribute('rwhref', cmsview_common::createRWUrlParamsForEntry( $id, $groupKeyValue ) );
								$xmlNavi->append_child( $xmlPrev );
							}
						
							// ڡ¸ߤСnextǤɲ
							if ( $allEntryCount > $entryPos + 1 )
							{
								$xmlNext = $xmlDocEntry->create_element('next');
								$id = $xmlAllEntryRefArr->nodeset[$entryPos+1]->get_attribute('id');
								$xmlNext->set_attribute('id', $id );
								$xmlNext->set_attribute('href', cmsview_common::createUrlParamsForEntry( $id, $groupKeyValue ) );
								// ڻƳ2005.05.12 for 1.0.0frwhref°ɲä롣
								//$xmlNext->set_attribute('rwhref', cmsview_common::createRWUrlParamsForEntry( $id, $groupKeyValue ) );
								$xmlNavi->append_child( $xmlNext );
							}
						
							$xmlEntryRoot->append_child( $xmlNavi );
						}
						
						$xmlDocIndex->free();
						
					}
				}
			}
			
			// ǡܤΤߤνϥե饰ONʤСdesignNameǡ̾ȤߤʤƹܤΤߤϤƽλ롣
			if ( $onlyData )
			{
				$xpathEntry = $xmlDocEntry->xpath_new_context();
				$xmlDataArr = $xpathEntry->xpath_eval( "/entry/$designName" );
				if ( count( cmsd_get_nodeset( $xmlDataArr ) ) > 0 )
				{
					return convencoding_xml2html( $xmlDataArr->nodeset[0]->get_content() );
				}
				return;
			}
			
			// 롼פꤵƤ硢롼׾Ϥ롣
			if ( ! empty( $groupKeyValue ) )
			{
				cmsview_common::addGroupInfo( $groupKeyValue, $xmlEntryRoot );
			}
			
			// ѥ᡼ꤵƤ硢ѥ᡼Ϥ롣
			if ( ! empty( $paramKeyValue ) )
			{
				cmsview_common::addParamInfo( $paramKeyValue, $xmlEntryRoot );
			}
						
			// todayǤɲ
			set_today_info( $xmlEntryRoot );
			
			
			//print $xmlDocEntry->dump_mem( true, 'EUC-JP');
			
			/*
			$xslt = domxml_xslt_stylesheet_file( App::createXslFilePath( $schemaName, $designName) );
			$result = $xslt->process( $xmlDocEntry );
			print $result->dump_mem( true, 'EUC-JP' );
			*/
			
			if ( $isXML )
			{
				// ǥ̾nullξXSLѴʤ
				if ( $designName )
				{
					// XMLϤUTF-8
					$result = ADXslt::process( $xmlDocEntry, App::createXslFilePath( $schemaName, $designName), 'UTF-8' );
				}
				elseif ( $this->inlineXslt != null )
				{
					$result = ADXslt::process( $xmlDocEntry, $this->getInlineXsltFull(), 'UTF-8', true );	// Ǹ true ϡxsltʸȤϤ̣롣
				}
				else
				{
					// XMLϤUTF-8
					$result = $xmlDocEntry->dump_mem( true, 'UTF-8' );
				}
			}
			else
			{
				if ( $designName )
				{
					$result = ADXslt::process( $xmlDocEntry, App::createXslFilePath( $schemaName, $designName) );
				}
				else
				{
					$result = ADXslt::process( $xmlDocEntry, $this->getInlineXsltFull(), 'EUC-JP', true );	// Ǹ true ϡxsltʸȤϤ̣롣
				}
			}
			
			$xmlDocEntry->free();
			
			return $result;			
		}
	}
	

	
	/* ---------------------------------------------------------------
	 * ȥѥӥ塼饹
	 * ޡȥꡢǥӤĤHTML󥰤롣
	 */
	class entrylist_view
	{
		var $entryName = '';
		//var $designName = null;
		var $pageNo = '';
		var $groupKeyValue = array();
		var $navigation = true;
		//var $xml = false;
		var $tagRemoving = false;
		var $sorting = false;
		var $sortKeyValue = array();
		var $cols = 1;
		
		var $paramKeyValue = array();	// 2005.9.25 Ƴ. xsltϤǡ˴ޤѥ᡼Ǽ
		var $entryId = '';	// 2005.9.29 Ƴ. ɽƤʤ⤷ʤentryIdǼ
		
		var $interlock = false; // 2006.2.15 Ƴ. 줬 true λ pageno  eid Ϳǡpageno ưŪϢư롣
		
		var $inlineXslt = null;  // 2007.7.3 Ƴ. ʸľxsltͿǤ롣
		
		/* ---------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $entryName : ȥ̾
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function entrylist_view( $entryName, $pageNo = null )
		{
			$this->entryName = $entryName;
			
			// 'top'ξ硢1ꤵ줿Ȥߤʤ
			if ( $pageNo == 'top' )
			{
				$pageNo = 1;
				//$this->pageNo = 1;
			}
			
			if ( empty( $pageNo ) )
			{
				// ڡֹάξ硢URLˤưŪڤؤˤʤΤǡưŪ˥ʥӥOnˤ롣
				$this->navigationOn();
				$this->pageNo = null;
			}
			else
			{
				if ( is_numeric( $pageNo ) )
				{
					$this->navigationOff();		// ڡֹľܻξ硢ưŪ˥ʥӥOffˤ롣
					$this->pageNo = $pageNo;
				}
				else
				{
					cmsd_abort_proc( "ڡֹ('$pageNo')ꤵޤͤ'top'ꤷƤ" );
				}
			}
			
		}
		
		/* ---------------------------------------------------------------
		 * ȥID
		 * $entryId : ȥIDºݤ˥ɾǻꤹϵǡ̤URLѥ᡼롣
		 */
		function setEntryId( $entryId )
		{
			$this->entryId = $entryId;
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT
		 * $xsltString : XSLʸꡣxmlxsl:stylesheetǤϼưŪ䴰롣
		 */
		function setInlineXslt( $xsltString )
		{
			$this->inlineXslt = $xsltString;
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT䴰ηǼ
		 */
		function getInlineXsltFull()
		{
			$xslt = '<?xml version="1.0" encoding="UTF-8" ?>' . "\n" .
					'<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">' . "\n" . 
					'<xsl:output method="xml" encoding="EUC-JP" omit-xml-declaration="yes" indent="no" />' . "\n";
					
			$xslt .= $this->inlineXslt;
			
			$xslt .= '</xsl:stylesheet>';
			
			return $xslt;

		}
		
		/* ---------------------------------------------------------------
		 * åɷνϤ򤷤ꤹפꡣ
		 * $cols : 2ʾꡣ1ꤷ̾ΥȥϤˤʤ롣
		 */
		function setCols( $cols )
		{
			$this->cols = $cols;
		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼ɲá
		 * $entryName : ȥ̾
		 * $keyValue : ά̵URLˡ
		 */
		function addParamKey( $keyName, $keyValue = null )
		{
			if ( is_null( $this->paramKeyValue ) )
			{
				$this->paramKeyValue = array();
			}
			
			if ( is_null( $keyValue ) || $keyValue === '' )
			{
				$keyValue = getGETParam( $keyName, '' );
			}
			
			$this->paramKeyValue[ $keyName ] = $keyValue;
		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼õ
		 */
		function clearParamKey()
		{
			$this->paramKeyValue = array();
		}		
		
		/* ---------------------------------------------------------------
		 * ʹ߾ɲá
		 * $entryName : ȥ̾
		 * $keyValue : ά̵URLˡ
		 */
		function addGroupKey( $keyName, $keyValue = null )
		{
			if ( is_null( $this->groupKeyValue ) )
			{
				$this->groupKeyValue = array();
			}

			$this->groupKeyValue[ $keyName ] = $keyValue;
		}
		
		/* ---------------------------------------------------------------
		 * ʹ߾õ
		 */
		function clearGroupKey()
		{
			$this->groupKeyValue = array();
		}
		
		/* ---------------------------------------------------------------
		 * ʥӥĤ롣
		 */
		function navigationOn()
		{
			$this->navigation = true;
		}
		
		/* ---------------------------------------------------------------
		 * ʥӥĤʤ
		 */
		function navigationOff()
		{
			$this->navigation = false;
		}
		
		function interlockOn()
		{
			$this->interlock = true;
		}
		
		function interlockOff()
		{
			$this->interlock = false;
		}
		
		/* ---------------------------------------------------------------
		 * Ԥ
		 */
		function tagRemovingOn()
		{
			$this->tagRemoving = true;
		}

		/* ---------------------------------------------------------------
		 * Ԥʤʵ͡ˡ
		 */
		function tagRemovingOff()
		{
			$this->tagRemoving = false;
		}
		
		/* ---------------------------------------------------------------
		 * Ԥ
		 */
		function sortingOn()
		{
			$this->sorting = true;
		}

		/* ---------------------------------------------------------------
		 * Ԥʤʵ͡ˡ
		 */
		function sortingOff()
		{
			$this->sorting = false;
		}
		
		/* ---------------------------------------------------------------
		 * Ⱦɲá
		 * $entryName : ȥ̾
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function addSortKey( $sortId, $sortParams = null )
		{
			if ( is_null( $this->sortKeyValue ) )
			{
				$this->sortKeyValue = array();
			}

			$this->sortKeyValue[ $sortId ] = $sortParams;
			
			$this->sortingOn();
		}
		
		/* ---------------------------------------------------------------
		 *	Ⱦõ
		 */
		function clearSortKey()
		{
			$this->sortingOff();
			
			$this->sortKeyValue = array();
			
		}		
				
		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣
		 * $designName : ǥ̾άXSLѴXMLϤ롣
		 * $pageMaxRows : 1ڡιԿʾά=10* $pageMaxRows : 1
		 */
		function outputxml( $designName = null, $pageMaxRows = 10 )
		{
			print $this->outputcommon( $designName, $pageMaxRows, true );
		}
		
		/* ---------------------------------------------------------------
		 * XHTMLȤƥȥϤ롣
		 * $designName : ǥ̾άԲġ
		 * $pageMaxRows : 1ڡιԿʾά=10
		 */
		function outputhtml( $designName, $pageMaxRows = 10 )
		{
			print $this->outputcommon( $designName, $pageMaxRows, false );
		}
		
		
		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣ʥӥϤĤʤ
		 * $designName : RSSѴѤΥǥ̾
		 */
		function outputrss( $designName )
		{
			$this->navigationOff();
			print $this->outputcommon( $designName, 15, true );
		}
		
		
		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣
		 * $designName : ǥ̾άXSLѴXMLϤ롣
		 * $pageMaxRows : 1ڡιԿʾά=10* $pageMaxRows : 1
		 */
		function getxml( $designName = null, $pageMaxRows = 10 )
		{
			return $this->outputcommon( $designName, $pageMaxRows, true );
		}
		
		/* ---------------------------------------------------------------
		 * XHTMLȤƥȥϤ롣
		 * $designName : ǥ̾άԲġ
		 * $pageMaxRows : 1ڡιԿʾά=10
		 */
		function gethtml( $designName, $pageMaxRows = 10 )
		{
			return $this->outputcommon( $designName, $pageMaxRows, false );
		}
		
		
		/* ---------------------------------------------------------------
		 * XMLȤƥȥϤ롣ʥӥϤĤʤ
		 * $designName : RSSѴѤΥǥ̾
		 */
		function getrss( $designName )
		{
			$this->navigationOff();
			return $this->outputcommon( $designName, 15, true );
		}

		
		
		/* ---------------------------------------------------------------
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $pageMaxRows : 1ڡιԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $pageNo : ڡֹ档ʾάGETѥ᡼"pageno"
		 * $isRSS : RSSɤʾάfalse
		 * $isXML : XMLȤƽϤ뤫 (άfalse)
		 */
		//function listpage( $entryName, $designName = null, $pageMaxRows = 10, $groupKeyValue = '', $showNavi = true, $pageNo = NULL, $isRSS = false, $isXML = false )
		function outputcommon( $designName = null, $pageMaxRows = 10, $isXML = false )
		{		
			$entryName = $this->entryName;
			$pageNo = $this->pageNo;
			$groupKeyValue = $this->groupKeyValue;
			$paramKeyValue = $this->paramKeyValue;
			$showNavi = $this->navigation;
			$tagRemoving = $this->tagRemoving;
			
			$sorting = $this->sorting;
			$sortKeyValue = $this->sortKeyValue;
			
			$cols = $this->cols;
			$entryId = $this->entryId;
			$interlock = $this->interlock;	// 2006.2.15 ɲáϢưб
			
			
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $entryName );
			
			// ȥIDꤵƤʤ硢ȥIDURLѥ᡼ߤ
			// ΥȥIDϡ֥ȥȶˡɽƤʤ⤷ʤ˥ȥIDפǤ롣Ϣư׻ä˥ȥIDpagenoФ٤˻Ѥ롣
			if ( empty($entryId) and isset( $_REQUEST['eid'] ) )
			{
					$entryId = $_REQUEST['eid'];
			}
			
			// ڡֹμ
			if ( empty($pageNo) )	// pagenoľܻꤵƤʤ
			{
				if ( isset( $_REQUEST['pageno'] ) )		// ꥯȤåꤵƤpagenoɤ߹ࡣ
				{
					$pageNo = $_REQUEST['pageno'];
				}
			}
			
			if ( empty($pageNo) or !is_numeric($pageNo) )	// ޤpagenoǤƤʤǤƤƤͤ۾ä
			{
				if ( $interlock and ! empty($entryId) )	// ϢưǳġȥIDꤵƤ뤫
				{
					$pageNo = 0;	// 0:ϢưʸФ
				}
				else
				{
					$pageNo = 1;	// ǽΥڡֹꤹ롣
				}
			}
			
			// ̾μ
			$schemaName = cmsview_common::getSchemaName( $entryName );

			// ޾Ǽ
			$schemaInfoArr = getSchemaInfoByArray( $schemaName );

			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! $isXML || $designName )	// XMLꤸʤ̵ǥådesignNameꤵƤ̵ǥå
			{
				// âdesignNameꤵƤʤƤ⡢inlineXsltꤵƤʤ
				if ( strlen( $designName ) > 0 )
				{
			
					if ( ! file_exists( App::createListXslFilePath( $schemaName, $designName ) ))
					{
						return "ե'" . App::createListXslFileName( $schemaName, $designName ) . "'Ĥޤߥޥɤdesign°λְ꤬äƤޤ";
						return;
					}
				
				}
				elseif ( strlen( $this->inlineXslt ) <= 0 )
				{
					return "ߥޥɤdesign°cmsd:designǤޤ";
				}
				
			}
			
			// indexDOM
			if ( file_exists( App::createEntryFilePath( $entryName, 'index' ) ) )
			{
				// եɤ߹ࡣ
		   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
			}
			else
			{
				// indexե뤬̵硢ǶindexDOM롣
				$xmlDocIndex = domxml_new_doc( '1.0' );
			
				// 롼ȥΡ'entry'
				$xmlDocIndex->add_root( 'entrylist' );
			}
			
			// ꥢ륿ॽȡxmlDocIndexưŪ륽XSLTȤäƥȤ롣
			if ( $sorting )
			{
				// Ⱦ狼XSLTȤΩƤ롣
				$sortTags = '';
				
				foreach ( $sortKeyValue as $id => $params )
				{
					$sortTag = '<xsl:sort ';
					if ( empty( $params ) )
					{
						$params = '';
						if ( isset( $_REQUEST[ $id ] ) )
						{
							$params = $_REQUEST[ $id ];
						}
						$sortKeyValue[$id] = $params;
					}
					
					// ѥ᡼ƤΥå
					if ( ! preg_match( '/^[,@a-zA-Z0-9_-]*$/i', $params ) )	// ѿڤӥޤ@鹽ʸΤߵĤ롣2007.06.15 eregȤȥ˸Ǥޤ(?)Զ
					//if ( ! eregi( '^[,@a-zA-Z0-9_-]*$', $params ) )	// ѿڤӥޤ@鹽ʸΤߵĤ롣
					{
						print "ȥѥ᡼ʸѤޤ'$params'<br />";
						continue;
					}
					
					$select = '';
					$order = '';
					$dataType = '';
					$caseOrder = '';
					$lang = '';
					
					$paramsArr = explode( ",", $params );
					if ( isset( $paramsArr[0] ) ) { $select = $paramsArr[0]; }
					if ( isset( $paramsArr[1] ) ) { $order = $paramsArr[1]; }
					if ( isset( $paramsArr[2] ) ) { $dataType = $paramsArr[2]; }
					if ( isset( $paramsArr[3] ) ) { $caseOrder = $paramsArr[3]; }
					if ( isset( $paramsArr[4] ) ) { $lang = $paramsArr[4]; }
					
					//list( $select, $order, $dataType, $caseOrder, $lang ) = explode( ",", $params );
					
					if ( ! empty($select) )
					{
						if ( strpos( $select, '@' ) === false )	 // '==='ӤȡͤηޤӤ롣ñ==Ӥȡͤ0äfalseǧƤޤ
						{
							// @äƤʤȤȤϡ̾ꤵ줿ȤȡindexǤgroupkeyǤȤ¸ƤΤŬڤpathѴ롣
							$sortTag .= 'select="groupkey[@key=\'' . $select . '\']" ';
						}
						else
						{
							// @äƤȤȤϡ°̾ꤵ줿Ȥȡ
							$sortTag .= 'select="' . $select . '" ';
						}
					}
					
					if ( ! empty( $order ) )
					{
						switch ( $order )
						{
							case 'asc' :
								$order = 'ascending';
								break;
							
							case 'desc' :
								$order = 'descending';
								break;
							
							case 'ascending' :
							case 'descending' :
								break;
							
							default : 
								print "ȥѥ᡼orderͤꤵޤ'$order'<br />";
								continue;
						}
						
						$sortTag .= 'order="'. $order . '" ';
					}
					
					if ( ! empty( $dataType ) )
					{
						switch ( $dataType )
						{
							case 'text' :
							case 'number' :
								break;
							
							default : 
								print "ȥѥ᡼data-typeͤꤵޤ'$dataTyper'<br />";
								continue;
						}
						
						$sortTag .= 'data-type="'. $dataType . '" ';
					}
					
					if ( ! empty( $caseOrder ) )
					{
						switch ( $caseOrder )
						{
							case 'upper-first' :
							case 'lower-first' :
								break;
							
							default : 
								print "ȥѥ᡼case-orderͤꤵޤ'$caseOrder'<br />";
								continue;
						}
						
						$sortTag .= 'case-order="'. $caseOrder . '" ';
					}
					
					if ( ! empty( $lang ) )
					{
						$sortTag .= 'lang="'. $lang . '" ';
					}
					
					$sortTag .= '/>';
					
					// Ǥ⥽ȥꤵƤʤϡȾˤϲäʤ
					if ( ! empty( $select ) )
					{
						$sortTags .= $sortTag;
					}
					
				}
				
				// XSL
				$strXslSort = <<<EOD
<?xml version="1.0" encoding="EUC-JP"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">

<entrylist>

<xsl:for-each select="entrylist/entry">
$sortTags
<xsl:copy-of select="." />
</xsl:for-each>

</entrylist>

</xsl:template>
</xsl:stylesheet>
EOD;
				
				// Ƚ
				if ( ! empty( $sortTags ) )	// Ⱦ郎ĤʤϹԤʤ
				{
					$strXmlDocIndexSorted = ADXslt::processStrXsl( $xmlDocIndex, $strXslSort );
					//$xmlDocIndex = null;
					$xmlDocIndex->free();
					$xmlDocIndex = domxml_open_mem( $strXmlDocIndexSorted );
				}

			}
			
			
			$xpathIndex = $xmlDocIndex->xpath_new_context();
			$xmlIndexRoot = $xmlDocIndex->document_element();
			
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			cmsview_common::setGroupKeyValue( $groupKeyValue );
			
			// 롼׹ʹѤXPathʬʸ
			$cond = cmsview_common::createXPathCondition( $groupKeyValue, $entryConfig->publishControl );
			
			// ڡݥȥϢư 2006.2.16 ɲ
			if ( $pageNo == 0 )	//	0 : Ϣư
			{
				$xmlEntryIdArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond . '/@id' );
				
				if ( !empty($xmlEntryIdArr->nodeset) )
				{
					foreach ( cmsd_get_nodeset( $xmlEntryIdArr ) as $entryIndex=>$xmlEntryId )
					{
						if ( $xmlEntryId->value == $entryId )	// ҥåȡ
						{
							// ȥ֤ꡢΥȥ꤬ޤޤڡֹ׻ƥ롼פȴ롣
							$pageNo = floor( $entryIndex / $pageMaxRows ) + 1;
							break;
						}
					}
				}
				
				$xmlEntryIdArr = null;	// η̤פʤΤǤǳ
				
				// ڡֹ椬ꤷʤäϡͤ1Ȥ롣
				if ( $pageNo == 0 )
				{
					$pageNo = 1;
				}
			}
			
			
			// ڡֹ椫饨ȥϰϤ
			$startPos = $pageMaxRows * ( $pageNo - 1) + 1;
			$endPos = $pageMaxRows * ( $pageNo );
			
			// 롼פȥȥϰϤˤʹ
			$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond . "[position()>=" . $startPos . " and position()<=" . $endPos . "]");
			
			// DOM
			//$xmlDocOutput = domxml_new_doc( '1.0' );
			//$xmlOutputRoot = $xmlDocOutput->add_root( 'entrylist' );
			
			$strXmlOutput = '<?xml version="1.0" encoding="UTF-8"?>'. "\n";
			$strXmlOutput .= "<entrylist>\n";
			
			foreach( cmsd_get_nodeset( $xmlEntryRefArr ) as $entryIndex=>$xmlEntryRef )
			{
				// cols2ʾʤСrowǥȥ귲Ϥࡣ
				if ( $cols >= 2 and  ( $entryIndex % $cols ) == 0 )
				{
					$strXmlOutput .= "<row>\n";
				}
				
				// ȥDOM롣
				$href = $xmlEntryRef->get_attribute('href');
				$xmlDocEntry = domxml_open_file( App::createEntryDirPath( $entryName ) . $href );
				$xmlEntryRoot = $xmlDocEntry->document_element();
				
				// ȥhref°ɲä롣
				$xmlEntryRoot->set_attribute('href', cmsview_common::createUrlParamsForEntry( $xmlEntryRoot->get_attribute('id'), $groupKeyValue ));
				
				// ȥdaysago°ɲä롣
				set_daysago_attribute( $xmlEntryRoot );
				
				// ȥָ꤬ɽƤʤ⤷ʤ˥ȥפΥȥIDƱʤСĤ롣
				if ( $xmlEntryRoot->get_attribute('id') == $entryId )
				{
					$xmlEntryRoot->set_attribute('current', 'True');	// 'True'Ȥͤˤϰ̣ϤʤȤǤʤФ°Τ¸ߤʤΤǡXSL¦Ǥ<xsl:if test="@current">Ƚ񤱤ɤ
				}
				
				// ȥIDä˻ꤵƤʤä硢ڡǽΥȥ򥫥ȤȤ롣
				if ( strlen( $entryId ) <= 0 and $entryIndex == 0 )
				{
					$xmlEntryRoot->set_attribute('current', 'True');	// 'True'Ȥͤˤϰ̣ϤʤȤǤʤФ°Τ¸ߤʤΤǡXSL¦Ǥ<xsl:if test="@current">Ƚ񤱤ɤ
				}
				
				// ȥ򥳥ԡơDOMappend롣
				//$xmlOutputEntry = $xmlEntryRoot->clone_node();
				//$xmlOutputRoot->append_child( $xmlOutputEntry );
				
				$strXmlOutput .= $xmlDocEntry->dump_node( $xmlEntryRoot );
				
				// rowĤ롣
				if ( $cols >= 2 and  ( $entryIndex % $cols ) == ( $cols - 1 ) )
				{
					$strXmlOutput .= "</row>\n";
				}
				
				//unset( $xmlEntryRoot );
				//unset( $xmlDocEntry );
				
				$xmlDocEntry->free();
				
			}
			
			// rowĤϳå
			if ( count( cmsd_get_nodeset( $xmlEntryRefArr ) ) > 0 and $cols >= 2 and  ( $entryIndex % $cols ) != ( $cols - 1 ) )
			{
				$strXmlOutput .= "</row>\n";
			}
			
			$strXmlOutput .= "</entrylist>";
			
			// XMLDOM
			$xmlDocOutput = domxml_open_mem( $strXmlOutput );

			//print '<pre>' . htmlentities( mb_convert_encoding( $xmlDocOutput->dump_mem(true, 'UTF-8'), 'EUC-JP' , 'UTF-8' ), ENT_COMPAT, 'EUC-JP' )	. '</pre>';
						
			// DOMΥƥȹܤѤѴ
			trans_dom_for_output( $xmlDocOutput, $schemaInfoArr, $tagRemoving );
			
			
			// ʥӥɲ
			if ( $showNavi )
			{
				// 롼פˤʹ
				$cond = cmsview_common::createXPathCondition( $groupKeyValue, $entryConfig->publishControl );
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond );
				
				/*
				if ( empty($groupKeyValue))
				{
					// 롼ץꤵƤʤСƼ롣
					$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
				}
				else
				{
					// 롼ץꤵƤ顢롼פǹʤࡣ
   					$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
					if ( strlen( $cond ) > 0 )
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[" . $cond . "]" );
					}
					else
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
					}
				}
				*/
				
				// ڡΥȥ
				$pageEntryCount = count( cmsd_get_nodeset( $xmlEntryRefArr ) );
				// 롼ȥ
				$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
				// ڡ
				$maxPage = (int)( (int)$allEntryCount / (int)$pageMaxRows ) + (( $allEntryCount % $pageMaxRows > 0 ) ? 1 : 0 );
				
				$xmlOutputRoot = $xmlDocOutput->document_element();
				
				// naviǤ
				$xmlNavi = $xmlDocOutput->create_element('navi');
				$xmlNavi->set_attribute('position', $pageNo );
				$xmlNavi->set_attribute('allcount', $allEntryCount );
				$xmlNavi->set_attribute('maxpage', $maxPage );
				$xmlNavi->set_attribute('maxpagerows', $pageMaxRows );
				
				// ڡ¸ߤСprevǤɲ
				if ( $pageNo > 1  )
				{
					$xmlPrev = $xmlDocOutput->create_element('prev');
					$xmlPrev->set_attribute('id', $pageNo - 1 );
					$xmlPrev->set_attribute('href', cmsview_common::createUrlParamsForPage( $pageNo - 1, $groupKeyValue, $sortKeyValue ) );
					$xmlNavi->append_child( $xmlPrev );
				}
				
				// ¸ߤڡʬpageǤɲ
				for ( $index = 1; $index <= $maxPage; $index++ )
				{
					$xmlPage = $xmlDocOutput->create_element('page');
					$xmlPage->set_attribute('id', $index );
					$xmlPage->set_attribute('href', cmsview_common::createUrlParamsForPage( $index, $groupKeyValue, $sortKeyValue ) );
					$xmlNavi->append_child( $xmlPage );
				}
				
				// ڡ¸ߤСnextǤɲ
				if ( $allEntryCount > $pageMaxRows * $pageNo )
				{
					$xmlNext = $xmlDocOutput->create_element('next');
					$xmlNext->set_attribute('id', $pageNo + 1 );
					$xmlNext->set_attribute('href', cmsview_common::createUrlParamsForPage( $pageNo + 1, $groupKeyValue, $sortKeyValue ) );
					$xmlNavi->append_child( $xmlNext );
				}
				
				$xmlOutputRoot->append_child( $xmlNavi );
				
			}
			
			// DOMΥɥȥ롼Ǥ
			$xmlOutputRoot = $xmlDocOutput->document_element();
			
			// todayǤɲ
			set_today_info( $xmlOutputRoot );
			
			// 롼פꤵƤ硢롼׾Ϥ롣
			if ( ! empty( $groupKeyValue ) )
			{
				cmsview_common::addGroupInfo( $groupKeyValue, $xmlOutputRoot );
			}
			
			// ѥ᡼ꤵƤ硢ѥ᡼Ϥ롣
			if ( ! empty( $paramKeyValue ) )
			{
				cmsview_common::addParamInfo( $paramKeyValue, $xmlOutputRoot );
			}
			
			// ɽƤʤ⤷ʤ˥ȥIDϤ롣
			if ( ! empty( $entryId ) )
			{
				$xmlOutputRoot->set_attribute('currenteid', $entryId );
			}
			
			// XSLѴ
			if ( $isXML )
			{
				// ǥ̾nullξXSLѴʤ
				if ( $designName )
				{
					// XMLϤUTF-8
					$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( $schemaName, $designName), 'UTF-8' );
				}
				elseif ( $this->inlineXslt != null )
				{
					// XMLϤUTF-8
					$result = ADXslt::process( $xmlDocOutput, $this->getInlineXsltFull(), 'UTF-8', true );	// Ǹ true ϡxsltʸȤϤ̣롣
				}
				else
				{
					// XMLϤUTF-8
					$result = $xmlDocOutput->dump_mem( true, 'UTF-8' );	
				}
			}
			// ̾ΥڡɽѴ
			else
			{
				if ( $designName )
				{
					$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( $schemaName, $designName) );
				}
				else
				{
					$result = ADXslt::process( $xmlDocOutput, $this->getInlineXsltFull(), 'EUC-JP', true );	// Ǹ true ϡxsltʸȤϤ̣롣
				}
							
				
			}
			
			$xmlDocOutput->free();
			return $result;
			
		}
		
	}		



	/* ---------------------------------------------------------------
	 * ѥӥ塼饹
	 * ꤵ줿ȥեꥭɤǸ̤˥ǥŬѤ֤
	 */
	class searchresult_view
	{
		var $entryName = '';
		var $targetFolders = array();
		var $inlineXslt = null;  // ʸľxsltͿǤ롣
		
		/* ---------------------------------------------------------------
		 * 󥹥ȥ饯
		 */
		function searchresult_view()
		{
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT
		 * $xsltString : XSLʸꡣxmlxsl:stylesheetǤϼưŪ䴰롣
		 */
		function setInlineXslt( $xsltString )
		{
			$this->inlineXslt = $xsltString;
		}
		
		/* ---------------------------------------------------------------
		 * 饤XSLT䴰ηǼ
		 */
		function getInlineXsltFull()
		{
			$xslt = '<?xml version="1.0" encoding="UTF-8" ?>' . "\n" .
					'<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">' . "\n" . 
					'<xsl:output method="xml" encoding="EUC-JP" omit-xml-declaration="yes" indent="no" />' . "\n";
					
			$xslt .= $this->inlineXslt;
			
			$xslt .= '</xsl:stylesheet>';
			
			return $xslt;

		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼ɲá
		 * $entryName : ȥ̾
		 * $keyValue : ά̵URLˡ
		 */
		function addTarget( $name, $title, $pageurl )
		{
			$this->targetFolders[ $name ] = array( $name, $title, $pageurl );
		}
		
		/* ---------------------------------------------------------------
		 * 桼ѥ᡼õ
		 */
		function clearTarget()
		{
			$this->targetFolders = array();
		}
		
		function output( $designName, $rows )
		{
			$p_encoding = getGETParam( "encoding", "EUC-JP" );
			$p_words = getGETParam( "words", "" );
			$p_rows = getGETParam( "rows", 100 );
			
			switch ( mb_strtoupper($p_words) )
			{
				case "UTF-8":
				case "EUC-JP":
				case "SHIFT_JIS":
					$encoding = $p_words;
					break;
				
				default:
					$encoding = "EUC-JP";
					break;
			}
			
			$p_words = mb_substr( trim( $p_words ), 0, 100, $encoding );
			$p_words = mb_convert_encoding( $p_words, "UTF-8", $encoding );	// XMLʸȤӤΰ١UTF-8Ѵ
			$words = explode( " ", $p_words );
			
			// 0ξ硢URLѥ᡼Ѥ롣
			if ( $rows == 0 )
			{
				$rows = $p_rows;
			}
			
			// ѤDOM
			$xmlDocOutput = domxml_new_doc( '1.0' );
		
			// 롼ȥΡ'entrylist'
			$xmlOutputRoot = $xmlDocOutput->add_root( 'entrylist' );
			
			// ɤDOMꡣ
			$xmlOutputSearchWord = $xmlDocOutput->create_element( 'searchword' );
			$xmlOutputSearchWord->set_content( $p_words );
			$xmlOutputRoot->append_child( $xmlOutputSearchWord );
			
			// ʸ󤬻ꤵƤ顢¹
			if ( strlen( $p_words ) > 0 )
			{
				$maxRows = (int)$rows;
				foreach( $this->targetFolders as $target )
				{
					list( $entryName, $title, $pageUrl ) = $target;
					$maxRows = $this->outputTarget( $xmlDocOutput, $words, $entryName, $title, $pageUrl, $designName, $maxRows );
					
					// ͤʸʤ顢顼ʤΤǤ֤ƽλ
					if ( is_string( $maxRows ) )
					{
						 return $maxRows;
					}
				}
			}
			
			// XSLѴ
			// ̾ΥڡɽѴ
			//$result = $xmlDocOutput->dump_mem( true, "UTF-8" );
			if ( $designName )
			{
				$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( "cmsd_system", $designName) );
			}
			else
			{
				$result = ADXslt::process( $xmlDocOutput, $this->getInlineXsltFull(), 'EUC-JP', true );	// Ǹ true ϡxsltʸȤϤ̣롣
			}
			
			$xmlDocOutput->free();
			return $result;
			
		}
		
		/* ---------------------------------------------------------------
		 * μ¹Ԥӡ̤ɽ
		 * $entryName : ȥ̾
		 * $title : ȥѹ̾
		 * $pageurl : ȥɽѥڡURL
		 * $designName : XSL륷̾
		 */
		function outputTarget( &$xmlDocOutput, $searchWords, $entryName, $title, $pageUrl, $designName, $maxRows )
		{
			/*	
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $entryName );
			
			// ̾μ
			$schemaName = cmsview_common::getSchemaName( $entryName );
			
			// ޾Ǽ
			$schemaInfoArr = getSchemaInfoByArray( $schemaName );
			*/
			
			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			// âdesignNameꤵƤʤƤ⡢inlineXsltꤵƤʤ
			if ( strlen( $designName ) > 0 )
			{
			
				if ( ! file_exists( App::createListXslFilePath( "cmsd_system", $designName ) ))
				{
					return "ե'" . App::createListXslFileName( "cmsd_system", $designName ) . "'Ĥޤߥޥɤdesign°λְ꤬äƤޤ";
				}
			
			}
			elseif ( strlen( $this->inlineXslt ) <= 0 )
			{
				return "ߥޥɤdesign°cmsd:designǤޤ";
			}
			
			// indexDOM
			if ( file_exists( App::createEntryFilePath( $entryName, 'index' ) ) )
			{
				// եɤ߹ࡣ
		   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
			}
			else
			{
				// indexե뤬̵硢ǶindexDOM롣
				$xmlDocIndex = domxml_new_doc( '1.0' );
			
				// 롼ȥΡ'entry'
				$xmlDocIndex->add_root( 'entrylist' );
			}
			
			// ǥåѤXPath
			$xpathIndex = $xmlDocIndex->xpath_new_context();
			$xmlIndexRoot = $xmlDocIndex->document_element();
			
			/*
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			cmsview_common::setGroupKeyValue( $groupKeyValue );
			
			// 롼׹ʹѤXPathʬʸ
			$cond = cmsview_common::createXPathCondition( $groupKeyValue, $entryConfig->publishControl );
			
			// 롼פȥȥϰϤˤʹ
			$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" . $cond . "[position()>=" . $startPos . " and position()<=" . $endPos . "]");
			*/
			
			// Configɤ߹
			$siteConfig = new CMSSiteConfig();
			$entryConfig = $siteConfig->getEntryConfig( $entryName );
			
			// 롼׹ʹѤXPathʬʸ
			$cond = cmsview_common::createXPathCondition( null, $entryConfig->publishControl );
			
			// ǥåΥȥ껲ǰ
			$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry". $cond );
			
			// DOMΥ롼Ǥ
			$xmlOutputRoot = $xmlDocOutput->document_element();
			
			foreach( cmsd_get_nodeset( $xmlEntryRefArr ) as $entryIndex=>$xmlEntryRef )
			{
				
				// ȥDOM롣
				$href = $xmlEntryRef->get_attribute('href');
				$xmlDocEntry = domxml_open_file( App::createEntryDirPath( $entryName ) . $href );
				
				// ȥǡʸǼ
				$entryData = $xmlDocEntry->dump_mem( false, 'UTF-8' );
				
				// 
				$entryData = preg_replace( "/<[\/\!]*?[^<>]*?>/u", "", $entryData );
				
				// 󥨥
				//$entryData = html_entity_decode( $entryData, ENT_QUOTES, "UTF-8" );
				$entryData = unhtmlentities( $entryData );
				
				// ٥
				$entryData = preg_replace( "/<[\/\!]*?[^<>]*?>/u", "", $entryData );
				
				// 
				//$entryData = str_replace( "&", "&amp;", $entryData );
				$entryData = htmlspecialchars( $entryData, ENT_QUOTES, "UTF-8" );
				
				//print $entryData;
				
				// ɤ˥ҥåȤ뤫
				$hit = true;
				foreach( $searchWords as $searchWord )
				{
					$pos = mb_strpos( $entryData, $searchWord, 0, "UTF-8" );
					if ( $pos === false )
					{
						$hit = false;
						break;
					}
				}
				
				// ҥåȤ顢̤ɲä롣
				if ( $hit )
				{
					// ȥǤ
					$xmlOutputEntry = $xmlDocOutput->create_element('entry');
				
					// ȥ꥿ȥʸ
					$xmlEntryRoot = $xmlDocEntry->document_element();
					$xmlEntryTitleArr = $xmlEntryRoot->get_elements_by_tagname( $title );
					if ( empty( $xmlEntryTitleArr ) )
					{
						return "cmsd:searchtargettitle°˻ꤵ줿ܤĤޤ";
					}
					$titleString = $xmlEntryTitleArr[0]->get_content();
				
					// ϥȥhref°ɲä롣
					$xmlOutputEntry->set_attribute('id', $xmlEntryRoot->get_attribute('id'));
					
					// ϥȥhref°ɲä롣
					$xmlOutputEntry->set_attribute('href', cmsview_common::createUrlParamsForEntry( $xmlEntryRoot->get_attribute('id'), null ));
					
					// ϥȥhref°ɲä롣
					$xmlOutputEntry->set_attribute('url', $pageUrl . cmsview_common::createUrlParamsForEntry( $xmlEntryRoot->get_attribute('id'), null ));
					
					// ϥȥtitleɲä
					$xmlOutputEntryTitle = $xmlDocOutput->create_element("title");
					$xmlOutputEntryTitle->set_content( $titleString );
					$xmlOutputEntry->append_child( $xmlOutputEntryTitle );
					
					// ϥȥbodyɲä
					$xmlOutputEntryBody = $xmlDocOutput->create_element("body");
					$xmlOutputEntryBody->set_content( $entryData );
					$xmlOutputEntry->append_child( $xmlOutputEntryBody );
					
					// ϥȥϤɲä롣
					$xmlOutputRoot->append_child( $xmlOutputEntry );
					
					// ĤϿ򸺤餹
					$maxRows--;
				}
				
				//unset( $xmlEntryRoot );
				//unset( $xmlDocEntry );
				
				$xmlDocEntry->free();
				
				// ĤϿ0ˤʤä롼פȴ
				if ( $maxRows <= 0 )
				{
					break;
				}
			}
			
			return $maxRows;
			
		}
		
	}		





	/* ---------------------------------------------------------------
	 * ӥ塼饹
	 * ޡȥꡢǥӤĤHTML󥰤롣
	 */
 	class cmsview
	{

		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $isXML : XSLTŬѤXMLΤޤ޽Ϥ뤫ɤ( true : XMLΤޤ޽Ϥ롣 )
		 */
		function entry( $entryName, $designName = null, $entryId = '', $groupKeyValue = '', $showNavi = false, $isXML = false )
		{

			// ꥹȥ֥
			$v = new entry_view( $entryName, $entryId );
			
			// 롼׹ʹ߾
			if ( is_array( $groupKeyValue ) )
			{
				foreach( $groupKeyValue as $key=>$value )
				{
					$v->addGroupKey( $key, $value );
				}
			}
			else
			{
				if ( strlen( $groupKeyValue ) > 0 )
				{
					$v->addGroupKey( "cmsd_singlekey", $groupKeyValue );	// "cmsd_singlekey"̾ϡ͸ߴΰ٤̤ʥ̾ñ쥭Ȥƽ롣
				}
			}
			
			// ʥӥON/OFF
			if ( $showNavi )
			{
				$v->navigationOn();
			}
			else
			{
				$v->navigationOff();
			}
			
			// Ϸ
			if ( $isXML )
			{
				// RSSνϡϡXMLν
				$v->outputxml( $designName );
			}
			else
			{
				// ̾HTML
				$v->outputhtml( $designName );
			}
			
		}
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $isXML : XSLTŬѤXMLΤޤ޽Ϥ뤫ɤ( true : XMLΤޤ޽Ϥ롣 )
		 */
		function old_entry( $entryName, $designName = null, $entryId = '', $groupKeyValue = '', $showNavi = false, $isXML = false )
		{
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			cmsview_common::setGroupKeyValue( $groupKeyValue );
			/*
			if ( is_array( $groupKeyValue ) )
			{
				foreach ( $groupKeyValue as $key=>$value )
				{
					if ( is_null($value) )
					{
						$groupKeyValue[$key] = $_REQUEST[$key];
					}
				}
			}
			*/
			
			// ȥIDά줿硢REQUEST롣
			if ( empty( $entryId ) )
			{
				$entryId = $_REQUEST[ 'eid' ];
			}
			
			// REQUESTǤʤ硢"top"ꤵ줿ΤȤߤʤ
			if ( empty( $entryId ) ) 
			{
				$entryId = 'top';
			}
			
			// ȥID"top"ꤵ줿硢indexեƬȥŬѤ롣
			if ( $entryId == 'top')
			{
				// indexDOM
		   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
				$xpathIndex = $xmlDocIndex->xpath_new_context();
				 
				// 롼פˤʹ
				if ( empty($groupKeyValue))
				{
					// 롼ץꤵƤʤСƼ롣
					$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[position()=1]" );
				}
				else
				{
					// 롼ץꤵƤ顢롼פǹʤࡣ
					$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
					if ( strlen( $cond ) > 0 )
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[$cond][position()=1]" );
					}
					else
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[position()=1]" );
					}
				}
				
				// ̤¸ߤСΥȥID롣
				if ( !empty($xmlAllEntryRefArr->nodeset) )
				{
					$entryId = $xmlAllEntryRefArr->nodeset[0]->get_attribute('id');
				}
				
			}
			
		
			// ̾μ
			$schemaName = cmsview_common::getSchemaName( $entryName );

			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! $isXML || $designName )	// XMLꤸʤ̵ǥådesignNameꤵƤ̵ǥå
			{	
				if ( ! file_exists( App::createXslFilePath( $schemaName, $designName ) ))
				{
					print "XSL file doesn't exists.'";
					return;
				}
			}
			

			// Υȥե뤬¸ߤʤ硢äݤΥȥǡ롣
			if ( ! file_exists( App::createEntryFilePath( $entryName, $entryId ) ) )
			{
				// äݤΥȥǡnoentryǤ롣
				
				// DOM
				$xmlDocEntry = domxml_new_doc( '1.0' );
				
				// 롼ȥΡ'noentry'
				$xmlEntryRoot = $xmlDocEntry->add_root( 'noentry' );
			}
			else 
			{
				// ȥ꤬¸ߤʤ顢ȥɤ߹ǽѤ˲ù롣
							
				// ȥDOM
		   	 	$xmlDocEntry = domxml_open_file( App::createEntryFilePath( $entryName, $entryId ) );
	
				// DOMĥ꡼Ƥtext/textareaܤ򡢽ѤĴ롣
				trans_dom_for_output( $xmlDocEntry );
	
				// ȥDOMΥ롼Ǥ
				$xmlEntryRoot = $xmlDocEntry->document_element();
	
				// entryhref°ɲä롣
				$xmlEntryRoot->set_attribute('href', cmsview_common::createUrlParamsForEntry( $entryId, $groupKeyValue ) );
				
				// entrydaysago°ɲä롣
				set_daysago_attribute( $xmlEntryRoot );
			
				// ʥӥϥե饰TrueʤСʥӥϤ롣
				if ( $showNavi )
				{
					// indexDOM
			   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
					$xpathIndex = $xmlDocIndex->xpath_new_context();
					 
					// 롼פˤʹ
					if ( empty($groupKeyValue))
					{
						// 롼ץꤵƤʤСƼ롣
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
					}
					else
					{
						// 롼ץꤵƤ顢롼פǹʤࡣ
						$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
						if ( strlen( $cond ) > 0 )
						{
							$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[$cond]" );
						}
						else
						{
							$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
						}
					}
				
					// 롼
					$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
				
					// Ȱ
					$entryPos = -1;	// 
					foreach ( cmsd_get_nodeset( $xmlAllEntryRefArr ) as $currEntryPos => $xmlEntryRef )
					{
						$currEntryId = $xmlEntryRef->get_attribute('id');
						//print $currEntryId . "=$entryId, ";
						if ( $currEntryId == $entryId )
						{
							$entryPos = $currEntryPos;
							break;
						}
					}
			
					if ( $entryPos >= 0 )
					{
						// naviǤ
						$xmlNavi = $xmlDocEntry->create_element('navi');
						$xmlNavi->set_attribute('position', $entryPos );
						$xmlNavi->set_attribute('allcount', $allEntryCount );
						
						// ȥ꤬¸ߤСprevǤɲ
						if ( $entryPos > 0	)
						{
							$xmlPrev = $xmlDocEntry->create_element('prev');
							$id = $xmlAllEntryRefArr->nodeset[$entryPos-1]->get_attribute('id');
							$xmlPrev->set_attribute('id', $id );
							$xmlPrev->set_attribute('href', cmsview_common::createUrlParamsForEntry( $id, $groupKeyValue ) );
							$xmlNavi->append_child( $xmlPrev );
						}
					
						// ڡ¸ߤСnextǤɲ
						if ( $allEntryCount > $entryPos + 1 )
						{
							$xmlNext = $xmlDocEntry->create_element('next');
							$id = $xmlAllEntryRefArr->nodeset[$entryPos+1]->get_attribute('id');
							$xmlNext->set_attribute('id', $id );
							$xmlNext->set_attribute('href', cmsview_common::createUrlParamsForEntry( $id, $groupKeyValue ) );
							$xmlNavi->append_child( $xmlNext );
						}
					
						$xmlEntryRoot->append_child( $xmlNavi );
					}
					
				}
			}
			
			// 롼פꤵƤ硢롼׾Ϥ롣
			if ( ! empty( $groupKeyValue ) )
			{
				cmsview_common::addGroupInfo( $groupKeyValue, $xmlEntryRoot );
			}
			
			//print $xmlDocEntry->dump_mem( true, 'EUC-JP');
			
			/*
			$xslt = domxml_xslt_stylesheet_file( App::createXslFilePath( $schemaName, $designName) );
			$result = $xslt->process( $xmlDocEntry );
			print $result->dump_mem( true, 'EUC-JP' );
			*/
			
			if ( $isXML )
			{
				if ( $designName )
				{
					// XMLϤUTF-8
					$result = ADXslt::process( $xmlDocEntry, App::createXslFilePath( $schemaName, $designName), 'UTF-8' );
				}
				else
				{
					// XMLϤUTF-8
					$result = $xmlDocEntry->dump_mem( true, 'UTF-8' );
				}
			}
			else
			{
				$result = ADXslt::process( $xmlDocEntry, App::createXslFilePath( $schemaName, $designName) );
			}
			
			print $result;

			
		}
		
		
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽʥʥӥդˡ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function navi_entry( $entryName, $designName = 'default', $groupKeyValue = '' )
		{
			cmsview::entry( $entryName, $designName, "", $groupKeyValue, true );
		}
		
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽʥʥӥ̵ˡ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function xml_entry( $entryName, $designName = null, $entryId = '', $groupKeyValue = '' )
		{
			cmsview::entry( 
				$entryName, 
				$designName, 			
				$entryId, 					// $entryId
				$groupKeyValue, 
				false, 					// $showNavi
				true 					// $isXML
			);
		}
		
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽʥʥӥդˡ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾ʾά"default"
		 * $entryId : ȥIDʾάREQUEST"eid"
		 */
		function xml_navi_entry( $entryName, $designName = null, $entryId = '', $groupKeyValue = '' )
		{
			cmsview::entry( 
				$entryName, 
				$designName, 			
				$entryId, 					// $entryId
				$groupKeyValue, 
				true, 					// $showNavi
				true 					// $isXML
			);
		}
		
		
		/* ---------------------------------------------------------------
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $pageMaxRows : 1ڡιԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $pageNo : ڡֹ档ʾάGETѥ᡼"pageno"
		 * $isRSS : RSSɤʾάfalse
		 * $isXML : XMLȤƽϤ뤫 (άfalse)
		 */
		function listpage( $entryName, $designName = null, $pageMaxRows = 10, $groupKeyValue = '', $showNavi = true, $pageNo = NULL, $isRSS = false, $isXML = false )
		{
			// ꥹȥ֥
			$v = new entrylist_view( $entryName, $pageNo );
			
			// 롼׹ʹ߾
			if ( is_array( $groupKeyValue ) )
			{
				foreach( $groupKeyValue as $key=>$value )
				{
					$v->addGroupKey( $key, $value );
				}
			}
			else
			{
				if ( strlen( $groupKeyValue ) > 0 )
				{
					$v->addGroupKey( "cmsd_singlekey", $groupKeyValue );	// "cmsd_singlekey"̾ϡ͸ߴΰ٤̤ʥ̾ñ쥭Ȥƽ롣
				}
			}
			
			// ʥӥON/OFF
			if ( $showNavi )
			{
				$v->navigationOn();
			}
			else
			{
				$v->navigationOff();
			}
			
			// Ϸ
			if ( $isRSS or $isXML )
			{
				// RSSνϡϡXMLν
				$v->outputxml( $designName, $pageMaxRows );
			}
			else
			{
				// ̾HTML
				$v->outputhtml( $designName, $pageMaxRows );
			}
		}

		/* ---------------------------------------------------------------
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $pageMaxRows : 1ڡιԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 * $showNavi : ʥӥϤ뤫ɤ
		 * $pageNo : ڡֹ档ʾάGETѥ᡼"pageno"
		 * $isRSS : RSSɤʾάfalse
		 * $isXML : XMLȤƽϤ뤫 (άfalse)
		 */
		function old_listpage( $entryName, $designName = null, $pageMaxRows = 10, $groupKeyValue = '', $showNavi = true, $pageNo = NULL, $isRSS = false, $isXML = false )
		{
			
			// ڡֹμ
			if ( empty($pageNo) )
			{
				$pageNo = $_REQUEST['pageno'];
			}
			if ( empty($pageNo) or !is_numeric($pageNo) )
			{
				$pageNo = 1;
			}
			
			// ̾μ
			$schemaName = cmsview_common::getSchemaName( $entryName );

			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! $isXML || $designName )	// XMLꤸʤ̵ǥådesignNameꤵƤ̵ǥå
			{
				if ( ! file_exists( App::createListXslFilePath( $schemaName, $designName ) ))
				{
					print "XSL file doesn't exists.'";
					return;
				}
			}
			
			// indexDOM
			if ( file_exists( App::createEntryFilePath( $entryName, 'index' ) ) )
			{
				// եɤ߹ࡣ
		   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
			}
			else
			{
				// indexե뤬̵硢ǶindexDOM롣
				$xmlDocIndex = domxml_new_doc( '1.0' );
			
				// 롼ȥΡ'entry'
				$xmlDocIndex->add_root( 'entrylist' );
			}
			
			$xpathIndex = $xmlDocIndex->xpath_new_context();
			$xmlIndexRoot = $xmlDocIndex->document_element();
			
			// ȥϰϤη
			$startPos = $pageMaxRows * ( $pageNo - 1) + 1;
			$endPos = $pageMaxRows * ( $pageNo );
			
			// 롼׾郎nullǻꤵƤ 'key'=>null ˡ롼׻ѥ᡼ɤ߹ࡣ
			cmsview_common::setGroupKeyValue( $groupKeyValue );
			/*
			if ( is_array( $groupKeyValue ) )
			{
				foreach ( $groupKeyValue as $key=>$value )
				{
					if ( is_null($value) )
					{
						$groupKeyValue[$key] = $_REQUEST[$key];
					}
				}
			}
			*/
			
			// 롼פˤʹ
			if ( empty($groupKeyValue))
			{
				// 롼ץꤵƤʤСƼ롣
				$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[position()>=" . $startPos . " and position()<=" . $endPos . "]");
			}
			else
			{
				// 롼ץꤵƤ顢롼פǹʤࡣ
				$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
				//print $cond;
				if ( strlen( $cond) > 0 )
				{
					$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[" . $cond . "][position()>=" . $startPos . " and position()<=" . $endPos . "]" );
				}
				else
				{
					$xmlEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[position()>=" . $startPos . " and position()<=" . $endPos . "]" );
				}
			
			}
			
			// DOM
			//$xmlDocOutput = domxml_new_doc( '1.0' );
			//$xmlOutputRoot = $xmlDocOutput->add_root( 'entrylist' );
			
			$strXmlOutput = '<?xml version="1.0" encoding="UTF-8"?>'. "\n";
			$strXmlOutput = "<entrylist>\n";
			
			foreach( cmsd_get_nodeset( $xmlEntryRefArr ) as $xmlEntryRef )
			{
				// ȥDOM롣
				$href = $xmlEntryRef->get_attribute('href');
				$xmlDocEntry = domxml_open_file( App::createEntryDirPath( $entryName ) . $href );
				$xmlEntryRoot = $xmlDocEntry->document_element();
				
				// ȥhref°ɲä롣
				$xmlEntryRoot->set_attribute('href', cmsview_common::createUrlParamsForEntry( $xmlEntryRoot->get_attribute('id'), $groupKeyValue ));
				
				// ȥdaysago°ɲä롣
				set_daysago_attribute( $xmlEntryRoot );
				
				// ȥ򥳥ԡơDOMappend롣
				//$xmlOutputEntry = $xmlEntryRoot->clone_node();
				//$xmlOutputRoot->append_child( $xmlOutputEntry );
				
				$strXmlOutput .= $xmlDocEntry->dump_node( $xmlEntryRoot );
				
			}
			
			$strXmlOutput .= "</entrylist>";
			
			// XMLDOM
			$xmlDocOutput = domxml_open_mem( $strXmlOutput );

			//print '<pre>' . htmlentities( mb_convert_encoding( $xmlDocOutput->dump_mem(true, 'UTF-8'), 'EUC-JP' , 'UTF-8' ), ENT_COMPAT, 'EUC-JP' )	. '</pre>';
						
			// DOMΥƥȹܤѤѴ
			trans_dom_for_output( $xmlDocOutput );
			
			// ʥӥɲ
			if ( $showNavi )
			{
				// 롼פˤʹ
				if ( empty($groupKeyValue))
				{
					// 롼ץꤵƤʤСƼ롣
					$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
				}
				else
				{
					// 롼ץꤵƤ顢롼פǹʤࡣ
   					$cond = cmsview_common::createXPathConditionForGroup( $groupKeyValue );
					if ( strlen( $cond ) > 0 )
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[" . $cond . "]" );
					}
					else
					{
						$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
					}
				}
				
				// ڡΥȥ
				$pageEntryCount = count( cmsd_get_nodeset( $xmlEntryRefArr ) );
				// 롼ȥ
				$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
				// ڡ
				$maxPage = ( $allEntryCount / $pageMaxRows ) + (( $allEntryCount % $pageMaxRows > 0 ) ? 1 : 0 );
				
				$xmlOutputRoot = $xmlDocOutput->document_element();
				
				// naviǤ
				$xmlNavi = $xmlDocOutput->create_element('navi');
				$xmlNavi->set_attribute('position', $pageNo );
				$xmlNavi->set_attribute('allcount', $allEntryCount );
				$xmlNavi->set_attribute('maxpage', $maxPage );
				$xmlNavi->set_attribute('maxpagerows', $pageMaxRows );
				
				// ڡ¸ߤСprevǤɲ
				if ( $pageNo > 1  )
				{
					$xmlPrev = $xmlDocOutput->create_element('prev');
					$xmlPrev->set_attribute('id', $pageNo - 1 );
					$xmlPrev->set_attribute('href', cmsview_common::createUrlParamsForPage( $pageNo - 1, $groupKeyValue ) );
					$xmlNavi->append_child( $xmlPrev );
				}
				
				// ¸ߤڡʬpageǤɲ
				for ( $index = 1; $index <= $maxPage; $index++ )
				{
					$xmlPage = $xmlDocOutput->create_element('page');
					$xmlPage->set_attribute('id', $index );
					$xmlPage->set_attribute('href', cmsview_common::createUrlParamsForPage( $index, $groupKeyValue ) );
					$xmlNavi->append_child( $xmlPage );
				}
				
				// ڡ¸ߤСnextǤɲ
				if ( $allEntryCount > $pageMaxRows * $pageNo )
				{
					$xmlNext = $xmlDocOutput->create_element('next');
					$xmlNext->set_attribute('id', $pageNo + 1 );
					$xmlNext->set_attribute('href', cmsview_common::createUrlParamsForPage( $pageNo + 1, $groupKeyValue ) );
					$xmlNavi->append_child( $xmlNext );
				}
				
				$xmlOutputRoot->append_child( $xmlNavi );
				
			}
			
			// 롼פꤵƤ硢롼׾Ϥ롣
			if ( ! empty( $groupKeyValue ) )
			{
				cmsview_common::addGroupInfo( $groupKeyValue, $xmlDocOutput->document_element() );
			}
			
			// XSLѴ
			if ( $isRSS )
			{
				$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( $schemaName, $designName), 'UTF-8' );
			}
			// XMLΤޤ޽ϡXSLѴʤ
			else if ( $isXML )
			{
				// ǥ̾nullξXSLѴʤ
				if ( $designName )
				{
					// XMLϤUTF-8
					$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( $schemaName, $designName), 'UTF-8' );
				}
				else
				{
					// XMLϤUTF-8
					$result = $xmlDocOutput->dump_mem( true, 'UTF-8' );	
				}
			}
			// ̾ΥڡɽѴ
			else
			{
				$result = ADXslt::process( $xmlDocOutput, App::createListXslFilePath( $schemaName, $designName) );
			}
			print $result;
			
			/*
			$xslt = domxml_xslt_stylesheet_file( App::createListXslFilePath( $schemaName, $designName) );
			$result = $xslt->process( $xmlDocOutput );
			print $result->dump_mem( true, 'EUC-JP' );
			*/
			
			/*
			//$xmlXsl = domxml_open_file( App::createListXslFilePath( $schemaName, $designName) );
			
			$strXml = $xmlDocOutput->dump_mem( true, 'UTF-8' );
			//$strXsl = $xmlXsl->dump_mem( true, 'UTF-8' );
			
			//print "XML string : '<pre>" . htmlconv( $strXml ) . "</pre>'";
			//print "XSL string : '<pre>" . htmlconv( $strXsl ) . "</pre>'";
			
			$xslt = xslt_create();
			$result = xslt_process( $xslt, 'arg:/_xml', App::createListXslFilePath( $schemaName, $designName), NULL, array( '/_xml' => $strXml ) );

			xslt_free( $xslt );
			
			// EUC-JPѴϤ롣
			print $result;
			//print( mb_convert_encoding( $result, "EUC-JP", "UTF-8" ) ); 
			*/
			
		}

		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $rows : ɽԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 */
		function listtop( $entryName, $designName, $rows = 5, $groupKeyValue = '' )
		{
			cmsview::listpage( $entryName, $designName, $rows, $groupKeyValue, false, 1 );
		}

		/* ---------------------------------------------------------------
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $pageMaxRows : 1ڡιԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 * $pageNo : ڡֹ档ʾάGETѥ᡼"pageno"
		 * $isRSS : RSSɤʾάfalse
		 * $isXML : XMLȤƽϤ뤫 (άfalse)
		 */
		function xml_listpage( $entryName, $designName = null, $pageMaxRows = 10, $groupKeyValue = '', $pageNo = NULL )
		{
			cmsview::listpage( 
				$entryName, 
				$designName, 
				$pageMaxRows, 
				$groupKeyValue, 
				true,					// $showNavi
				$pageNo, 				// $pageNo
				false, 					// $isRSS
				true 					// $isXML
			);
		}
				
		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $rows : ɽԿʾά=10
		 * $groupKeyValue : 롼ץʾά=ʤ
		 */
		function xml_listtop( $entryName, $designName = null, $rows = 5, $groupKeyValue = '' )
		{
			cmsview::listpage( 

				$entryName, 
				$designName, 
				$rows, 
				$groupKeyValue, 
				false, 		// $showNavi 
				1, 			// $pageNo
				false,		// $isRSS
				true 		// $isXML
			);
		}
		
		/* ---------------------------------------------------------------
		 * ȥ1ɽ
		 * ȥꥹȤɽ
		 * $entryName : ȥ̾
		 * $designName : XSL륷̾
		 * $groupKeyValue : 롼ץʾά=ʤ
		 */
		function rss( $entryName, $designName, $groupKeyValue = '' )
		{
			cmsview::listpage( $entryName, $designName, 15, $groupKeyValue, false, 1, true );
		}
		
		
		
		
		
		function entrynavi( $entryName, $groupKeyValue = '', $entryId = NULL )
		{
			// ȥIDμ
			if ( empty($entryId) )
			{
				$entryId = $_REQUEST['eid'];
			}
	
			// indexDOM
	   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
			$xpathIndex = $xmlDocIndex->xpath_new_context();
			
			// 롼פˤʹ
			if ( empty($groupKeyValue))
			{
				// 롼ץꤵƤʤСƼ롣
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
			}
			else
			{
				// 롼ץꤵƤ顢롼פǹʤࡣ
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[groupkey='" . $groupKeyValue . "']" );
			}
			
			// 롼
			$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
			
			// Ȱ
			$entryPos = -1;	// 
			foreach ( cmsd_get_nodeset( $xmlAllEntryRefArr ) as $currEntryPos => $xmlEntryRef )
			{
				$currEntryId = $xmlEntryRef->get_attribute('id');
				//print $currEntryId . ", ";
				if ( $currEntryId == $entryId )
				{
					$entryPos = $currEntryPos;
					break;
				}
			}
		
			if ( $entryPos >= 0 )
			{
				if ( $entryPos > 0	)
				{
					print '<a href="?eid=' . $xmlAllEntryRefArr->nodeset[$entryPos-1]->get_attribute('id') . '">Υȥ</a> ';
				}
			
				print ($entryPos + 1) . 'ܤΥȥ ' . $allEntryCount . ' ';
				
				if ( $allEntryCount > $entryPos + 1 )
				{
					print ' <a href="?eid=' . $xmlAllEntryRefArr->nodeset[$entryPos+1]->get_attribute('id') . '">Υȥ</a>';
				}
			
				print '<br />';
			}
			else
			{
				print "Such entryId doesn't exists.<br />";
			}
			
		}
		
		
		function pagenavi( $entryName, $pageMaxRows = 10, $groupKeyValue = '', $pageNo = NULL )
		{
			// ڡֹμ
			if ( empty($pageNo) )
			{
				$pageNo = $_REQUEST['pageno'];
			}
			if ( empty($pageNo) or !is_numeric($pageNo) )
			{
				$pageNo = 1;
			}
			
			// indexե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! file_exists( App::createEntryFilePath( $entryName, 'index' ) ) )
			{
				print "Index file doesn't exists.'";
				return;
			}
			
			// indexDOM
	   	 	$xmlDocIndex = domxml_open_file( App::createEntryFilePath( $entryName, 'index' ) );
			$xpathIndex = $xmlDocIndex->xpath_new_context();
			
			// ȥϰϤη
			$startPos = $pageMaxRows * ( $pageNo - 1) + 1;
			$endPos = $pageMaxRows * ( $pageNo );
			
			// 롼פˤʹ
			if ( empty($groupKeyValue))
			{
				// 롼ץꤵƤʤСƼ롣
				$xmlPageEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[position()>=" . $startPos . " and position()<=" . $endPos . "]");
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry" );
			}
			else
			{
				// 롼ץꤵƤ顢롼פǹʤࡣ
				$xmlPageEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[groupkey='" . $groupKeyValue . "'][position()>=" . $startPos . " and position()<=" . $endPos . "]" );
				$xmlAllEntryRefArr = $xpathIndex->xpath_eval( "/entrylist/entry[groupkey='" . $groupKeyValue . "']" );
			}
			
			
			$pageEntryCount = count( cmsd_get_nodeset( $xmlPageEntryRefArr ) );
			$allEntryCount = count( cmsd_get_nodeset( $xmlAllEntryRefArr ) );
			
			if ( $pageNo > 1  )
			{
				print '<a href="?pageno=' . ( $pageNo - 1 ) . '">Υڡ</a> ';
			}
			
			print $pageNo . 'ڡ ' . $allEntryCount . ' ';
			
			if ( $allEntryCount > $pageMaxRows * $pageNo )
			{
				print ' <a href="?pageno=' . ( $pageNo + 1 ) . '">Υڡ</a>';
			}
			
			print '<br />';
			
		}
		
		
	}
	
	/* ---------------------------------------------------------------
	 * ȥΡɤդֺפȤ򻻽Фdaysago°Ȥɲä롣
	 * $xmlEntry : ȥΥΡɡ
	 */	
	function set_daysago_attribute( &$xmlEntry )
	{
		$year = intval( $xmlEntry->get_attribute('year') );
		$month = intval( $xmlEntry->get_attribute('month') );
		$day = intval( $xmlEntry->get_attribute('day') );
		$hour = intval( $xmlEntry->get_attribute('hour') );
		$minute = intval( $xmlEntry->get_attribute('minute') );
		
		// ȥ
		$dtEntry = mktime( 0, 0, 0, $month, $day, $year );	// ϴޤ᤺˷׻
		// 
		$dtNow = mktime(0, 0, 0);	// ϴޤ᤺˷׻롣
		
		$daysago = intval(($dtNow - $dtEntry) / ( 24 * 60 * 60 ));
		
		$xmlEntry->set_attribute('daysago', $daysago );
		
		// time°ɲäƤʤ硢ɲä롣
		if ( $xmlEntry->get_attribute('time') === '' )
		{
			$xmlEntry->set_attribute('time', mktime( $hour, $minute, 0, $month, $day, $year ) );
		}
		
	}
	
	/* ---------------------------------------------------------------
	 * ȥΡɤդվɲä롣
	 * $xmlEntry : ȥΥΡɡ
	 */	
	function set_today_info( &$xmlEntry )
	{
		// time
		$dtNow = time();
	
		// ǯʬ
		$sYear = sprintf( "%04d", date( "Y", $dtNow ) );
		$sMonth = sprintf( "%02d", date( "m", $dtNow ) );
		$sDay = sprintf( "%02d", date( "d", $dtNow ) );
		$sHour = sprintf( "%02d", date( "H", $dtNow ) );
		$sMinute = sprintf( "%02d", date( "i", $dtNow ) );
		$sSecond = sprintf( "%02d", date( "s", $dtNow ) );
		$timezone_offset = date( "Z", $dtNow );
		
		// ׻롣
		$arrWeekday = array( 'sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat' );
		$iWeekday = date('w', $dtNow );
		$sWeekday = $arrWeekday[ $iWeekday ];
		
		// ʸ
		$strDate = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
		
		// todayǤ
		$doc = $xmlEntry->owner_document();
		$xmlToday = $doc->create_element( 'today' );
		
		$xmlToday->set_content( $strDate );
		$xmlToday->set_attribute( 'year', $sYear );
		$xmlToday->set_attribute( 'month', $sMonth );
		$xmlToday->set_attribute( 'day', $sDay );
		$xmlToday->set_attribute( 'hour', $sHour );
		$xmlToday->set_attribute( 'minute', $sMinute );
		$xmlToday->set_attribute( 'second', $sSecond );	
		$xmlToday->set_attribute( 'weekday', $sWeekday );
		$xmlToday->set_attribute( 'time', $dtNow );
		$xmlToday->set_attribute( 'tzoffset', $timezone_offset );
		
		$xmlEntry->append_child( $xmlToday );
	}
	
	/* ---------------------------------------------------------------
	 * DOMĥ꡼ƤΥƥȹܤɽѤѴ롣
	 * $xmlDocEntry : ȥDOM
	 * $tagRemoving : 뤫ʾά͡falseʤʤˡ
	 */	
	function trans_dom_for_output( &$xmlDocEntry, $schemaInfoArr, $tagRemoving = false )
	{
		$xpathEntry = $xmlDocEntry->xpath_new_context();
		$xmlTextNodeArr = $xpathEntry->xpath_eval("//*[@output!='']");

		foreach ( cmsd_get_nodeset( $xmlTextNodeArr ) as $xmlTextNode )
		{
			$strText = $xmlTextNode->get_content();
			$outputMode = $xmlTextNode->get_attribute('output');
			
			// ޾μ
			$tagname = $xmlTextNode->node_name();
			$schemaInfo = null;
			if ( isset( $schemaInfoArr[ $tagname ] ) )
			{
				$schemaInfo = $schemaInfoArr[ $tagname ];
				
				if ( isset( $schemaInfo[ 'output' ] ) )
				{
					// ޾󤬤Фͥ褹롣
					$outputMode = $schemaInfo[ 'output' ];
				}
			}
			
			// ONʤСԤ
			if ( $tagRemoving )
			{
				$strText = preg_replace( "/<[\/\!]*?[^<>]*?>/u", "", $strText );
				XmlUtil::deleteTextNode( $xmlTextNode );
				$strText = htmlspecialchars( $strText, ENT_QUOTES );
				$xmlTextNode->set_content( $strText );
			}
			else	// OFFʤСƼѴԤ
			{
			
				switch ( $outputMode )
				{
					case 'text1' :
						
						break;
				
					case 'text2' :
						$strText = htmlentities( $strText, ENT_COMPAT, 'UTF-8' );
						$strText = htmlentities( $strText, ENT_COMPAT, 'UTF-8' );
						
						// URLμư󥯡autolinkξΤߡ htmlentities˼ư󥯤ȡ󥯤ΤΤפ١ǽ롣
						if ( isset( $schemaInfo[ 'autolink' ] ) and $schemaInfo[ 'autolink' ] == 'True' )
						{
							$strText = autolink_html( $strText );
						}
						
						$strText = nl2br( $strText ); //str_replace( "\n", '<br />&#13;', $strText );
						XmlUtil::deleteTextNode( $xmlTextNode );
						$xmlTextNode->set_content( $strText );
					
						break;
				
					case 'html1' :
					
						break;
					
					case 'html2' :
						// URLμư󥯡autolinkξΤߡ
						if ( isset( $schemaInfo[ 'autolink' ] ) and $schemaInfo[ 'autolink' ] == 'True' )
						{
							$strText = autolink_html( $strText );
						}
						$strText = nl2br_html( $strText );
						XmlUtil::deleteTextNode( $xmlTextNode );
						$strText = htmlspecialchars( $strText, ENT_QUOTES );
						$xmlTextNode->set_content( $strText );
						break;
				
				}
			}
		}
	}
	
	// html_entity_decodeؿPHP4ĶǤMBCSбƤʤ١
	function unhtmlentities($string)
	{
		// ͥƥƥִ
		$string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
		$string = preg_replace('~&#([0-9]+);~e', 'chr(\\1)', $string);
		
		// ʸƥƥִ
		$trans_tbl = get_html_translation_table(HTML_ENTITIES);
		$trans_tbl = array_flip($trans_tbl);
		
		return strtr($string, $trans_tbl);
	}	
	
	// ʸ˽и URL ưŪ˥󥯤AǰϤˡpregϤȤäƤ١UTF-8ʳԲġ
	function autolink_html( $strText )
	{
		// 2007.6.15 eregϴؿȤȥ˸Ǥޤ(?)Τ򤹤١pregϤ֤
		$strText = preg_replace("/([^=\"']|^)(https?|ftp)(:\\/\\/[[:alnum:]\+\$\;\?\.%,!#~*\\/:@&=_-]+)/ui", "\\1<a href=\"\\2\\3\" >\\2\\3</a>", $strText);
		//$strText = ereg_replace("([^=\"']|^)(https?|ftp)(://[[:alnum:]\+\$\;\?\.%,!#~*/:@&=_-]+)", "\\1<a href=\"\\2\\3\" >\\2\\3</a>", $strText);
		
		return $strText;
	}
	
	// ʸ˽иԤ<br />Ĥ롣ΥľβԤѴʤpregϤȤäƤ١UTF-8ʳԲġ
	function nl2br_html( $str )
	{
		$strArr = preg_split( "/(\n?<(?:pre|script|style|iframe|PRE|SCRIPT|STYLE|IFRAME)[^>]*>\n?|\n?<\/(?:pre|script|style|iframe|PRE|SCRIPT|STYLE|IFRAME)[^>]*>\n?)/u", $str, -1, PREG_SPLIT_DELIM_CAPTURE );
		//$strArr = preg_split( "/(\n?<pre[^>]*>\n?|\n?<\/pre[^>]*>\n?|\n?<PRE[^>]*>\n?|\n?<\/PRE[^>]*>\n?)/", $str, -1, PREG_SPLIT_DELIM_CAPTURE );

		$strResult = '';
		$countTextSections = 0;
		$mode = 'nopre';
		foreach ( $strArr as $tok )
		{
			//$tok = '(**' . $tok . '**)';	// ȡڤФåѥǥХåʸ
		
			//if ( preg_match( "/<pre[^>]*>|<PRE[^>]*>/", $tok ) )
			if ( preg_match( "/<(pre|script|style|iframe)[^>]*>/u", strtolower( $tok ) ) )
			{
				// pre,script,object,iframeϥȯ顢⡼ɤpreˤ롣
				$countTextSections ++;
				
				if ( $countTextSections > 0 )
				{
					$mode = 'pre';
				}
				$strResult .= $tok;
			}
			//else if ( preg_match( "/<\/pre[^>]*>|<\/PRE[^>]*>/", $tok ) )
			else if ( preg_match( "/<\/(pre|script|style|iframe)[^>]*>/u", strtolower( $tok ) ) )
			{
				// PREλȯ顢⡼ɤnopreˤ롣
				$countTextSections --;
				if ( $countTextSections < 0 ) $countTextSections = 0;
				
				if ( $countTextSections <= 0 )
				{
					$mode = 'nopre';
				}
				$strResult .= $tok;
			}
			else
			{
				if ( $mode == 'nopre' )
				{
					// nopreϡʬ<br />դä롣
					// ޤԤȡˤsplit롣
					$lineArr = preg_split( "/\n/", $tok );//, -1, PREG_SPLIT_DELIM_CAPTURE );
					if ( count($lineArr) == 1 )
					{
						// \nǶڤäƷ̤1ĤȤȤϡ\n¸ߤʤäȤȤʤΤǡΤޤ޽Ϥ롣
						$strResult .= $lineArr[0];	
					}
					else
					{
						// <br />ղýԤ
						foreach( $lineArr as $lineNo=>$lineStr )
						{
							// ȡƤϤ롣
							$strResult .= rtrim($lineStr);
							
							if ( $lineNo != count($lineArr)-1 )
							{
								$needsBR = true;	// ܤϹ <br />Ϥ롣
								
								if ( mb_substr( trim($lineStr), mb_strlen(trim($lineStr)) - 1, 1 ) == '>' )
								{
									// ">"ʥǽäƤ˾ϡ<br />Ϥʤ
									$needsBR = false;
								}
								
								// â ">" äȤƤ⡢ʲĤäϤϤϤ롣
								$matches = array();
								preg_match( "/<\/([^>]*)>$/u", trim($lineStr), $matches );
								if ( isset( $matches[1] ) )
								{
									switch ( strtolower( trim( $matches[1] ) ) )
									{
										case 'a' :
										case 'font' :
										case 'span' :
										case 'b' :
										case 'strong' :
										case 'i' :
										case 'em' :
										case 'u' :
										case 's' :
										case 'tt' :
										case 'small' :
										case 'sup' :
										case 'sub' :
										case 'big' :
											
											$needsBR = true;
											break;
									}
								}
								
								if ( $needsBR ) 
								{
									$strResult .= '<br />';
								}
								
								/*
								if ( mb_substr( trim($lineStr), mb_strlen(trim($lineStr)) - 1, 1 ) != '>' )
								{
									// ">"ʥǽäƤ˾ȥȡ󤬲ʸξ<br />Ϥ롣
									$strResult .= '<br />';
								}
								*/
							}
							
							$strResult .= "\n";
						}
					}
				//$strResult .= mb_ereg_replace( '[^>]($)', "<br />", $tok );  // ǽ餳ǰִ褦Ȥܸ줬
				}
				else
				{
					$strResult .= $tok;
				}
			}
		
		  //print "token = " . $tok . "\n";
		}
		
		return $strResult;

	}
	

	/* ---------------------------------------------------------------
	 * ӥ塼饹
	 * ޡȥꡢǥӤĤHTML󥰤롣
	 */
	class View2
	{
		var $name;					// ӥ塼̾
		var $schemaName;			// ̾
		var $desginName;			// ǥ̾
		var $maxPageEntryCount; 	// 1ڡκ票ȥ
		
		
		/* -----------------------------------------------------------
		 * 󥹥ȥ饯
		 */
		function View2( $name )
		{
			$this->name = $name;
			$this->entryName = "news1";
			$this->designName = "news_all";
			$maxPageEntryCount = 10;
		}
		
		/* -----------------------------------------------------------
		 * HTMLΥ
		 */
		function renderHTML( $entryID )
		{
			// HTMLإåν
			header("Content-Type:text/html;charset=EUC-JP");
			
			// 롼ȥǥ쥯ȥѥ
			$strDir = App::getRootDir();
			
			// ȥΥǥ쥯ȥѥ
			$strEntryDir = $strDir . "/data/entry/" . $this->entryName . "/";
			
			// ȥXMLեѥ
			$strXml = $strEntryDir . $this->entryName . "." . $entryID . ".xml";
			
			// ǥXSLեΥѥ
			$strXsl = $strDir . "/config/design/" . $this->designName . "/" .
				$this->designName . ".xsl";
			
			// XSLTHTML롣
			$objPrc = xslt_create();
			xslt_set_base( $objPrc, "file://" . $strEntryDir ); 	// XSLTBaseURI˥ȥDirꡣ
			$result = xslt_process( $objPrc, $strXml, $strXsl );
			
			// EUC-JPѴϤ롣
			print( mb_convert_encoding( $result, "EUC-JP", "UTF-8" ) ); 	
		}
		
	}
	
	
	
	//-------------------------------------------------------------------------
	// array parse_http_date( string Date )
	// DateRFC1123RFC 850ANSI C's asctime() formatΤ줫
	//-------------------------------------------------------------------------
	function parse_http_date( $string_date ) {

		// ̾ȿ
		$define_month = array(
			"01" => "Jan", "02" => "Feb", "03" => "Mar",
			"04" => "Apr", "05" => "May", "06" => "Jun",
			"07" => "Jul", "08" => "Aug", "09" => "Sep",
			"10" => "Oct", "11" => "Nov", "12" => "Dec"
		);

		if( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), ([0-3][0-9]) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-9]{4}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $temp_date ) ) {

			$date["hour"] = $temp_date[5];
			$date["minute"] = $temp_date[6];
			$date["second"] = $temp_date[7];
			// Ѥߤη̾Ѵ
			$date["month"] = array_search( $temp_date[3], $define_month );
			$date["day"] = $temp_date[2];
			$date["year"] = $temp_date[4];


		} elseif( preg_match( "/^(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), ([0-3][0-9])-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-([0-9]{2}) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) GMT$/", $string_date, $temp_date ) ) {

			$date["hour"] = $temp_date[5];
			$date["minute"] = $temp_date[6];
			$date["second"] = $temp_date[7];
			// Ѥߤη̾Ѵ
			$date["month"] = array_search( $temp_date[3], $define_month );
			// ǯ2夷ʤΤ1900­4
			$date["day"] = $temp_date[2];
			$date["year"] = 1900 + $temp_date[4];


		} elseif( preg_match( "/^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-3 ][0-9]) ([0-2][0-9]):([0-5][0-9]):([0-5][0-9]) ([0-9]{4})$/", $string_date, $temp_date ) ) {
			$date["hour"] = $temp_date[4];
			$date["minute"] = $temp_date[5];
			$date["second"] = $temp_date[6];
			$date["month"] = array_search( $temp_date[2], $define_month );
			// 1ξ衢Ⱦѥڡ0ִ
			$date["day"] = str_replace( " ", 0, $temp_date[3] );
			// Ѥߤη̾Ѵ
			$date["year"] = $temp_date[7];


		} else {
			return FALSE;
		}

		// UNIXॹפGMTʤΤ
		$date["timestamp"] = gmmktime( $date["hour"], $date["minute"], $date["second"], $date["month"], $date["day"], $date["year"] );

		return $date;

	}	
	
	// ե
	class FileDownloader
	{
		function FileDownloader()
		{
		}
		
		function output()
		{
			// ѥ᡼μ
			$entryName = $_GET['entryname'];
			$entryId = $_GET['entryid'];
			$fileid = $_GET['fileid'];
			$mode = getGETParam( 'mode' );	// 'manager'ʤС̥⡼ɡ
			$disp = getGETParam( 'disp' );	// 'inline'ʤХɤǤϤʤ֥饦ɽ
			
	   	 	$xmlDocEntry = domxml_open_file( App::createEntryFilePath( $entryName, $entryId ) );
			$xpathEntry = $xmlDocEntry->xpath_new_context();
			$xmlEntryDataArr = $xpathEntry->xpath_eval( "//*[@fileid='$fileid']" );
			
			//$srcFileName = $xmlEntryDataArr->nodeset[0]->get_attribute('src');
			$orgFileName = $xmlEntryDataArr->nodeset[0]->get_attribute('org');
			
			//$ext = getfileext( $orgFileName );
			
			//$srcFilePath = App::createAttachedFilePath( $entryName, $entryId, $fileid, $orgFileName );

			// ԽΥե׵ᤵ줿硢ޤȥǡ˾¸ƤʤΤǡĥҾºݤΥեΥե뤫õƤɬפ롣
			// ĥҡ*פǸơեꥹȤ롣
			$srcFilePathDammy = App::createAttachedFilePath( $entryName, $entryId, $fileid, 'dammy.*' );
			$srcFilePathArr = glob( $srcFilePathDammy );
			
			if ( $mode == 'manager' )
			{
				// ̥⡼ɤξ硢ֿեեȤ롣
				$lastmtime = 0;	// ֿեιʽͤ0鳫ϡ
				foreach ( $srcFilePathArr as $srcFilePathItem )
				{
					$mtime = filemtime( $srcFilePathItem );
					if ( $mtime > $lastmtime )
					{
						$srcFilePath = $srcFilePathItem;
						$lastmtime = $mtime;
					}
				}
			}
			else
			{
				// ̾⡼ɤξ硢tmpեեեȤ롣ʳեϣĤ¸ߤʤϤ
				foreach ( $srcFilePathArr as $srcFilePathItem )
				{
					if ( getfileext( $srcFilePathItem ) != 'tmp'  )
					{
						$srcFilePath = $srcFilePathItem;
						break;
					}
				}
			}
			
			// ֥饦åȤӡIf-Modified-Sinceб
			//$request_headers = apache_request_headers();
			$etag = md5( $entryName . $entryId . $fileid );	// Etagϡentryname+entryid+fileid
			$timestamp = filemtime( $srcFilePath );
			$sLastModified = gmdate('D, d M Y H:i:s T', $timestamp);
			$modified = true;	// 
			
			// ֥饦å²ιŤС$modifiedfalse̤ˤˤ롣
			if( isset( $_SERVER['HTTP_IF_MODIFIED_SINCE'] ) ) {
				$since = parse_http_date( $_SERVER['HTTP_IF_MODIFIED_SINCE'] );
				if( $since["timestamp"] >= $timestamp ) {
					$modified = false;
				}
			}
			
			// ̤ʤ顢304 Not Modified֤ƽλ
			if ( ! $modified )
			{
					header( "HTTP/1.1 304 Not Modified" );
					header( "Etag: \"$etag\"" );
					return;		// ǽλ
			}
			
			// եĥҤμ
			$fileext = getfileext( $srcFilePath );
			
			// ĥҤ tmp ξ硢ե̾ϼǤƤʤϤʤΤǡǲ̾Ĥ롣
			if ( $fileext == 'tmp' )
			{
				$orgFileName = 'untitled.' . gettmpfileext( $srcFilePath );
			}
			
			// ɳ
			mb_http_output("pass");
			
			$mimetypes = array(
				'pdf'	=>	'application/pdf',
				'bmp'	=>	'image/bmp',
				'eps'	=>	'application/postscript',
				'gif'	=>	'image/gif',
				'ico'	=>	'image/x-icon',
				'jpeg'	=>	'image/jpeg',
				'jpg'	=>	'image/jpeg',
				'png'	=>	'image/png',
				'ps'	=>	'application/postscript',
				'tif'	=>	'image/tiff',
				'tiff'	=>	'image/tiff',
				'css'	=>	'text/css',
				'htm'	=>	'text/html',
				'html'	=>	'text/html',
				'xhtml'	=>	'application/xhtml+xml',
				'xml'	=>	'text/xml',
				'js'	=>	'text/javascript',
				'doc'	=>	'application/msword',
				'xls'	=>	'application/msexcel',
				'ppt'	=>	'application/mspowerpoint',
				'docx'	=>	'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
				'xlsx'	=>	'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
				'pptx'	=>	'application/vnd.openxmlformats-officedocument.presentationml.presentation',
				'rtf'	=>	'application/rtf',
				'swf'	=>	'application/x-shockwave-flash',
				'mpg'	=>	'video/mpeg',
				'mpeg'	=>	'video/mpeg',
				'mov'	=>	'video/quicktime',
				'qt'	=>	'video/quicktime',
				'avi'	=>	'video/x-msvideo',
				'mp3'	=>	'audio/mpeg',
				'mid'	=>	'audio/midi',
				'midi'	=>	'audio/midi',
				'ra'	=>	'audio/vnd.rn-realaudio',
				'wav'	=>	'audio/wav',
				'txt'	=>	'text/plain'
			);
			
			// disp'inline'ġбĥҤʤСContent-disposition: inline ˤĥҤ˹碌ŬڤContent-type롣ǤʤХɤ롣
			if ( $disp == 'inline' && array_key_exists( $fileext, $mimetypes )	){
				header( 'Content-type: ' . $mimetypes[ $fileext ] );
				header("Content-disposition: inline; filename=" . mb_convert_encoding( $orgFileName, 'SJIS' , mb_detect_encoding( $orgFileName ) ) );
			}
			else {
				header("Content-type: application/octet-stream; name=" . mb_convert_encoding( $orgFileName, 'SJIS' , mb_detect_encoding( $orgFileName ) ) );
				header("Content-disposition: attachment; filename=" . mb_convert_encoding( $orgFileName, 'SJIS' , mb_detect_encoding( $orgFileName ) ) );
	   			
	   			//header("Content-type: application/octet-stream; name=" .	urlencode( mb_convert_encoding($orgFileName, 'SJIS', 'UTF-8' ) ) );
				//header("Content-disposition: attachment; filename=" . urlencode( mb_convert_encoding($orgFileName, 'SJIS', 'UTF-8' )	) );

				//header("Content-type: application/octet-stream; name=xxx.xls" );
				//header("Content-disposition: attachment; filename=abc.xls" );
			}
			
			header("Content-length: " . filesize( $srcFilePath ));
			//$fp = fopen( $srcFilePath , "rb");
			//print fread($fp, filesize($srcFilePath));
			header('ETag: "' . $etag . '"' );
			header("Last-Modified: " . $sLastModified );
			
			
			// readfileϥ̤˾񤹤١freadѹ2009.03.05 jshin
			$fp = fopen( $srcFilePath, 'rb');
			if ( $fp )
			{
				while (!feof($fp))
				{
					echo fread($fp, 4096);
				}
				flush();
				fclose($fp);
			}
			else
			{
				cmsd_abort_proc( 'Can not read the file.' );
			}
			
			//readfile( $srcFilePath );
			//fclose($fp);
		}
	}
	
	// 
	class ImageDownloader
	{
		function ImageDownloader()
		{
		}
		
		function output()
		{
			// ѥ᡼μ
			$entryName = $_GET['entryname'];
			$entryId = $_GET['entryid'];
			$fileid = $_GET['fileid'];
			$mode = getGETParam( 'mode' );	// 'manager'ʤС̥⡼ɡ
			
			// ԽΥե׵ᤵ줿硢ޤȥǡ˾¸ƤʤΤǡĥҾºݤΥեΥե뤫õƤɬפ롣
			// ĥҡ*פǸơեꥹȤ롣
			$srcFilePathDammy = App::createAttachedFilePath( $entryName, $entryId, $fileid, 'dammy.*' );
			$srcFilePathArr = glob( $srcFilePathDammy );
			
			if ( $mode == 'manager' )
			{
				// ̥⡼ɤξ硢ֿեեȤ롣
				$lastmtime = 0;	// ֿեιʽͤ0鳫ϡ
				foreach ( $srcFilePathArr as $srcFilePathItem )
				{
					$mtime = filemtime( $srcFilePathItem );
					if ( $mtime > $lastmtime )
					{
						$srcFilePath = $srcFilePathItem;
						$lastmtime = $mtime;
					}
				}
			}
			else
			{
				// ̾⡼ɤξ硢tmpեեեȤ롣ʳեϣĤ¸ߤʤϤ
				foreach ( $srcFilePathArr as $srcFilePathItem )
				{
					if ( getfileext( $srcFilePathItem ) != 'tmp'  )
					{
						$srcFilePath = $srcFilePathItem;
						break;
					}
				}
			}
			
			$ext = strtolower( getfileext( basename( $srcFilePath ) ) );
			if ( $ext == 'tmp' )
			{
				$ext = strtolower( gettmpfileext( basename( $srcFilePath ) ) );
			}
			
			switch ( $ext )
			{
				case 'jpg' :
					$ext = 'jpeg';
					break;
			}
			
			$width = null;
			$height = null;
			
			if ( !empty( $_GET['w'] ) ) 
			{ 
				$width = $_GET['w']; 
			}
			
			if ( !empty( $_GET['h'] ) )
			{
				$height = $_GET['h'];
			}
			
			// ֥饦åȤӡIf-Modified-Sinceб
			//$request_headers = apache_request_headers();
			$etag = md5( $entryName . $entryId . $fileid );	// Etagϡentryname+entryid+fileid
			$timestamp = filemtime( $srcFilePath );
			$sLastModified = gmdate('D, d M Y H:i:s T', $timestamp);
			$modified = true;	// 
			
			// ֥饦å²ιŤС$modifiedfalse̤ˤˤ롣
			if( isset( $_SERVER['HTTP_IF_MODIFIED_SINCE'] )) {
				$since = parse_http_date( $_SERVER['HTTP_IF_MODIFIED_SINCE'] );
				if( $since["timestamp"] >= $timestamp ) {
					$modified = false;
				}
			}
			
			// ̤ʤ顢304 Not Modified֤ƽλ
			if ( ! $modified )
			{
					header( "HTTP/1.1 304 Not Modified" );
					header( "Etag: \"$etag\"" );
					return;		// ǽλ
			}
			
			if ( empty($width) and empty($height) )
			{
				// ɳ
				mb_http_output("pass");
				//header("Content-disposition: attachment; filename=" . mb_convert_encoding( $orgFileName, 'SJIS' , mb_detect_encoding( $orgFileName ) ) );
	   			header("Content-type: image/" . $ext );
				header("Content-length: " . filesize( $srcFilePath ));
				header('ETag: "' . $etag . '"' );
				header("Last-Modified: " . $sLastModified );
				//$fp = fopen( $srcFilePath , "r");
   	 			//echo fread($fp, filesize($srcFilePath));
				//fclose($fp);
				
				// readfileϥ̤˾񤹤١freadѹ2009.03.05 jshin
				$fp = fopen( $srcFilePath, 'rb');
				if ( $fp )
				{
					while (!feof($fp))
					{
						echo fread($fp, 4096);
					}
					flush();
					fclose($fp);
				}
				else
				{
					cmsd_abort_proc( 'Can not read the file.' );
				}
				
				/*
				if ( ! readfile( $srcFilePath ) )
				{
					cmsd_abort_proc( 'Can not read the file.' );
				}
				*/
			}
			else
			{
				if ( $mode != 'manager' )
				{
					// å夬¸ߤʤ顢åɤ߹¸ߤʤн̾ؿʤ
					// եѥ cmsdesigner/cache/imagecache.entryname1.00001.00000001.gif.120x200
					$paramWidth = parseNumeric( getGETParam( 'w' ), 0 );
					$paramHeight = parseNumeric( getGETParam( 'h' ), 0 );
					$filePathImageCache = App::getRootDir() . "/cache/imagecache." . App::createAttachedFileName( $entryName, $entryId, $fileid, $srcFilePath ) . ".{$paramWidth}x{$paramHeight}";
					if ( file_exists( $filePathImageCache ) )
					{
						// ɳ
						mb_http_output("pass");
						header("Content-type: image/" . $ext );
						header("Content-length: " . filesize( $filePathImageCache ));
						header('ETag: "' . $etag . '"' );
						header("Last-Modified: " . $sLastModified );
						readfile( $filePathImageCache );
						return;
					}
				
					// åоݤɤ
					// Configɤ߹
					$siteConfig = new CMSSiteConfig();
					$entryConfig = $siteConfig->getEntryConfig( $entryName );
					$isCacheTarget = false;
					foreach ( $entryConfig->imageCacheList as $imageCache )
					{
						if ( $imageCache->isTarget( $paramWidth, $paramHeight ) )
						{
							$isCacheTarget = true;
							break;
						}
					}
				}
			
				// 礭
				$info = getimagesize( $srcFilePath );
				$widthSrc = $info[0];
				$heightSrc = $info[1];
				
				// ꤵ줿Ϲ⤵˹碌׻
				/// ⤵Ʊ˻ꤵƤ顢̾Ψ⤤ͤˤͥ褹ΰ˼ޤ褦ˤ
				if ( !empty($width) and !empty($height) )
				{
					if ( ( $width / $widthSrc ) >= ( $height / $heightSrc ) )
					{
						unset( $width );
					}
					else
					{
						unset( $height );
					}
				}
				
				/// ̾Υ
				if (!empty($width))	// widthꤵƤ
				{
					$widthNew = $width;
					$heightNew = ($width * $heightSrc) / $widthSrc;
				}
				else
				{
					$heightNew = $height;
					$widthNew = ($height * $widthSrc) / $heightSrc;
				}
				
				// 
				switch( $info[2] )
				{
					case 1: // GIF
						$imageSrc = imagecreatefromgif( $srcFilePath );
						break;
					
					case 2: // JPEG
						$imageSrc = imagecreatefromjpeg( $srcFilePath );
						break;
					
					case 3: // PNG
						$imageSrc = imagecreatefrompng( $srcFilePath );
						break;
				}
				
				// ϲ
				if ( function_exists( 'imagecreatetruecolor' ) )
				{
					$imageNew = imagecreatetruecolor( $widthNew, $heightNew );
				}
				else
				{
					$imageNew = imagecreate( $widthNew, $heightNew );
				}
				
				// ϲˡ̾
				global $gGDimagecopyfunc;
				if ( $gGDimagecopyfunc === 1 and function_exists( 'imagecopyresampled' ) )
				{
					imagecopyresampled( $imageNew, $imageSrc, 0, 0, 0, 0, $widthNew, $heightNew, $widthSrc, $heightSrc );
				}
				else
				{
					imagecopyresized( $imageNew, $imageSrc, 0, 0, 0, 0, $widthNew, $heightNew, $widthSrc, $heightSrc );
				}
	   			header("Content-type: image/" . $ext );
				header('ETag: "' . $etag . '"' );
				header("Last-Modified: " . $sLastModified );
				
				// ꥽
				imagedestroy($imageSrc);
				
				// 
				global $gGDJpegQuality;
				switch( $info[2] )
				{
					case 1: // GIF
						imagegif( $imageNew );
						break;
					
					case 2: // JPEG
						imagejpeg( $imageNew, null, $gGDJpegQuality );
						break;
					
					case 3: // PNG
						imagepng( $imageNew );
						break;
				}
				
				// åоݤξ硢å
				if ( $mode != 'manager' and $isCacheTarget )
				{
					$adimageCache = new ADImage();
					$adimageCache->loadFromResourceID( $imageNew );
					
					// եѥ cmsdesigner/cache/imagecache.entryname1.00001.00000001.gif.120x200
					//  $entryName, $entryId, $fileid ϤδؿκǽǰåѤߡ
					$ext = strtolower( getfileext( basename( $srcFilePath ) ) );
					$width = parseNumeric( getGETParam( 'w' ), 0 );
					$height = parseNumeric( getGETParam( 'h' ), 0 );
					$filePathImageCache = App::getRootDir() . "/cache/imagecache.{$entryName}.{$entryId}.{$fileid}.{$ext}.{$width}x{$height}";
					$adimageCache->saveToFile( $filePathImageCache, $info[2] );
					// ФˤäƤϥեͭapache0600ˤʤäƤޤ礬ꡢFTPGETǤʤΤǡǥѡߥåǤ0644ꤹ롣
					chmod( $filePathImageCache, 0644 ); 
				}
				
				// ꥽˴
				imagedestroy($imageNew);
			}
		}
	}
	
	
	
	/* ---------------------------------------------------------------
	 * XMLѥӥ塼饹
	 * 
	 */
	class externalxml_view
	{
		var $src = '';
		
		/* ---------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $src : XMLURLϥѥ̾
		 */
		function externalxml_view( $src )
		{
			$this->src = $src;
			
		}
		
		
		/* ---------------------------------------------------------------
		 * ǡ̵ξηDOMĥ꡼롣
		 * $message : å
		 */
		function createNodataResult( $message = '' )
		{
			// äݤΥȥǡnodataǤֵѤ롣
			
			// DOM
			$xmlDoc = domxml_new_doc( '1.0' );
			
			// 롼ȥΡ'nodata'
			$xmlRoot = $xmlDoc->add_root( 'nodata' );
			
			// åꤵƤСåǤɲä롣
			if ( strlen( $message ) > 0 )
			{
				$xmlMessage = $xmlDoc->create_element( 'message' );
				$xmlMessage->set_content( fileconv( $message ) );
				$xmlRoot->append_child( $xmlMessage );
			}
			
			return $xmlDoc;
		
		}
		
		
		/* ---------------------------------------------------------------
		 * ȥꥹȤɽ
		 * $designName : XSL륷̾
		 * $isXML : XMLȤƽϤ뤫 (άfalse)
		 * $dateInfoAddition : վϤɲä뤫
		 */
		//function listpage( $entryName, $designName = null, $pageMaxRows = 10, $groupKeyValue = '', $showNavi = true, $pageNo = NULL, $isRSS = false, $isXML = false )
		function output( $designName = null, $isXML = false, $dateInfoAddition = true )
		{
			$src = $this->src;
			
			// ̾"xml"ꡣ
			$schemaName = 'xml';

			// Υǥե뤬¸ߤʤ硢顼åɽƽλ롣
			if ( ! $isXML || $designName )	// XMLꤸʤ̵ǥådesignNameꤵƤ̵ǥå
			{
				if ( ! file_exists( App::createXslFilePath( $schemaName, $designName ) ))
				{
					return "ե'" . App::createXslFileName( $schemaName, $designName ) . "'ĤޤߥޥɤΥǥ̾λְ꤬äƤޤ";
				}
			}
			
			// srcե뤫ޤϥ⡼ȥե뤫
			$isRemote = false;
			if ( substr( $src, 0, 7 ) == 'http://' )	// http://ǻϤޤsrcξ硢⡼ȥեȸʤ
			{
				$isRemote = true;
			}
			
			// XMLdomȤƼ롣
			$xmlDocSrc = null;
			
			if ( $isRemote )
			{
				// ⡼ȥեξ硢fopenȤäƾɤ߹ߡĤʸ˷礹롣
				// URLΥڡɤ߹ࡣ 
				$fp = @fopen( $src, 'r' ); // @Ĥ뤳Ȥǥ顼ɽ롣
				
				if ( empty( $fp ) ) 
				{
					$xmlDocSrc = $this->createNodataResult( 'ꤵ줿XMLURLΥǡɤ߹ߤ˼Ԥޤsrc=' . $src );
				}
				else
				{
				
					// ĥǡɤ߹ǡĤʸ˷礹롣
					$strXmlSrc = '';
					while( !feof( $fp ) ) 
					{
					  $strXmlSrc .= fgets( $fp, 4096 );
					}
					
					// ɤ߹߽λ
					fclose( $fp );
					
					// DOM
					$errors = array();
					$xmlDocSrc = @domxml_open_mem( $strXmlSrc, DOMXML_LOAD_PARSING, $errors );
					
					if ( is_null( $xmlDocSrc ) )
					{
						$xmlDocSrc = $this->createNodataResult( 'ꤵ줿XMLǡŬڤXMLǡǤϤޤsrc=' . $src );
					}
					elseif ( count( $errors ) > 0 )
					{
						$xmlDocSrc = $this->createNodataResult( $errors[0]['errormessage'] . ', src=' . $src );
					}
					
				}
				
			}
			else
			{
				// եξ硢domxml_open_fileȤäɤ߹ࡣ
				if ( file_exists( $src ) )
				{
					// եɤ߹ࡣ
					$errors = array();
			   	 	$xmlDocSrc = @domxml_open_file( $src, DOMXML_LOAD_PARSING, $errors );
					
					if ( is_null( $xmlDocSrc ) )
					{
						$xmlDocSrc = $this->createNodataResult( 'ꤵ줿XMLǡŬڤXMLǡǤϤޤsrc=' . $src );
					}
					elseif ( count( $errors ) > 0 )
					{
						$xmlDocSrc = $this->createNodataResult( $errors[0]['errormessage'] . ', src=' . $src );
					}
				}
				else
				{
					$xmlDocSrc = $this->createNodataResult( 'ꤵ줿XML¸ߤޤsrc=' . $src ); 
				}
				
			}
			
			// CMSDȼվࡣ
			if ( $dateInfoAddition )
			{
				$xmlSrcRoot = $xmlDocSrc->document_element();
				$rootTagName = $xmlSrcRoot->tagname();
				
				// 2007.02.27 excite blogΤ褦ˡRSS2.0ˤؤ餺dc:dateϤƤfeed¸ߤ١ξн褹褦ˤ
				switch ( $rootTagName )
				{
					case 'RDF' :	// RSS1.0
					case 'rdf:RDF' :	// for PHP5
					case 'rss' :	// RSS0.91 or RSS2.0
					
						// XPath
						$xpath = $xmlDocSrc->xpath_new_context();
						xpath_register_ns( $xpath, 'dc', 'http://purl.org/dc/elements/1.1/');
						xpath_register_ns( $xpath, 'rdf', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#' );
						
						// RSS1.0Ѥν
						$xmlDateArr = $xpath->xpath_eval('//*[self::dc:date]');//( '//dc:date' ); // '//dc:date'ȡXREAСPHP5.3Ķǥϥ󥰥åפ١ɽѤʤϥ󥰥åפ뤫namespace˴طƤ饤֥ΥХβǽ⤤
						
						if ( !empty($xmlDateArr->nodeset) )
						{
							foreach( $xmlDateArr->nodeset as $xmlDate )
							{
								$strDate = $xmlDate->get_content();
								$timestamp = $this->parseDateTime( $strDate, 'W3C/Date' );
								$this->addDateInfo( $xmlDate, $timestamp );
							}
						}
						
						// RSS2.0Ѥν
						$xmlDateArr = $xpath->xpath_eval( '//*[self::pubDate or self::lastBuildDate]' );
						
						if ( !empty($xmlDateArr->nodeset) )
						{
							foreach( $xmlDateArr->nodeset as $xmlDate )
							{
								$strDate = $xmlDate->get_content();
								$timestamp = $this->parseDateTime( $strDate, 'RFC822' );
								$this->addDateInfo( $xmlDate, $timestamp );
							}
						}
					
						break;
					
				}
				
				/*
				switch ( $rootTagName )
				{
					case 'RDF' :	// RSS1.0
						$xpath = $xmlDocSrc->xpath_new_context();
						xpath_register_ns( $xpath, 'dc', 'http://purl.org/dc/elements/1.1/');
						xpath_register_ns( $xpath, 'rdf', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#' );
						
						$xmlDateArr = $xpath->xpath_eval( '//dc:date' );
						
						if ( $xmlDateArr->nodeset )
						{
							foreach( $xmlDateArr->nodeset as $xmlDate )
							{
								$strDate = $xmlDate->get_content();
								$timestamp = $this->parseDateTime( $strDate, 'W3C/Date' );
								$this->addDateInfo( $xmlDate, $timestamp );
							}
						}
						
						
						break;
					
					case 'rss' :	// RSS0.91 or RSS2.0
						$xpath = $xmlDocSrc->xpath_new_context();
						$xmlDateArr = $xpath->xpath_eval( '//*[self::pubDate or self::lastBuildDate]' );
						
						if ( $xmlDateArr->nodeset )
						{
							foreach( $xmlDateArr->nodeset as $xmlDate )
							{
								$strDate = $xmlDate->get_content();
								$timestamp = $this->parseDateTime( $strDate, 'RFC822' );
								$this->addDateInfo( $xmlDate, $timestamp );
							}
						}
					
						break;
					
				}
				*/
				
			}
			
			
			// XSLѴ
			if ( $isXML )
			{
				// XMLΤޤ޽ϡŪˤEUC-JPǽ뤬XMLǽϤ硢UTF-8Ϥˤʤ뤳ȤۤȤɤȻפ١㳰ŪUTF-8ϤȤ롣
				$result = $xmlDocSrc->dump_mem( true, 'UTF-8' );
				$result = trim( $result );	// 2006.11.15 ɲáXMLĥ꡼̤;פʲԤɲä١ŪβԤ
				
			}
			// ̾ΥڡɽѴ
			else
			{
				$result = ADXslt::process( $xmlDocSrc, App::createXslFilePath( $schemaName, $designName) );
			}
			return $result;
			
		}
		
		
		function addDateInfo( &$xmlDate, $timestamp )
		{
			// Ǽ

			$sYear = date( 'Y', $timestamp );
			$sMonth = date( 'm', $timestamp );
			$sDay = date( 'd', $timestamp );
			$sWeekday = strtolower( date( 'D', $timestamp ) );
			$sHour = date( 'H', $timestamp );
			$sMinute = date( 'i', $timestamp );
			$sSecond = date( 's', $timestamp );
			$sTimezone = date( 'O', $timestamp );
			
			// Ǥ˳ƾ°Ȥɲ
			
			$xmlDate->set_attribute( 'year', $sYear );
			$xmlDate->set_attribute( 'month', $sMonth );
			$xmlDate->set_attribute( 'day', $sDay );
			$xmlDate->set_attribute( 'weekday', $sWeekday );
			$xmlDate->set_attribute( 'hour', $sHour );
			$xmlDate->set_attribute( 'minute', $sMinute );
			$xmlDate->set_attribute( 'second', $sSecond );
			
			// ƥ
			$xmlDate->set_attribute( 'timezone', $sTimezone );
			
		}
		
		function parseDateTime( $strDate, $type )
		{
			$timestamp = null;	// 
			
			switch ( $type )
			{
				case 'W3C/Date' :
					// ѥ졼'T'ǡʬȻʬʬΥ롣
					$arrDateToken = explode( 'T', $strDate );
					
					// ѿν
					$year = 0;
					$month = 0;
					$day = 0;
					
					// ʬʬ
					if ( isset( $arrDateToken[0] ) )
					{
						$year = substr( $arrDateToken[0], 0, 4 );
						$month = substr( $arrDateToken[0], 5, 2 );
						$day = substr( $arrDateToken[0], 8, 2 );
					}
					
					// Ȼѿν
					$hour = 0;
					$minute = 0;
					$second = 0;
					$milisecond = 0;
					$offset_sign = '';	// + or - 
					$offset_hour = 0;
					$offset_minute = 0;
					
					// ʬ¸ߤ뤫
					if ( isset( $arrDateToken[1] ) )
					{
						// ʬ򡢤˥ȻʬΥ롣
						$arrDateToken2 = preg_split( '/[-+Z]/', $arrDateToken[1] );	// ǽ顢[+-Z]Ƚ񤤤顢ɤ"-Z"ʸȤư줿(?)餷ޥʥǧʤä
						
						// ʬʬ
						if ( isset( $arrDateToken2[0] ) )
						{
							$hour = substr( $arrDateToken2[0], 0, 2 );
							$minute = substr( $arrDateToken2[0], 3, 2 );
							$second = substr( $arrDateToken2[0], 6, 2 );
							$milisecond = substr( $arrDateToken2[0], 9 );
						}
						
						// μʸĹ+1ʸ档
						$offset_sign = substr( $arrDateToken[1], strlen( $arrDateToken2[0] ), 1 );
						
						// ʬʬ
						if ( isset( $arrDateToken2[1] ) )
						{
							$offset_hour = substr( $arrDateToken2[1], 0, 2 );
							$offset_minute = substr( $arrDateToken2[1], 3, 2 );
							
							// 'Z'ȤƤ顢"+00:00"ΰ̣
							if ( $offset_sign == 'Z' )
							{
								$offset_sign = '+';
								$offset_hour = '00';
								$offset_minute = '00';
							}
						}
					}
					
					// GMTǤtimestamp롣
					$timestamp = gmmktime( $hour, $minute, $second, $month, $day, $year );
					
					// ä롣
					$offset_time = $offset_hour * 3600 + $offset_minute * 60;
					if ( $offset_sign == '-' )
					{
						$offset_time *= -1;
					}
					$timestamp -= $offset_time;	// +09:00ʤ顢9ʬСGMTǤtimestampФǤ롣
					
					break;
					
				
				case 'RFC822' :
					
					$timestamp = strtotime( $strDate );
				
					break;
			
			}

			
			return $timestamp;
		}
		
	}
	
?>