<?php 
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( "include/manager.php.inc" );
	require_once( "include/login.php.inc" );
	require_once( "include/user.php.inc" );
	
	$editor = null;

	cmsd_session_start();
	
	mb_language( 'Japanese' );
	mb_internal_encoding( 'EUC-JP' );	
	
	// --- OutputConfigɤ߹ ---------------------------------------------------------
	loadSiteConfig();
	
	// ׵᤬ä硢Ȥ˳桼ΥȥԽåƲ롣
	if ( isset( $_GET['logout'] ) )
	{
		if ( LoginManager::IsAuthed() )
		{
			$user = LoginManager::GetAuthedUser();
			EditingEntryLock::ReleaseLocksByUser( $user->getUserId() );
		}
	}
	
	// 󥪥֥Ȥ
	$loginForm = new LoginForm();
	
	// 桼ǧ
	$isAuth = $loginForm->authUser();
	
	// ǧںѤߤ
	if ( $isAuth )
	{
		// ǧںѤߤʤ顢Ʋ̤ν롣		
		header("Content-Type:text/html;charset=EUC-JP");
		
		// 򥻥å
		if ( isset( $_SESSION['actionStack'] ) )
		{
			$actionStack = $_SESSION['actionStack'];
		}
		else
		{
			$actionStack = array();
		}
		
		// 
		$actionName = getGETParam( 'p' );	//	$_GET['p']
		///$action =& createAction( $actionName );
		$action = createAction( $actionName );
		
		if ( ! isset($action) )
		{
			// ̾άƤΤǡƱܤ󥢥
			if ( count($actionStack) > 0 )
			{
				// 򤬻ĤäƤʤ顢Ʊܡ
				$action =& $actionStack[ count($actionStack)-1 ];
			}
			else
			{
				// 򤬻ĤäƤʤʤ顢󥢥
				///$action =& createAction( 'entrynames' );	// ȥåץڡ
				$action = createAction( 'entrynames' );	// ȥåץڡ
				array_push( $actionStack, $action );
			}
		}
		else
		{
			// 򥯥ꥢƬ̤ꤹ롣
			$actionStack = array(); // 򥯥ꥢ
			array_push( $actionStack, $action );
		}
		
		// ȥԽ̰ʳβ̤˰ܤä顢桼Υȥå롣
		$actionClassName = get_class( $action );
		if ( strtolower( $actionClassName ) != 'entryeditor' )
		{
			$user = LoginManager::GetAuthedUser();
			EditingEntryLock::ReleaseLocksByUser( $user->getUserId() );
		}

		// ˽Ѿ롣
		$nextActionName = $action->procRequest();
		// procRequestaction֥ȤȤѹ줿ǽΤǡactionStackƬꤷʤ
		array_pop( $actionStack );
		array_push( $actionStack, $action );
		
		// ̤ϡ̤ɽ롣
		switch ( $nextActionName )
		{
			// ľγؤ
			case 'pop' :
				$action =& array_pop( $actionStack );
				$action->procRequest();
				// procRequestǥ֥ȤȤѹ줿ǽΤǡåƬꤷʤ
				array_pop( $actionStack );
				array_push( $actionStack, $action );
				break;
				
			// 桼Խ
			case 'edituserlist' :
				// ̤ɽ롣
				$action = new EditUserListForm();
				$action->procRequest();
				$actionStack = array();
				array_push( $actionStack, $action );	// ΤؤϤäĤɡȤΤȹ碌ĴɬסOK
				break;
				
			default :
				break;
		}
		
		// 򥻥å˳Ǽ롣
		$_SESSION['actionStack'] = $actionStack;
		
	}
	else
	{
		// ƥΰ٤ˡΥåä
		unset( $_SESSION['actionStack'] );
		
		// ǧڤƤʤʤ顢եɽ롣
		$loginForm->dispForm();
	}
	
	
	
	function createAction( $actionName )
	{
		
		// ѥ᡼ˤäƽʬ롣pѥ᡼˲̾դ
		// ƤӽФ줿硢β̥֥Ȥ롣
		// ̥֥Ȥϥåݻ롣
 	   	switch ( $actionName )
		{
			case 'versioninfo' :
				$action = new VersionInfoAction();
				break;
			
			// 桼Խ
			case 'edituserlist' :
				$action = new EditUserListForm();
				break;
			
			case 'edituser' :
				$userId = $_GET['userid'];
				$action = new EditUserForm( $userId );
				break;
				
			// ȥ
			case 'entries' :
				$entryName = $_GET['entryname'];
				$action = new EntriesForEditor( $entryName );
				break;
					
			// ȥ
			case 'entry' :
				$entryName = $_GET['entryname'];
				$entryID = $_GET['entryid'];
				$action = new EntryEditor( $entryName, $entryID );
				break;
		
			// ȥ̾ϥǥե
			case 'entrynames' :
		   		$action = new EntryNamesForEditor();
				break;
			
			default :
				/*
				// editoråѿʤ顢ȥ̤̾ɽ롣
				if ( ! isset( $_SESSION["editor"] ) )
				{
					$_SESSION["editor"] = new EntryNamesForEditor();
				}
				*/				
				$action = null;
				break;
		}
		
		return $action;
	}
	
	// siteConfigɤƼɤ߹ࡣ
	function loadSiteConfig()
	{
		$siteConfig = new CMSSiteConfig();
		$outputConfig =& $siteConfig->getOutputConfig();	// 󥹥󥹤ѹ١ȤǼ롣
		
		// XSLT饤ֹ֥
		ADXslt::setXsltLibNo( $outputConfig->getXsltLibNo() );
		
		// XSLTˤʸ󥳡ǥ󥰽̵ͭ
		ADXslt::setDisableXsltEncoding( $outputConfig->getDisableXsltEncoding() );
		
		//print "ADXslt::setXsltLibNo( " . $outputConfig->getXsltLibNo() . " )<br />";
		//print "ADXslt::setDisableXsltEncoding( " .  ( $outputConfig->getDisableXsltEncoding() ? "True" : "False" ) . " )<br />";
	}
	
?>