<?php

	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */
	
	if ( version_compare(PHP_VERSION,'5','>=') )
	{
 		require_once('domxml-php4-to-php5.php');
 	}
 	
	if ( version_compare(PHP_VERSION,'5','>=') && extension_loaded('xsl') )
	{
		require_once('xslt-php4-to-php5.php');
	}
	
	/* -----------------------------------------------------------
	 * [̴ؿ]
	 * HTMLѤUTF-8EUC-JPѴ롣
	 */
	 
	function _htmlconv( $str )
	{
		return htmlentities( mb_convert_encoding( $str, 'EUC-JP'.'' , mb_detect_encoding( $str ) ), ENT_QUOTES, 'EUC-JP'.'' );
	}
	
	function convencoding_xml2html( $str )
	{
		//$str = utf8_replace_irregular_chars( $str );
		$str = htmlentities( mb_convert_encoding( $str, 'eucJP-win'.''.'' , 'UTF-8' ), ENT_QUOTES, 'EUC-JP' );
		return $str;
	}
	
	function file2code( $str )
	{
		//$str = utf8_replace_irregular_chars( $str );
		$str = mb_convert_encoding( $str, 'eucJP-win'.''.'', 'UTF-8' );
		return $str;
	}
	
	function fileconv( $str )
	{
		$str = htmlspecialchars( mb_convert_encoding( $str, 'UTF-8', 'eucJP-win'.''.'' ), ENT_QUOTES, 'UTF-8' );//mb_detect_encoding( $str ) ) );
		//$str = utf8_replace_irregular_chars( $str ); // 2007.10.1 ɲáeucJP-winбˤѤ//XSLT򤫤¦н褹褦ˤ
		
		// IBMĥʸѴޤǤʤäΤǰʲˡ٤Ͼʸ(R)ѴǤʤʤä
		//$str = htmlspecialchars( mb_convert_encoding( mb_convert_encoding( $str, 'sjis-win', 'EUC-JP' ), 'UTF-8', 'sjis-win' ), ENT_QUOTES, 'UTF-8' );//mb_detect_encoding( $str ) ) );
		
		return $str;
	}
	
	function cmsd_session_start()
	{
		// å󥯥åHttpOnlyˤ
		$currentCookieParams = session_get_cookie_params();
		session_set_cookie_params( 
			$currentCookieParams["lifetime"], 
			$currentCookieParams["path"], 
			$currentCookieParams["domain"], 
			$currentCookieParams["secure"], 
			true
		);
		session_name( 'cmsdsessionid' );
		session_start();
	}
	
	// GETѥ᡼롣
	function getGETParam( $paramName, $defaultValue = null )
	{
		$value = $defaultValue;
		if ( isset( $_GET[ $paramName ] ) )
		{
			$value = $_GET[ $paramName ];
		}
		
		return $value;
	}
	
	// POSTѥ᡼롣
	function getPOSTParam( $paramName, $defaultValue = null )
	{
		$value = $defaultValue;
		if ( isset( $_POST[ $paramName ] ) )
		{
			$value = $_POST[ $paramName ];
		}
		
		return $value;
	}
	
	
	// ǥեդͼ
	function nullString( $value, $defaultValue = "" )
	{
		if ( $value === '' or is_null( $value ) )
		{
			return $defaultValue;
		}
		else
		{
			return $value;
		}
	}

	/* -----------------------------------------------------------
	 * ե륵ХȿñդοͤѴ롣
	 *	
	 */
	function byte2unit( $fileSize )
	{
		$unitFileSize = 0; // 
		// ե륵
		if ( $fileSize > 0 and $fileSize < 1024 )
		{
			$unitFileSize =  $fileSize . "bytes";
		}
		else if ( $fileSize >= 1024 and $fileSize < 1024000 )
		{
			$unitFileSize = round( $fileSize / 1024, 1 ) . "KB";
		}
		else if ( $fileSize >= 1024000 )
		{
			$unitFileSize =  round( $fileSize / 1024000, 1 ) . "MB";
		}
		
		return $unitFileSize;
	
	}
	
	function unit2byte( $unitFileSize )
	{
		$fileSize = 0; // 
		if ( !empty($unitFileSize) && is_numeric( $unitFileSize ) )
		{
			$fileSize = $unitFileSize;
		}
		else if ( !empty($unitFileSize) && !is_numeric( $unitFileSize ) )
		{
			// ñ̤ڤФʸ2ʸ
			$unitkind = substr( $unitFileSize, -2 );
			
			// ͤڤФʸ2ʸ͡
			$sizevalue = substr( $unitFileSize, 0, strlen( $unitFileSize ) - 2 );
			
			if ( !empty($sizevalue) && is_numeric( $sizevalue ) )
			{
				// 'KB'ξ1024ܤ롣
				switch( strtoupper( $unitkind ) )
				{
					case 'KB' :
						$fileSize = $sizevalue * 1024;
						break;
				
					case 'MB' :
						$fileSize = $sizevalue * 1024 * 1000;
						break;
				}
				
			}
		}
		
		return $fileSize;
	}
	
	
	/* -----------------------------------------------------------
	 * dieؿΥåѡXSSб
	 *	
	 */
	function cmsd_abort_proc( $message, $sanitizing = true )
	{
		if ( $sanitizing )
		{
			$message = htmlspecialchars( $message, ENT_QUOTES );
		}
		$html = '<html><head><title>CMS Designer</title><meta http-equiv="Content-Type" content="text/html; charset=euc-jp" /></head><body>' . $message . '</body></html>';
		die($html );
	}
	
	/* -----------------------------------------------------------
	 * PHP4Ǥ objnullʤobj->propnullˤʤäƤPHP5NoticeФ褦ˤʤä١
	 * εưˤƤ foreach( xml->nodeset as hoge ) ʬñ˽Ǥ褦ˤ롣
	 */
	function cmsd_get_nodeset( $xmlobj )
	{
		if ( is_object( $xmlobj ) )
		{
			return $xmlobj->nodeset;
		}
		else
		{
			return array();
		}
	}

	/* ---------------------------------------------------------------
	 * ץꥱ󥯥饹
	 */
	class App
	{
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * CMSDesignerΥ롼ȥǥ쥯ȥѥμ
		 */
		function getRootDir()
		{
			return rtrim( realpath( dirname(__FILE__) . "/../" ), '/\\');	// 2007.11.21 PHP5realpathؿͤ/\դѹб
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * CMSDesignerΥ롼ȥǥ쥯ȥ̾μ
		 */
		function getRootDirName()
		{
			// 롼ȥǥ쥯ȥѥʸ"/"ǶڤäƺǸǤФС줬Dir̾ʤϤ
			$rootDirPath = App::getRootDir();
			$tokens = preg_split( '@[\\\/]@', $rootDirPath );	// LinuxWindowsɤǤбǤ褦/\ξǥߥȤƤ롣
			return array_pop( $tokens );
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * åǥ쥯ȥѥμ
		 */
		function getCacheDir()
		{
			return App::getRootDir() . '/cache/';
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥΥǥ쥯ȥѥμ
		 */
		function createEntryDirPath( $entryName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			$dirpath = App::getRootDir() . "/data/entry/" . $entryName . "/";

			// dirpath¸ߥå
			if ( ! file_exists( $dirpath )	)
			{
				cmsd_abort_proc( "ȥե'$dirpath'ޤ󡣥ѡߥå705ʾǥեƤ" );
			}
			
			return $dirpath;
		}
	
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥե̾μ
		 */
		function createEntryFileName( $entryName, $id )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $id ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $id );
			}
			
			return $entryName . "." . $id . ".xml";
		}
	
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥեѥμ
		 */
		function createEntryFilePath( $entryName, $id )
		{
			return App::createEntryDirPath( $entryName ) . App::createEntryFileName( $entryName, $id );
		}
		
		
		function createEntrySequenceFilePath( $entryName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			return App::createEntryDirPath( $entryName ) . $entryName . '.sequence';
		}		
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * site.config.xml եѥμ
		 */
		function getSiteConfigFilePath()
		{
			return App::getRootDir() . "/config/site.config.xml";
		}

		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * users.config.xml եѥμ
		 */
		function getUsersConfigFilePath()
		{
			return App::getRootDir() . "/config/users.config.xml";
		}
		
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ޥեѥμ
		 */
		function createSchemaFilePath( $schemaName )
		{
			if ( !InputValidater::IsSchemaName( $schemaName ) )
			{
				cmsd_abort_proc( 'invalid schema name:' . $schemaName );
			}
			
			return App::getRootDir() . "/config/schema/" . $schemaName . "/" . $schemaName . '.schema.xml';
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥե̾μ
		 */
		function createAttachedFileName( $entryName, $entryId, $fileId, $orgFileName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $entryId ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $entryId );
			}
			
			if ( !InputValidater::IsAttachedFileId( $fileId ) )
			{
				cmsd_abort_proc( 'invalid attached file ID : ' . $fileId );
			}
						
			return $entryName . '.' . $entryId . '.' . $fileId . '.' . getfileext( $orgFileName );
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥեѥμ
		 */
		function createAttachedFilePath( $entryName, $entryId, $fileId, $orgFileName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $entryId ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $entryId );
			}
			
			if ( !InputValidater::IsAttachedFileId( $fileId ) )
			{
				cmsd_abort_proc( 'invalid attached file ID : ' . $fileId );
			}
			
			return App::createEntryDirPath( $entryName ) . $entryName . '.' . $entryId . '.' . $fileId . '.' . getfileext( $orgFileName );
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * Xslե̾μ
		 */
		function createXslFilePath( $schemaName, $designName )
		{
			if ( !InputValidater::IsSchemaName( $schemaName ) )
			{
				cmsd_abort_proc( 'invalid schema name : ' . $schemaName );
			}
			
			if ( !InputValidater::IsDesignName( $designName ) )
			{
				cmsd_abort_proc( 'invalid design name : ' . $designName );
			}
			
			return App::getRootDir() . "/config/schema/" . $schemaName . "/" . App::createXslFileName( $schemaName, $designName );
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * Xslեѥμ
		 */
		function createXslFileName( $schemaName, $designName )
		{
			if ( !InputValidater::IsSchemaName( $schemaName ) )
			{
				cmsd_abort_proc( 'invalid schema name : ' . $schemaName );
			}
			
			if ( !InputValidater::IsDesignName( $designName ) )
			{
				cmsd_abort_proc( 'invalid design name : ' . $designName );
			}
			
			return $schemaName . '.' . $designName . '.design.xsl';
		}
				
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * Xslե̾μ
		 */
		function createListXslFilePath( $schemaName, $designName )
		{
			if ( !InputValidater::IsSchemaName( $schemaName ) )
			{
				cmsd_abort_proc( 'invalid schema name : ' . $schemaName );
			}
			
			if ( !InputValidater::IsDesignName( $designName ) )
			{
				cmsd_abort_proc( 'invalid design name : ' . $designName );
			}
			
			return App::getRootDir() . "/config/schema/" . $schemaName . "/" . App::createListXslFileName( $schemaName, $designName );
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * Xslեѥμ
		 */
		function createListXslFileName( $schemaName, $designName )
		{
			if ( !InputValidater::IsSchemaName( $schemaName ) )
			{
				cmsd_abort_proc( 'invalid schema name : ' . $schemaName );
			}
			
			if ( !InputValidater::IsDesignName( $designName ) )
			{
				cmsd_abort_proc( 'invalid design name : ' . $designName );
			}

			return $schemaName . '.list.' . $designName . '.design.xsl';
		}
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥåեѥμ
		 */
		function createEntryLockDirPath()
		{
		
			return App::getRootDir() . '/data/lock/'; 
		}		
		

		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * ȥåեѥμ
		 */
		function createEntryLockFilePath( $entryName, $entryId, $userId )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $entryId ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $entryId );
			}
			
			return App::createEntryLockDirPath() . $entryName . '.' . $entryId . '.' . $userId . '.lock';
		}
		
		
		function createImageUrl( $entryName, $entryId, $fileId, $orgFileName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $entryId ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $entryId );
			}
			
			if ( !InputValidater::IsAttachedFileId( $fileId ) )
			{
				cmsd_abort_proc( 'invalid attached file ID : ' . $fileId );
			}
			
			$imgurl = App::getRootDirName() . '/viewimg.php?entryname=' . $entryName . '&entryid=' . $entryId . '&fileid=' . $fileId. '&/' . rawurlencode( $orgFileName );
			return $imgurl;
		}
		
		function createFileUrl( $entryName, $entryId, $fileId, $orgFileName )
		{
			if ( !InputValidater::IsEntryName( $entryName ) )
			{
				cmsd_abort_proc( 'invalid entry name : ' . $entryName );
			}
			
			if ( !InputValidater::IsEntryId( $entryId ) )
			{
				cmsd_abort_proc( 'invalid entry ID : ' . $entryId );
			}
			
			if ( !InputValidater::IsAttachedFileId( $fileId ) )
			{
				cmsd_abort_proc( 'invalid attached file ID : ' . $fileId );
			}
						
			$imgurl = App::getRootDirName() . '/dlfile.php?entryname=' . $entryName . '&entryid=' . $entryId . '&fileid=' . $fileId. '&/' . rawurlencode( $orgFileName );
			return $imgurl;
		}
			
	}
	
	
	/* --------------------------------------------------------------------
	 * Xml桼ƥƥ
	 * 
	 */		
	 class XmlUtil
	 {
		
		/* ----------------------------------------------------------------
		 * ΡľΥƥȥΡɤ롣
		 */
		function deleteTextNode( &$xmlNode )
		{
			foreach( $xmlNode->child_nodes() as $xmlNodeChild )
			{
				if ( $xmlNodeChild->node_type() == XML_TEXT_NODE )
				{
					$xmlNodeChild->unlink_node();
				}
			}
		}
	}
	
	/* --------------------------------------------------------------------
	 * ϥåʥƥкѥ桼ƥƥ
	 * 
	 */		
	class InputValidater
	{
		function IsEntryId( $entryID )
		{
			return preg_match( '/^[^.\/][^\/]*$/', $entryID );
			//return ereg( '^[^./][^/]*$', $entryID );
		}
		
		function IsEntryName( $entryName )
		{
			return preg_match( '/^[^.\/][^\/]*$/', $entryName );
			//return ereg( '^[^./][^/]*$', $entryName );
		}
		
		function IsSchemaName( $schemaName )
		{
			return preg_match( '/^[^.\/][^\/]*$/', $schemaName );
			//return ereg( '^[^./][^/]*$', $schemaName );
		}

		function IsDesignName( $designName )
		{
			return preg_match( '/^[^.\/][^\/]*$/', $designName );
			//return ereg( '^[^./][^/]*$', $designName );
		}
		
		function IsAttachedFileId( $fileid )
		{
			return preg_match( '/^[^.\/][^\/]*$/', $fileid );
			//return ereg( '^[^./][^/]*$', $fileid );
		}
	}
	
	/* -----------------------------------------------------------
	 * [̴ؿ]
	 * ե̾ĥҤФ
	 */
	function getfileext( $filename )
	{
		// '.'ǶڤäưֺǸΥȡФС줬ĥҤΤϤ
		$tokens = explode( '.', $filename );
		return array_pop( $tokens );
	}
	
	function gettmpfileext( $filename )
	{
		// '.'ǶڤäưֺǸΥȡФС줬ĥҤΤϤ
		// tmpեξϡxxx.xxx.jpg.tmp Τ褦ˤʤäƤΤǡǸ夫飲ܤ֤
		$tokens = explode( '.', $filename );
		array_pop( $tokens );
		return array_pop( $tokens );
	}
	
	
	/* ------------------------------------------------------------------
	 * SiteConfig饹
	 */
	$gEntryConfigArr = array();	// CMSEntryConfig饹ΥåѥХѿSiteConfig롣
	$gOutputConfig = null; 	// CMSOutputConfig饹ΥåѥХѿSiteConfig롣
	class CMSSiteConfig
	{
	 	function CMSSiteConfig()
		{
			global $gEntryConfigArr;
			if ( empty( $gEntryConfigArr ) )
			{
				$this->loadFromFile();
			}
		}
		
		function loadFromFile()
		{
			global $gEntryConfigArr;
			global $gOutputConfig;
			
			// å
			$gEntryConfigArr = array();
			
			// Site.Configꤵ줿ȥ롣
			$xmlDocSite = domxml_open_file( App::getSiteConfigFilePath() );
			
			// XMLɤ߹ߤ
			if ( empty( $xmlDocSite ) )
			{
				cmsd_abort_proc( App::getSiteConfigFilePath() . " ɤ߹ߤ˼Ԥޤե뤬XMLǤϤʤǽޤ" );
			}
			
			$xpath = $xmlDocSite->xpath_new_context();
			
			// entry
			$xmlEntryConfigArr = $xpath->xpath_eval( "//entry" );
			foreach( cmsd_get_nodeset( $xmlEntryConfigArr ) as $xmlEntryConfig )
			{
				$entryConfig = new CMSEntryConfig( $xmlEntryConfig );
				$gEntryConfigArr[ $entryConfig->entryName ] = $entryConfig;
			}
			
			// encoding
			$xmlOutputConfigArr = $xpath->xpath_eval("//output" );
			if ( count( cmsd_get_nodeset( $xmlOutputConfigArr ) ) > 0 )
			{
				$gOutputConfig = new CMSOutputConfig( $xmlOutputConfigArr->nodeset[0] );
			}
			else
			{
				$gOutputConfig = new CMSOutputConfig();
			}
			
		}
		
		function &getEntryConfig( $entryName )
		{
			global $gEntryConfigArr;
			return $gEntryConfigArr[ $entryName ];
		}
		
		function &getOutputConfig()
		{
			global $gOutputConfig;
			return $gOutputConfig;
		
		}
	 
	 }
	 
	 // ֡ꥢʸ'True'|'False'ˤѡ롣
	 function parseBoolean( $strValue, $default = false )
	 {
	 	$value = $default;
	 
	 	if ( strcasecmp( $strValue, 'TRUE' ) == 0 )
		{
			$value = true;
		}
		elseif ( strcasecmp( $strValue, 'FALSE' ) == 0 )
		{
			$value = false;
		}
		
		return $value;
	 
	 }
	 
	 // եʸͤʵդ
	 function parseString( $strValue, $default = '' )
	 {
	 	$value = $default;
	 	
		if ( strlen( $strValue ) > 0 )
		{
			$value = $strValue;
		}
	 	
		return $value;
	 }
	 
	 function parseNumeric( $strValue, $default = 0 )
	 {
	 	$value = $default;
		
		if ( is_numeric( $strValue) )
		{
			$value = $strValue;
		}
		
		return $value;
	 }
	 
	 // CMSDʸ󥳡ǥꥯ饹
	 class CMSOutputConfig
	 {
	 	var $encoding = 'EUC-JP';			// ֥饦֤ʸ
		var $disableXsltEncoding = false;	// XSLT饤֥ˤʸѴ̵ˤ롣
		var $metaTagReplacement = true;		// ǽʸΥ᥿charsetưŪ˽ʸɤѴ뵡ǽONˤ롣
		var $xsltLibNo = 0;					// XSLT饤ֹ֥档
		
	 	function CMSOutputConfig( $xmlOutputConfig = null )
		{
			if ( ! is_null( $xmlOutputConfig ) )
			{
				$this->encoding = parseString( $xmlOutputConfig->get_attribute( 'encoding' ), $this->encoding );
				//$this->script = parseString( $xmlOutputConfig->get_attribute( 'script' ), $this->script );
				$this->disableXsltEncoding = parseBoolean( $xmlOutputConfig->get_attribute( 'disable-xslt-encoding' ), false );
				$this->metaTagReplacement = parseBoolean( $xmlOutputConfig->get_attribute( 'meta-tag-replacement' ), true );
				$this->xsltLibNo = parseNumeric( $xmlOutputConfig->get_attribute( 'xslt-libno' ), 0 );
			}
		}

		
		function getEncoding()
		{
			return $this->encoding;
		}
		
		function setEncoding( $newValue )
		{
			$this->encoding = $newValue;
		}
		
		function getDisableXsltEncoding()
		{
			return $this->disableXsltEncoding;
		}
		
		function setDisableXsltEncoding( $newValue )
		{
			$this->disableXsltEncoding = $newValue;
		}
		
		function getMetaTagReplacement()
		{
			return $this->metaTagReplacement;
		}
		
		function setMetaTagReplacement( $newValue )
		{
			$this->metaTagReplacement = $newValue;
		}
		
		function getXsltLibNo()
		{
			return $this->xsltLibNo;
		}
		
		function setXsltLibNo( $newValue )
		{
			$this->xsltLibNo = $newValue;
		}
		
	 }
	 
	 // CMSDȥ饹
	 class CMSEntryConfig
	 {
	 	var $entryName;			// ȥե̾
		var $entryType;			// ȥ꥿סά"entry"
		var $schemaName;		// ̾
		var $caption;			// Фʥץ
		var $entryPageUrl;		// ȥ꣱ɽURLХѥ
		var $listPageUrl;		// ȥɽURLХѥ
		var $publishControl;	// ˡ
		var $imageCacheList = array();	// åꥹ
		var $permitList = array();		// ¾ꥹ
		
	 	function CMSEntryConfig( $xmlEntryConfig )
		{
			$this->entryName = $xmlEntryConfig->get_attribute( 'name' );
			$this->entryType = $xmlEntryConfig->get_attribute( 'type' );
			$this->schemaName = $xmlEntryConfig->get_attribute( 'schema' );
			$this->caption = file2code( $xmlEntryConfig->get_attribute( 'caption' ) );
			$this->entryPageUrl = $xmlEntryConfig->get_attribute( 'entrypageurl' );
			$this->listPageUrl = $xmlEntryConfig->get_attribute( 'listpageurl' );
			$this->publishControl = $xmlEntryConfig->get_attribute( 'publishcontrol' );
			
			// å
			
			// name°
			if ( empty( $this->entryName ) )
			{
				cmsd_abort_proc( "site.config.xmlΥȥname°̵򤬻ꤵƤޤ" );
			}
			
			// type°"separator"ξϡѥ졼ʤΤǰʲΥåԤʤ
			if ( $this->entryType != 'separator' )
			{
			
				if ( strstr( $this->entryName, ' ' ) !== false )
				{
					cmsd_abort_proc( "site.config.xmlΥȥˤơname°˶򤬻ѤƤޤ" );
				}
				
				// schema°
				if ( empty( $this->schemaName ) )
				{
					cmsd_abort_proc( "site.config.xmlΥȥschema°̵򤬻ꤵƤޤ" );
				}
	
				if ( strstr( $this->schemaName, ' ' ) !== false )
				{
					cmsd_abort_proc( "site.config.xmlΥȥˤơschema°˶򤬻ѤƤޤ" );
				}
				
				// caption°
				if ( empty( $this->caption ) )
				{
					cmsd_abort_proc( "site.config.xmlΥȥcaption°̵򤬻ꤵƤޤ" );
				}
				
				// publish
				if ( empty( $this->publishControl ) )
				{
					$this->publishControl = 'on-off';	// ά"on-off"
				}
				else if ( $this->publishControl != 'none' and $this->publishControl != 'on-off' and $this->publishControl != 'full' )
				{
					cmsd_abort_proc( "site.config.xmlΥȥˤơpublish°'{$this->publish}'ꤵƤޤ" );
				}
			}
			
			// ImageCacheɤ߹
			$xmlImageCacheList = $xmlEntryConfig->get_elements_by_tagname( 'imagecache' );
			foreach ( $xmlImageCacheList as $xmlImageCache )
			{
				$this->imageCacheList[] = new CMSEntryConfigImageCache( $xmlImageCache );
			}
			
			//print "EntryConfig '{$this->entryName}' is loaded with publish = '{$this->publish}'<br />";
			
			// ImageCacheɤ߹
			$xmlPermitList = $xmlEntryConfig->get_elements_by_tagname( 'permit' );
			foreach ( $xmlPermitList as $xmlPermit )
			{
				$this->permitList[] = new CMSEntryConfigPermit( $xmlPermit );
			}
			
		}
		
		
		function canShowInContentList( $user )
		{
			$able = false; 	// 
			
			if ( count( $this->permitList ) <= 0 )
			{
				// permitǤĤ̵ä硢ƤοͤФƤθ¤Ϳ롣ʲλͤȤΰ١
				$able = true;
			}
			else
			{
				// mineФlist
				$ableMine = $this->canAction( $user, 'list', 'mine' );
				// othersФlist
				$ableOthers = $this->canAction( $user, 'list', 'others' );
				
				// ɤ餫trueʤ顢ƥİɽ
				$able = ( $ableMine || $ableOthers );
			
			}
			
			return $able;
		}
		
		
		function canShowInContentList2( $user )
		{
			$permission = 'none'; 	// 
			
			if ( count( $this->permitList ) <= 0 )
			{
				// permitǤĤ̵ä硢ƤοͤФƤθ¤Ϳ롣ʲλͤȤΰ١
				$permission = 'permit';
			}
			else
			{
				// Ƥθ¾󤫤飱ģĥѡߥånone < permit < deny νǾ񤭤롣㡧permitnoneǤϾ񤭤Ǥʤ
				foreach ( $this->permitList as $permit )
				{
					// Ƹ¾󤫤ѡߥå롣
					$permission_temp = $permit->getPermissionShowInContentList( $user );
					
					//print "permission = " . $permission_temp . "   ";
					
					switch ( $permission_temp )
					{
						case 'none' :
							// ⤷ʤ
							break;
						
						case 'permit' :
							// ߤnoneξΤߡ񤭤롣
							if ( $permission === 'none' )
							{
								$permission = $permission_temp;
							}
							break;
						
						case 'deny' :
							// Ū˾񤭤롣
							$permission = $permission_temp;
							break;
					}
					
					// denyä硢ʾͳʤΤǥ롼פλ롣
					if ( $permission === 'deny' )
					{
						break;
					}
				}
			
			}
			
			return ( $permission === 'permit' );
			
		}
		
		// ꤷactionФ븢¤äƤ뤫
		// $actionName : list, add, delete, edit, publish
		// $target : 'mine' or 'others'
		// Result: ǽ:true  Բǽ:false
		function canAction( $user, $actionName, $target )
		{
			$permission = 'none'; 	// 
			
			if ( count( $this->permitList ) <= 0 )
			{
				// permitǤĤ̵ä硢ƤοͤФƤθ¤Ϳ롣ʲλͤȤΰ١
				$permission = 'permit';
			}
			else
			{
				// Ƥθ¾󤫤飱ģĥѡߥånone < permit < deny νǾ񤭤롣㡧permitnoneǤϾ񤭤Ǥʤ
				foreach ( $this->permitList as $permit )
				{
					// Ƹ¾󤫤ѡߥå롣
					$permission_temp = $permit->getPermission( $user, $actionName, $target );
					
					switch ( $permission_temp )
					{
						case 'none' :
							// ⤷ʤ
							break;
						
						case 'permit' :
							// ߤnoneξΤߡ񤭤롣
							if ( $permission === 'none' )
							{
								$permission = $permission_temp;
							}
							break;
						
						case 'deny' :
							// Ū˾񤭤롣
							$permission = $permission_temp;
							break;
					}
					
					// denyä硢ʾͳʤΤǥ롼פλ롣
					if ( $permission === 'deny' )
					{
						break;
					}
				}
			
			}
			
			return ( $permission === 'permit' );
			
		}
		
	 }
	 
	 class CMSEntryConfigImageCache
	 {
		var $width = 0;
		var $height = 0;
		
		function CMSEntryConfigImageCache( $xmlEntryConfigImageCache )
		{
			$this->width = parseString( $xmlEntryConfigImageCache->get_attribute('width') );
			$this->height = parseString( $xmlEntryConfigImageCache->get_attribute('height') );
			
			if ( empty( $this->width ) )
			{
				$this->width = 0;
			}
			
			if ( empty( $this->height ) )
			{
				$this->height = 0;
			}
			
		}
		
		function isTarget( $width, $height )
		{
			$isTarget = false;
			
			$matchWidth = false;
			$matchHeight = false;
			
			if ( $this->width === 'all' )	//  ͤʸӤ硢ʸ󤬿ͤȤɾ١ñ"=="Ӥ0ξ˰פƤޤ
			{
				$matchWidth = true;	// Ƥξ
			}
			else if ( empty( $this->width ) ) // 0 ϾάƤ
			{
				$matchWidth = empty( $width );	// 0 ϾάƤ
			}
			else
			{
				$matchWidth = ( $this->width === $width );	// ͤפ
			}
			
			
			if ( $this->height === 'all' )
			{
				$matchHeight = true;	// Ƥξ
			}
			else if ( empty( $this->height ) ) // 0 ϾάƤ
			{
				$matchHeight = empty( $height );	// 0 ϾάƤ
			}
			else
			{
				$matchHeight = ( $this->height === $height );	// ͤפ
			}
			
			$isTarget = ( $matchWidth and $matchHeight );
			
			/*
			if ( empty( $this->width ) and empty( $this->height ) )
			{
				// ξʤΥå̵
				
			}
			elseif ( empty( $this->width ) )
			{
				$isTarget = ( empty( $width ) and $this->height == $height );
			}
			elseif ( empty( $this->height ) )
			{
				$isTarget = ( empty( $height ) and $this->width == $width );
			}
			elseif ( $this->width == 'all' and $this->height == 'all' )
			{
				$isTarget = true;
			}
			elseif ( $this->width == 'all' )
			{
				$isTarget = ( $this->height == $height );
			}
			elseif ( $this->height == 'all' )
			{
				$isTarget = ( $this->width == $width );
			}
			else
			{
				$isTarget = ( $this->width == $width and $this->height == $height );
			}
			*/
			
			return $isTarget;
			
		}
	 }
	 
	 /* ---------------------------------------------------------------
	  * Permit饹[2008.04 桼]
	  * 
	  * 
	  */
	 class CMSEntryConfigPermit
	 {
	 	var $users = array();
	 
	 	var $mine = array();		// ʬȥФѡߥå㡧'list,read,add,edit'
		var $others = array();	// ¾ͤȥФѡߥå
		
		var $maxrow = 0;	// ̤
		
		function CMSEntryConfigPermit( $xmlPermit )
		{
			// mineothersξάͤ'all'
			$mine = parseString( $xmlPermit->get_attribute( 'mine' ), 'all' );
			$others = parseString( $xmlPermit->get_attribute( 'others' ), 'all' );
			
			$this->mine = explode( ',', $mine );
			$this->others = explode( ',', $others );
			
			// 'deny'ꤵƤ顢ʳ̵denyͥ褵
			if ( in_array( 'deny', $this->mine ) ) $this->mine = array( 'deny' );
			if ( in_array( 'deny', $this->others) ) $this->others = array( 'deny' );
			
			// 'none'ꤵƤ顢ʳ̵allnoneͥ褹
			if ( in_array( 'none', $this->mine ) ) $this->mine = array( 'none' );
			if ( in_array( 'none', $this->others) ) $this->others = array( 'none' );
			
			// 'all'ꤵƤ顢ʳ̵
			if ( in_array( 'all', $this->mine ) ) $this->mine = array( 'all' );
			if ( in_array( 'all', $this->others) ) $this->others = array( 'all' );
			
			// оݥ桼ɤ߹
			$users = parseString( $xmlPermit->get_attribute( 'users' ) );
			
			if ( strlen( $users ) <= 0 )
			{
				cmsd_abort_proc( 'permitǤˤusers°1İʾΥ桼̾λ꤬ɬפǤ' );
			}
			
			// ޶ڤΥ桼IDꥹȤʬ򤷤ˤ롣
			$this->users = explode( ',', $users );
			
		}
		
		function isTargetUser( $userId )
		{
			// usersuserId¸ߤtrue֤(publisher)ޤˤϡ̵true֤
			return in_array( '(publisher)', $this->users ) || in_array( $userId, $this->users );
		}
		
		function GetPermissionShowInContentList( $user )
		{
			$pemission = 'none';	// ͡ʥߡ
			
			// mineФlist
			$permissionMine = $this->GetPermission( $user, 'list', 'mine' );
			// othersФlist
			$permissionOthers = $this->GetPermission( $user, 'list', 'others' );
			
			// ɤdenyʤ顢ƥİؤɽdeny
			if ( $permissionMine === 'deny' && $permissionOthers === 'deny' )
			{
				$permission = 'deny';
			}
			// ɤ餫permitʤ顢ƥİؤɽpermit
			elseif ( $permissionMine === 'permit' || $permissionOthers === 'permit' )
			{
				$permission = 'permit';
			}
			// ʳnone
			else
			{
				$permission = 'none';
			}
			
			return $permission;
		
		}

		function innerGetPermission( $actionName, $permittedActions )
		{
		
			$permission = 'none'; // ͤϥߡ
			
			if ( in_array( 'all', $permittedActions ) )
			{
				$permission = 'permit';
			}
			elseif ( in_array( 'none', $permittedActions ) )
			{
				$permission = 'none';
			}
			elseif ( in_array( 'deny', $permittedActions ) )
			{
				$permission = 'deny';
			}
			else
			{
				// allǤnoneǤʤ硣
				switch ( $actionName )
				{
					case 'list' :
						// -listޤޤƤʳ permit
						if ( in_array( '-list', $permittedActions ) )
						{
							$permission = 'deny';
						}
						else
						{
							$permission = 'permit';
						}
						
						break;
					
					case 'read' :	// ϼʤ
					
						break;
					
					case 'publish' : // ϼʤ
						break;
					
					case 'edit' :
					case 'add' :
					case 'delete' :
						// Υ󤬴ޤޤƤ permit-󤬴ޤޤƤСdenyʳʤ none
						if ( in_array( $actionName, $permittedActions ) )
						{
							$permission = 'permit';
						}
						elseif ( in_array( '-'.$actionName, $permittedActions ) )
						{
							$permission = 'deny';
						}
						else
						{
							$permission = 'none';
						}
						
						break;
				
				}
			}
			
			return $permission;
		}
		
		// ѡߥåμ
		// $target : 'mine' or 'others'
		// 'permit","none","deny" Τ줫֤
		function getPermission( $user, $actionName, $target )
		{
			$permission = "none"; // ͡ʥߡ
			
			if ( $user->isAdministrator() )
			{
				// AdministratorʤС̵permit֤
				$permission = 'permit';
			}
			elseif ( ! $this->isTargetUser( $user->getUserId() ) )
			{
				// Permitоݥ桼Ǥʤnone֤
				$permission = 'none';
			}
			else
			{
				// 桼AdministratorʳǡPermitоݥ桼ξν
				switch ( $target )
				{
					case 'mine' : 
						// mineФѡߥå
						$permission = $this->innerGetPermission( $actionName, $this->mine );
						break;
					
					case 'others' :
						// othersФѡߥå
						$permission = $this->innerGetPermission( $actionName, $this->others );
						break;
					
				}
			}
			
			return $permission;
		
		}
		
		
		
		
		
		function CMSEntryConfigImageCache( $xmlEntryConfigImageCache )
		{
			$this->width = parseString( $xmlEntryConfigImageCache->get_attribute('width') );
			$this->height = parseString( $xmlEntryConfigImageCache->get_attribute('height') );
			
			if ( empty( $this->width ) )
			{
				$this->width = 0;
			}
			
			if ( empty( $this->height ) )
			{
				$this->height = 0;
			}
			
		}
		
		function isTarget( $width, $height )
		{
			$isTarget = false;
			
			$matchWidth = false;
			$matchHeight = false;
			
			if ( $this->width === 'all' )	//  ͤʸӤ硢ʸ󤬿ͤȤɾ١ñ"=="Ӥ0ξ˰פƤޤ
			{
				$matchWidth = true;	// Ƥξ
			}
			else if ( empty( $this->width ) ) // 0 ϾάƤ
			{
				$matchWidth = empty( $width );	// 0 ϾάƤ
			}
			else
			{
				$matchWidth = ( $this->width === $width );	// ͤפ
			}
			
			
			if ( $this->height === 'all' )
			{
				$matchHeight = true;	// Ƥξ
			}
			else if ( empty( $this->height ) ) // 0 ϾάƤ
			{
				$matchHeight = empty( $height );	// 0 ϾάƤ
			}
			else
			{
				$matchHeight = ( $this->height === $height );	// ͤפ
			}
			
			$isTarget = ( $matchWidth and $matchHeight );
			
			/*
			if ( empty( $this->width ) and empty( $this->height ) )
			{
				// ξʤΥå̵
				
			}
			elseif ( empty( $this->width ) )
			{
				$isTarget = ( empty( $width ) and $this->height == $height );
			}
			elseif ( empty( $this->height ) )
			{
				$isTarget = ( empty( $height ) and $this->width == $width );
			}
			elseif ( $this->width == 'all' and $this->height == 'all' )
			{
				$isTarget = true;
			}
			elseif ( $this->width == 'all' )
			{
				$isTarget = ( $this->height == $height );
			}
			elseif ( $this->height == 'all' )
			{
				$isTarget = ( $this->width == $width );
			}
			else
			{
				$isTarget = ( $this->width == $width and $this->height == $height );
			}
			*/
			
			return $isTarget;
			
		}
	}
	 
	 
	/* --------------------------------------------------------------------
	 * к饹
	 * ѥȡԤƥ饹᥽åɡ
	 */	
	class ReloadToken
	{
		
		function getCurrentToken()
		{
			return $_SESSION[ ReloadToken::getTokenKey() ];		
		}
		
		function getRequestToken()
		{
			$token = $_REQUEST[ ReloadToken::getTokenKey() ];
			
			return $token;
						
		}
		
		function isReload()
		{
		
			if ( ReloadToken::getCurrentToken() === ReloadToken::getRequestToken() )
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		
		function newToken()
		{
			$newToken = md5(uniqid(rand(),1));
			
			$_SESSION[ ReloadToken::getTokenKey() ] = $newToken;
			
			return $newToken;
		}

		function embed()
		{
			$token = ReloadToken::getCurrentToken();
			
			return '<input type="hidden" name="' . ReloadToken::getTokenKey() . '" value="' . $token . '" />' . "\n";
		}
		
		function embedToXmlDoc( &$xmlDoc )
		{
			$token = ReloadToken::getCurrentToken();
			
			$xmlToken = $xmlDoc->create_element('reloadtoken');
			$xmlToken->set_attribute( 'key', ReloadToken::getTokenKey() );
			$xmlToken->set_attribute( 'value', $token );
			
			$xmlRoot = $xmlDoc->document_element();
			$xmlRoot->append_child( $xmlToken );
		}
		
		function getTokenKey()
		{
			// "."ޤޤȥ餷
			return 'jp_al-design_ReloadToken';
		}	
		
	}
	
?>