<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    //require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );

    /* --------------------------------------------------------------------
     * ȥإåϹܥ饹header
     * 
     */ 
    class HeaderEntryItem extends BaseEntryItem
    {
		var $publishControl;	// ˡ
    	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 */
    	function HeaderEntryItem( $entryName, $entryId, $publishControl )
    	{
    		// ١󥹥ȥ饯ƤӽФʤ
    		//parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
			
            // ١饹Υץѥƥ
    		$this->dataName = "header"; //$xmlSchemaData->get_attribute('name');
    		$this->dataType = "header"; //$xmlSchemaData->get_attribute('type');
    		$this->dataCaption = "꡿"; //file2code( $xmlSchemaData->get_attribute('caption') );
			
			$this->entryName = $entryName;
			$this->entryId = $entryId;
			
			$this->publishControl = $publishControl;
			
       	}
		
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			//$newNode = parent::createNew( $xmlDocParentEntry );
    		
			cmsd_abort_proc( 'Υ᥽åɤϸƤӽФԲ' );
			
    		return $newNode;
    	}
		
		/* ----------------------------------------------------------------
		 * ͿФ뽵֤
		 * return : ɽ3ʸʸ
		 */
		function getWeekday( $year, $month, $day, $hour, $minute, $second )
		{
			$arrWeekday = array( 'sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat' );
			$iWeekday = date('w', mktime( $hour, $minute, $second, $month, $day, $year ) );
			$sWeekday = $arrWeekday[ $iWeekday ];
			
			return $sWeekday;
		}
		
		/* ----------------------------------------------------------------
		 * Ϳ򣱤Ĥʸ˷礹롣
		 * return : ɽ³ʸ
		 */
		function getDateString( $dataType, $year, $month, $day, $hour, $minute, $second )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", $year );
			$sMonth = sprintf( "%02d", $month );
			$sDay = sprintf( "%02d", $day );
			$sHour = sprintf( "%02d", $hour );
			$sMinute = sprintf( "%02d", $minute );
			$sSecond = sprintf( "%02d", $second );

			switch( $dataType )
			{
				case 'condition' :
					$strDate = $sYear . $sMonth . $sDay . $sHour . $sMinute;
					break;
				
				case 'datetime' :
					$strDate = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
					break;
				
				case 'date' :
					$strDate = $sYear . '-' . $sMonth . '-' . $sDay;
					break;
				
				case 'time' :
					$strDate = $sHour . ':' . $sMinute;
					break;
				
				case 'year' :
					$strDate = $sYear;
					break;
				
				case 'month' :
					$strDate = $sYear . '-' . $sMonth;
					break;
				
			}
			
			return $strDate;
		}
		
		/* ----------------------------------------------------------------
		 * ʸʬ򤹤롣
		 * return : ͤ
		 */
		function parseDateString( $strDate )
		{
			$strDate = str_replace( array( ':',' ','-' ), array( '','','' ), $strDate );
			
			// YYYYMMDDHHmm
			$sYear = substr( $strDate, 0, 4 );
			$sMonth = substr( $strDate, 4, 2 );
			$sDay = substr( $strDate, 6, 2 );
			$sHour = substr( $strDate, 8, 2 );
			$sMinute = substr( $strDate, 10, 2 );
			$sSecond = substr( $strDate, 12, 2 );

			/*
			// YYYY-MM-DD HH:mm
			$sYear = substr( $strDate, 0, 4 );
			$sMonth = substr( $strDate, 5, 2 );
			$sDay = substr( $strDate, 8, 2 );
			$sHour = substr( $strDate, 11, 2 );
			$sMinute = substr( $strDate, 14, 2 );
			$sSecond = substr( $strDate, 17, 2 );
			*/
			
			return array( $sYear, $sMonth, $sDay, $sHour, $sMinute, $sSecond );
		
		}
		
		/* ----------------------------------------------------------------
		 * POSTꥯȤ롣
		 * return : 󡣥顼ξFalse֤
		 */
		function getRequestYMDHM( $dataType, $dataName )
		{
			// year
			if ( in_array( $dataType, array( 'entrydate', 'datetime', 'date', 'year', 'month' ) ) )
			{
				$year = $_POST[ $dataName . '_year' ];
				
				// ϰϥå
				$iYear = intval( $year ); 
				if ( $iYear < 0 or $iYear > 9999 )
				{
					$this->errorMessage = sprintf( "%s(ǯ)  0-9999ϰϤĶޤ", $this->dataCaption );
					return false;
				}
				
			}
			
			// month
			if ( in_array( $dataType, array( 'entrydate', 'datetime', 'date', 'month' ) ) )
			{
				$month = $_POST[ $dataName . '_month' ];
				
				// ϰϥå
				$iMonth = intval( $month ); 
				if ( $iMonth < 0 or $iMonth > 12 )
				{
					$this->errorMessage = sprintf( "%s()  0-12ϰϤĶޤ", $this->dataCaption );
					return false;
				}
				
			}

			// day
			if ( in_array( $dataType, array( 'entrydate', 'datetime', 'date' ) ) )
			{
				$day = $_POST[ $dataName . '_day' ];
				
				// ϰϥå
				$iDay = intval( $day ); 
				if ( $iDay < 0 or $iDay > 31 )
				{
					$this->errorMessage = sprintf( "%s()  0-31ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}
			
			// hour
			if ( in_array( $dataType, array( 'entrydate', 'datetime', 'time' ) ) )
			{
				$hour = $_POST[ $dataName . '_hour' ];
				
				// ϰϥå
				$iHour = intval( $hour ); 
				if ( $iHour < 0 or $iHour > 23 )
				{
					$this->errorMessage = sprintf( "%s()  0-24ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}

			// minute
			if ( in_array( $dataType, array( 'entrydate', 'datetime', 'time' ) ) )
			{
				$minute = $_POST[ $dataName . '_minute' ];
				
				// ϰϥå
				$iMinute = intval( $minute ); 
				if ( $iMinute < 0 or $iMinute > 59 )
				{
					$this->errorMessage = sprintf( "%s()  0-59ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}
			
			return array( $year, $month, $day, $hour, $minute );
		
		}
		
		
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
    		// ȥXML
    		/// entryǼȤƹ롣
            $xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry );
			$xmlEntryData = $xmlEntryDataArr->nodeset[0];
			
			// ե饰ʲ̾Ǥϡץå
			$visible = getPOSTParam( 'cmsd_visible' ); //$_POST[ 'cmsd_visible' ];
			$xmlEntryData->set_attribute('visible', ( $visible ? 'False' : 'True' ) );	// ̾ǤϡץåʤΤǡͤ"False"ˤʤ롣
			
			// ϥե饰
			$startDateActive = getPOSTParam( 'cmsd_sd_active' ); //$_POST[ 'cmsd_sd_active' ];
			if ( $startDateActive )
			{
				// ϥե饰ONλϡϻ롣
				// ϻ
                $cmsd_sd_ymdhm = $this->getRequestYMDHM( 'datetime', 'cmsd_sd' );
				if ( ! $cmsd_sd_ymdhm ) 
				{
					return false;	// ƥ顼ϰʹߤν򥭥󥻥뤷return
				}
				list( $year, $month, $day, $hour, $minute ) = $cmsd_sd_ymdhm;
				$strStartDate = $this->getDateString( 'condition', $year, $month, $day, $hour, $minute, 0 );
			}
			else
			{
				// ϥե饰OFFλϡ0ꤹ롣
				$strStartDate = $this->getDateString( 'condition', 0, 0, 0, 0, 0, 0 );
			}
			
			// λե饰
			$endDateActive = getPOSTParam( 'cmsd_ed_active' ); //$_POST[ 'cmsd_ed_active' ];
			if ( $endDateActive )
			{
				// λե饰ONλϡλ롣
				// λ
                $cmsd_ed_ymdhm = $this->getRequestYMDHM( 'datetime', 'cmsd_ed' );
				if ( ! $cmsd_ed_ymdhm )
				{
					return false;	// ƥ顼ϰʹߤν򥭥󥻥뤷return
				}
				list( $year, $month, $day, $hour, $minute ) = $cmsd_ed_ymdhm;
				$strEndDate = $this->getDateString( 'condition', $year, $month, $day, $hour, $minute, 0 );
			}
			else
			{
				// λե饰OFFλϡ9ꤹ롣
				$strEndDate = $this->getDateString( 'condition', 9999, 99, 99, 99, 99, 0 );
			}
			
			// ϡλ֥å
			if ( $strStartDate > $strEndDate )
			{
				$this->errorMessage = 'λ򳫻ϻ᤯ꤹ뤳ȤϽޤ';
				return false;
			}
			else
			{
				$xmlEntryData->set_attribute( 'enddate', $strEndDate );
				$xmlEntryData->set_attribute( 'startdate', $strStartDate );
			}
			
			// ԥå [2008.04 桼]
			$author = getPOSTParam( 'cmsd_author' );
			$authedUser = LoginManager::GetAuthedUser();
			
			if ( strlen( $author ) <= 0 ) 
			{
				// ǡʤѹʤʲ⤷ʤˢAdminʳΥ桼ǤϡԽ̤κϸˤʤäƤꡢ⤽formܤˤʤäƤʤ
			}
			elseif ( ! SiteUser::UserExists( $author ) )
			{
				// 桼ꥹȤ¸ߤʤХ顼
				$this->errorMessage = '̾ˡ¸ߤʤ桼IDꤵƤޤ';
				return false;
			}
			elseif ( ! ( $authedUser->isAdministrator() || $autheduser->getUserId() == $author ) )
			{
				// 桼Admin桼̾Ⱥ̾ƱʤOKʳϡʺIDץ顼
			}
			else
			{
				// å̤äΤͤꤹ롣
				$xmlEntryData->set_attribute( 'author', $author );
			}
			
			return true;
			
    	}
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
			// ߤγؤentryǤˡ
			$xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry );
   			$xmlEntryData = $xmlEntryDataArr->nodeset[0];
			
			// ǡμФ
			// ե饰
			$visible = ( $xmlEntryData->get_attribute('visible') == 'False' ? 'False' : 'True' );	// ե饰̵äΥǡȤθߴΰ١"False"Ӥ롣
			$xmlOutputEntryData->set_attribute('visible', $visible );
			
			// 
			$startDate = $xmlEntryData->get_attribute('startdate');
			if ( $startDate == $this->getDateString('condition', 0, 0, 0, 0, 0, 0 ) or strlen( $startDate ) == 0 )
			{
				$xmlOutputEntryData->set_attribute('sd_active', 'False' );
				$xmlOutputEntryData->set_attribute('sd_year', sprintf( "%04d", date('Y') ) );
				$xmlOutputEntryData->set_attribute('sd_month',sprintf( "%02d", date('m') ) );
				$xmlOutputEntryData->set_attribute('sd_day', sprintf( "%02d", date('d') ) );
				$xmlOutputEntryData->set_attribute('sd_hour', sprintf( "%02d", date('H') ) );
				$xmlOutputEntryData->set_attribute('sd_minute', sprintf( "%02d", date('i') ) );
			}
			else
			{
				$xmlOutputEntryData->set_attribute('sd_active', 'True' );
				list( $year, $month, $day, $hour, $minute, $second ) = $this->parseDateString( $startDate );
				$xmlOutputEntryData->set_attribute('sd_year', $year );
				$xmlOutputEntryData->set_attribute('sd_month', $month );
				$xmlOutputEntryData->set_attribute('sd_day', $day );
				$xmlOutputEntryData->set_attribute('sd_hour', $hour );
				$xmlOutputEntryData->set_attribute('sd_minute', $minute );
			}
			
			// λ
			$endDate = $xmlEntryData->get_attribute('enddate');
			if ( $endDate == $this->getDateString( 'condition', 9999, 99, 99, 99, 99, 0 ) or strlen( $endDate ) == 0 )
			{
				$xmlOutputEntryData->set_attribute('ed_active', 'False' );
				$xmlOutputEntryData->set_attribute('ed_year', sprintf( "%04d", date('Y') ) );
				$xmlOutputEntryData->set_attribute('ed_month',sprintf( "%02d", date('m') ) );
				$xmlOutputEntryData->set_attribute('ed_day', sprintf( "%02d", date('d') ) );
				$xmlOutputEntryData->set_attribute('ed_hour', sprintf( "%02d", date('H') ) );
				$xmlOutputEntryData->set_attribute('ed_minute', sprintf( "%02d", date('i') ) );
			}
			else
			{
				$xmlOutputEntryData->set_attribute('ed_active', 'True' );
				list( $year, $month, $day, $hour, $minute, $second ) = $this->parseDateString( $endDate );
				$xmlOutputEntryData->set_attribute('ed_year', $year );
				$xmlOutputEntryData->set_attribute('ed_month', $month );
				$xmlOutputEntryData->set_attribute('ed_day', $day );
				$xmlOutputEntryData->set_attribute('ed_hour', $hour );
				$xmlOutputEntryData->set_attribute('ed_minute', $minute );
			}
			
			// ˡ
			$xmlOutputEntryData->set_attribute('publishcontrol', $this->publishControl );
			
			// 桼ID [2008.04 桼]
			$userId = $xmlEntryData->get_attribute( 'author' );
			$xmlOutputEntryData->set_attribute( 'userid', $userId );
    		
    	}
		
    
    }

?>