<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    //require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );

    /* --------------------------------------------------------------------
     * Ϲܥ饹
     * 
     */ 
    class IntEntryItem extends BaseEntryItem
    {
    	var $max = 0;
    	var $min = 0;
		var $size = 4;
    	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function IntEntryItem( $xmlSchemaData, $entryName, $entryId  )
    	{
    		// ١󥹥ȥ饯θƤӽФ
    		parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
    		
    		$this->max = (int)( $xmlSchemaData->get_attribute('max') ); 
    		$this->min = (int)( $xmlSchemaData->get_attribute('min') );
			
			$size = (int)( $xmlSchemaData->get_attribute('size') );
			if ( $size <= 0 )
			{
				$size = 4;	// 
			}
			$this->size = $size;
    		
    	}
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			$newNode = parent::createNew( $xmlDocParentEntry );
    		$newNode->set_content( '0' );
    		
    		return $newNode;
    	}
    	
    	
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
    		// ȥXML
            $xmlEntryDataList = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataList->nodeset[0];
			
			/*
			if ( count($xmlEntryDataList) > 0 )
			{
	            $xmlEntryData = $xmlEntryDataList->nodeset[0];
			}
			else
			{
				// Υǡܤ¸ߤʤ硢ޤƱ١Ρɤ롣
				$xmlParentDataArr = $xpathEntry->xpath_eval( $currentEntry );
				$xmlParentData = $xmlParentDataArr->nodeset[0];
				$xmlDocEntry = $xmlParentData->owner_document();
				$xmlEntryData = $this->createNew( $xmlDocEntry );
				$xmlParentData->append_child( $xmlEntryData );
			}
			*/

		    // "name"°бPOST¸ߤСȥȿǤ롣
		    if ( isset( $_POST[ $this->dataName ] ) )
		    {
	            $datavalue = $_POST[ $this->dataName ];
				
				// ͥå
				if ( ! is_numeric( $datavalue ) )
				{
					$this->errorMessage = sprintf( "%s ˿ͰʳϤޤ", $this->dataCaption );
					return false;
				}
				
				// ϰϥå
				if ( 
				    ( $datavalue < $this->min ) or 
				    ( ( $datavalue > $this->max ) and ! empty( $this->max ) ) // max0ʤС¥åϤʤ
				)
				{
					$this->errorMessage = sprintf( "%s  %d  %d ϰϤĶޤ", $this->dataCaption, $this->min, $this->max );
					return false;
				}
				
                // ޤƥȥΡɤʺʤȡset_contentǤϥƥȥΡɤˡ
                $xmlEntryData = $xmlEntryDataList->nodeset[0];
                EntryUtil::deleteTextNode( $xmlEntryData );
        		
    	        // ƥȥΡɤ˿ͤset롣
	    	    $xmlEntryData->set_content( fileconv( $datavalue ) );
    	    	//print( $dataname . " = " . htmlconv( $datavalue ) . "<br>\n" );
    	    }
    	    
    	    return true;
    	
    	}
    	
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItem( $xpathEntry, $currentEntry )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
    		$value = $xmlEntryDataArray->nodeset[0]->get_content();
    		
    		$strFormHTML = '';
    		
            $strFormHTML .= '<input type="text" size="4" name="' . $this->dataName . '" value="' . $value . '" /><br>' . "\n";
    		
    		return $strFormHTML;
    	}
		

		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
    		$value = $xmlEntryDataArray->nodeset[0]->get_content();

			// ꥯȤͤСͤɽʥ顼ͤݾڤ褦ˤ
			if ( isset( $_POST[ $this->dataName ] ) )
			{
				$value = $_POST[ $this->dataName ];
			}

			$xmlOutputEntryData->set_attribute('size', $this->size );
			$xmlOutputEntryData->set_content( $value );
    	}				
    	
    }

?>